/*static char *SCCSID = "@(#)bse.h	6.8 92/03/15";*/
/****************************** Module Header ******************************\
*
* Module Name: BSE.H
*
* Copyright (c) 1987, 1992  IBM Corporation
*
*
*
* ===========================================================================
*
* The following symbols are used in this file for conditional sections.
*
*   INCL_BASE      -  ALL of OS/2 Base
*   INCL_DOS       -  OS/2 DOS Kernel
*   INCL_SUB       -  OS/2 VIO/KBD/MOU
*   INCL_DOSERRORS -  OS/2 Errors         - only included if symbol defined
*   INCL_ORDINALS  -  OS/2 Ordinals       - only included if symbol defined
*
****************************************************************************
*   CHANGE ACTIVITY:
*
*   FLAG REASON     LEVEL DATE       PGMR       COMMENTS
*   ---- ------     ----- ----       ----       --------
*  $W0   f8900      Rel2  03/14/96  T Nguyen   Initial port to Windows;
*                                              keep in common with VSAM/6
*
\***************************************************************************/

#if !defined(__WIN32__) && !defined(__WIN16__)             /* @W0A */

#ifdef __IBMC__
#pragma checkout( suspend )
   #ifndef __CHKHDR__
      #pragma checkout( suspend )
   #endif
#pragma checkout( resume )
#endif

#endif   /* #if !defined(__WIN32__)...                     @W0A */

#ifndef __BSE__
#define __BSE__

#define INCL_BASEINCLUDED

/* if INCL_BASE defined then define all the symbols */

#ifdef INCL_BASE
   #define INCL_DOS
   #define INCL_SUB
   #define INCL_DOSERRORS
#endif /* INCL_BASE */

#include <bsedos.h>       /* Base definitions */


#ifdef INCL_DOSDEVIOCTL
   #include <bsedev.h>    /* Structures and constants for DosDevIOCtl */
#endif /* INCL_DOSDEVIOCTL */

#ifdef _AIX                 /* @W0A */
  #include <bsesub.h>       /* VIO/KBD/MOU definitions */
#endif                      /* @W0A */

/* @W0A Begin ***************************************************
   Include bseerr.h or error.h only if they haven't been included.
   (We know this by checking if two ERROR messages have been defined */
#ifndef ERROR_NESTING_NOT_ALLOWED
  #ifndef ERROR_ITERATED_DATA_EXCEEDS_64k

    #if defined(__WIN32__) || defined(__WIN16__)
      #include <error.h>
    #else
      #include "bseerr.h"       /* Base error code definitions */
    #endif

  #endif
#endif
/* @W0A End *****************************************************/

#ifdef INCL_ORDINALS
#include <bseord.h>     /* ordinals */
#endif /* INCL_ORDINALS */

#endif /* __BSE__ */

#if !defined(__WIN32__) && !defined(__WIN16__)             /* @W0A */

#ifdef __IBMC__
#pragma checkout( suspend )
   #ifndef __CHKHDR__
      #pragma checkout( resume )
   #endif
#pragma checkout( resume )
#endif   /* #if !defined(_WIN32...                       @W0A */

#endif
