 /* ++                                                                */
 /*                                                                   */
 /* Copyright (c) 1996-1999 Microsoft Corporation                     */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     winfax.cpy                                                    */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     This module contains the WIN32 FAX APIs.                      */
 /*                                                                   */
 /* --                                                                */


 %dcl #FAXAPI_ char ext;
 %if #FAXAPI_ = '' %then %do;
 %#FAXAPI_ = 'Y';

 %dcl UNICODE char ext;

 %dcl TAPI_H char ext;
 %if TAPI_H = '' %then %do;
 %include tapi;
 %end;

 %dcl WINFAXAPI char ext;
 %WINFAXAPI = '';


 dcl FAXLOG_LEVEL_NONE        fixed bin(31) value(0);
 dcl FAXLOG_LEVEL_MIN         fixed bin(31) value(1);
 dcl FAXLOG_LEVEL_MED         fixed bin(31) value(2);
 dcl FAXLOG_LEVEL_MAX         fixed bin(31) value(3);

 dcl FAXLOG_CATEGORY_INIT     fixed bin(31) value(1);
 dcl FAXLOG_CATEGORY_OUTBOUND fixed bin(31) value(2);
 dcl FAXLOG_CATEGORY_INBOUND  fixed bin(31) value(3);
 dcl FAXLOG_CATEGORY_UNKNOWN  fixed bin(31) value(4);


 define structure
   1 FAX_LOG_CATEGORYA,
     2 Name     type LPCSTR, /* logging category name */
     2 Category type DWORD,  /* logging category number */
     2 Level    type DWORD;  /* logging level for the category */
 define alias PFAX_LOG_CATEGORYA handle FAX_LOG_CATEGORYA;

 define structure
   1 FAX_LOG_CATEGORYW,
     2 Name     type LPCWSTR,/* logging category name */
     2 Category type DWORD,  /* logging category number */
     2 Level    type DWORD;  /* logging level for the category */
 define alias PFAX_LOG_CATEGORYW handle FAX_LOG_CATEGORYW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_LOG_CATEGORY type  FAX_LOG_CATEGORYW;
 define alias PFAX_LOG_CATEGORY type PFAX_LOG_CATEGORYW;
 %end; %else %do;
 define alias  FAX_LOG_CATEGORY type  FAX_LOG_CATEGORYA;
 define alias PFAX_LOG_CATEGORY type PFAX_LOG_CATEGORYA;
 %end; /* UNICODE */

 define structure
   1 FAX_TIME,
     2 Hour   type WORD,
     2 Minute type WORD;
 define alias PFAX_TIME handle FAX_TIME;

 define structure
   1 FAX_CONFIGURATIONA,
     2 SizeOfStruct         type DWORD,
         /* size of this structure */
     2 Retries              type DWORD,
         /* number of retries for fax send */
     2 RetryDelay           type DWORD,
         /* number of minutes between retries */
     2 DirtyDays            type DWORD,
         /* number of days to keep an unsent job in the queue */
     2 Branding             type BOOL,
         /* fsp should brand outgoing faxes */
     2 UseDeviceTsid        type BOOL,
         /* server uses device tsid only */
     2 ServerCp             type BOOL,
         /* clients must use cover pages on the server */
     2 PauseServerQueue     type BOOL,
         /* is the server queue paused? */
     2 StartCheapTime       type FAX_TIME,
         /* start of discount rate period */
     2 StopCheapTime        type FAX_TIME,
         /* end of discount rate period */
     2 ArchiveOutgoingFaxes type BOOL,
         /* whether outgoing faxes should be archived */
     2 ArchiveDirectory     type LPCSTR,
         /* archive directory for outgoing faxes */
     2 InboundProfile       type LPCSTR;
         /* profile used for inbound routing (email) */

 define alias PFAX_CONFIGURATIONA handle FAX_CONFIGURATIONA;

 define structure
   1 FAX_CONFIGURATIONW,
     2 SizeOfStruct         type DWORD,
         /* size of this structure */
     2 Retries              type DWORD,
         /* number of retries for fax send */
     2 RetryDelay           type DWORD,
         /* number of minutes between retries */
     2 DirtyDays            type DWORD,
         /* number of days to keep an unsent job in the queue */
     2 Branding             type BOOL,
         /* fsp should brand outgoing faxes */
     2 UseDeviceTsid        type BOOL,
         /* server uses device tsid only */
     2 ServerCp             type BOOL,
         /* clients must use cover pages on the server */
     2 PauseServerQueue     type BOOL,
         /* is the server queue paused? */
     2 StartCheapTime       type FAX_TIME,
         /* start of discount rate period */
     2 StopCheapTime        type FAX_TIME,
         /* end of discount rate period */
     2 ArchiveOutgoingFaxes type BOOL,
         /* whether outgoing faxes should be archived */
     2 ArchiveDirectory     type LPCWSTR,
         /* archive directory for outgoing faxes */
     2 InboundProfile        type LPCWSTR;
         /* profile used for inbound routing (email) */
 define alias PFAX_CONFIGURATIONW handle FAX_CONFIGURATIONW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_CONFIGURATION type  FAX_CONFIGURATIONW;
 define alias PFAX_CONFIGURATION type PFAX_CONFIGURATIONW;
 %end; %else %do;
 define alias  FAX_CONFIGURATION type  FAX_CONFIGURATIONA;
 define alias PFAX_CONFIGURATION type PFAX_CONFIGURATIONA;
 %end; /* UNICODE */


 /* FaxSetJob() command codes */

 dcl JC_UNKNOWN      fixed bin(31) value(0);
 dcl JC_DELETE       fixed bin(31) value(1);
 dcl JC_PAUSE        fixed bin(31) value(2);
 dcl JC_RESUME       fixed bin(31) value(3);
 dcl JC_RESTART      fixed bin(31) value(JC_RESUME);


 /* job type defines */

 dcl JT_UNKNOWN      fixed bin(31) value(0);
 dcl JT_SEND         fixed bin(31) value(1);
 dcl JT_RECEIVE      fixed bin(31) value(2);
 dcl JT_ROUTING      fixed bin(31) value(3);
 dcl JT_FAIL_RECEIVE fixed bin(31) value(4);


 /* job status defines */

 dcl JS_PENDING          type DWORD value('00000000'xu);
 dcl JS_INPROGRESS       type DWORD value('00000001'xu);
 dcl JS_DELETING         type DWORD value('00000002'xu);
 dcl JS_FAILED           type DWORD value('00000004'xu);
 dcl JS_PAUSED           type DWORD value('00000008'xu);
 dcl JS_NOLINE           type DWORD value('00000010'xu);
 dcl JS_RETRYING         type DWORD value('00000020'xu);
 dcl JS_RETRIES_EXCEEDED type DWORD value('00000040'xu);

 define structure
   1 FAX_DEVICE_STATUSA,
     2 SizeOfStruct  type DWORD,  /* size of this structure */
     2 CallerId      type LPCSTR, /* caller id string */
     2 Csid          type LPCSTR, /* station identifier */
     2 CurrentPage   type DWORD,  /* current page */
     2 DeviceId      type DWORD,  /* permanent line id */
     2 DeviceName    type LPCSTR, /* device name */
     2 DocumentName  type LPCSTR, /* document name */
     2 JobType       type DWORD,  /* send or receive? */
     2 PhoneNumber   type LPCSTR, /* sending phone number */
     2 RoutingString type LPCSTR, /* routing information */
     2 SenderName    type LPCSTR, /* sender name */
     2 RecipientName type LPCSTR, /* recipient name */
     2 Size          type DWORD,  /* sizebytes of the document */
     2 StartTime     type FILETIME,
         /* starting time of the fax send/receive */
     2 Status        type DWORD,
         /* current status of the device, see FPS_??? masks */
     2 StatusString  type LPCSTR,
         /* status string if the Status field is zero. May be NULL. */
     2 SubmittedTime type FILETIME,/* time the document was submitted */
     2 TotalPages    type DWORD,  /* total number of pagesthis job */
     2 Tsid          type LPCSTR, /* transmitting station identifier */
     2 UserName      type LPCSTR;
         /* user that submitted the active job */
 define alias PFAX_DEVICE_STATUSA handle FAX_DEVICE_STATUSA;

 define structure
   1 FAX_DEVICE_STATUSW,
     2 SizeOfStruct  type DWORD,  /* size of this structure */
     2 CallerId      type LPCWSTR,/* caller id string */
     2 Csid          type LPCWSTR,/* station identifier */
     2 CurrentPage   type DWORD,  /* current page */
     2 DeviceId      type DWORD,  /* permanent line id */
     2 DeviceName    type LPCWSTR,/* device name */
     2 DocumentName  type LPCWSTR,/* document name */
     2 JobType       type DWORD,  /* send or receive? */
     2 PhoneNumber   type LPCWSTR,/* sending phone number */
     2 RoutingString type LPCWSTR,/* routing information */
     2 SenderName    type LPCWSTR,/* sender name */
     2 RecipientName type LPCWSTR,/* recipient name */
     2 Size          type DWORD,  /* sizebytes of the document */
     2 StartTime     type FILETIME,
         /* starting time of the fax send/receive */
     2 Status        type DWORD,
         /* current status of the device, see FPS_??? masks */
     2 StatusString  type LPCWSTR,
         /* status string if the Status field is zero. May be NULL. */
     2 SubmittedTime type FILETIME,/* time the document was submitted */
     2 TotalPages    type DWORD,/* total number of pagesthis job */
     2 Tsid          type LPCWSTR,/* transmitting station identifier */
     2 UserName      type LPCWSTR;
         /* user that submitted the active job */
 define alias PFAX_DEVICE_STATUSW handle FAX_DEVICE_STATUSW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_DEVICE_STATUS type  FAX_DEVICE_STATUSW;
 define alias PFAX_DEVICE_STATUS type PFAX_DEVICE_STATUSW;
 %end; %else %do;
 define alias  FAX_DEVICE_STATUS type  FAX_DEVICE_STATUSA;
 define alias PFAX_DEVICE_STATUS type PFAX_DEVICE_STATUSA;
 %end; /* UNICODE */

 define structure
   1 FAX_JOB_ENTRYA,
     2 SizeOfStruct          type DWORD,  /* size of this structure */
     2 JobId                 type DWORD,  /* fax job id */
     2 UserName              type LPCSTR,
         /* user who submitted the job */
     2 JobType               type DWORD,  /* job type, see JT defines */
     2 QueueStatus           type DWORD,
         /* job queue status, see JS defines */
     2 Status                type DWORD,
         /* current status of the device, see FPS_??? masks */
     2 Size                  type DWORD,  /* sizebytes of the document*/
     2 PageCount             type DWORD,  /* total page count */
     2 RecipientNumber       type LPCSTR, /* recipient fax number */
     2 RecipientName         type LPCSTR, /* recipient name */
     2 Tsid                  type LPCSTR, /* transmitter's id */
     2 SenderName            type LPCSTR, /* sender name */
     2 SenderCompany         type LPCSTR, /* sender company */
     2 SenderDept            type LPCSTR, /* sender department */
     2 BillingCode           type LPCSTR, /* billing code */
     2 ScheduleAction        type DWORD,
         /* when to schedule the fax, see JSA defines */
     2 ScheduleTime          type SYSTEMTIME,
         /* time to send the fax when JSA_SPECIFIC_TIME is used */
         /* (must be local time) */
     2 DeliveryReportType    type DWORD,
         /* delivery report type, see DRT defines */
     2 DeliveryReportAddress type LPCSTR,
         /* email address for delivery report (ndr or dr) */
     2 DocumentName          type LPCSTR;/* document name */
 define alias PFAX_JOB_ENTRYA handle FAX_JOB_ENTRYA;

 define structure
   1 FAX_JOB_ENTRYW,
     2 SizeOfStruct          type DWORD,  /* size of this structure */
     2 JobId                 type DWORD,  /* fax job id */
     2 UserName              type LPCWSTR,
         /* user who submitted the job */
     2 JobType               type DWORD,  /* job type, see JT defines */
     2 QueueStatus           type DWORD,
         /* job queue status, see JS defines */
     2 Status                type DWORD,
         /* current status of the device, see FPS_??? masks */
     2 Size                  type DWORD,  /* sizebytes of the document*/
     2 PageCount             type DWORD,  /* total page count */
     2 RecipientNumber       type LPCWSTR,/* recipient fax number */
     2 RecipientName         type LPCWSTR,/* recipient name */
     2 Tsid                  type LPCWSTR,/* transmitter's id */
     2 SenderName            type LPCWSTR,/* sender name */
     2 SenderCompany         type LPCWSTR,/* sender company */
     2 SenderDept            type LPCWSTR,/* sender department */
     2 BillingCode           type LPCWSTR,/* billing code */
     2 ScheduleAction        type DWORD,
         /* when to schedule the fax, see JSA defines */
     2 ScheduleTime          type SYSTEMTIME,
         /* time to send the fax when JSA_SPECIFIC_TIME is used */
         /* (must be local time) */
     2 DeliveryReportType    type DWORD,
         /* delivery report type, see DRT defines */
     2 DeliveryReportAddress type LPCWSTR,
         /* email address for delivery report (ndr or dr) */
     2 DocumentName          type LPCWSTR;/* document name */
 define alias PFAX_JOB_ENTRYW handle FAX_JOB_ENTRYW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_JOB_ENTRY type  FAX_JOB_ENTRYW;
 define alias PFAX_JOB_ENTRY type PFAX_JOB_ENTRYW;
 %end; %else %do;
 define alias  FAX_JOB_ENTRY type  FAX_JOB_ENTRYA;
 define alias PFAX_JOB_ENTRY type PFAX_JOB_ENTRYA;
 %end; /* UNICODE */

 /* fax port state masks */
 /* if you change these defines the be sure to */
 /* change the resources in the fax service.   */

 dcl FPS_DIALING          type DWORD value('20000001'xu);
 dcl FPS_SENDING          type DWORD value('20000002'xu);
 dcl FPS_RECEIVING        type DWORD value('20000004'xu);
 dcl FPS_COMPLETED        type DWORD value('20000008'xu);
 dcl FPS_HANDLED          type DWORD value('20000010'xu);
 dcl FPS_UNAVAILABLE      type DWORD value('20000020'xu);
 dcl FPS_BUSY             type DWORD value('20000040'xu);
 dcl FPS_NO_ANSWER        type DWORD value('20000080'xu);
 dcl FPS_BAD_ADDRESS      type DWORD value('20000100'xu);
 dcl FPS_NO_DIAL_TONE     type DWORD value('20000200'xu);
 dcl FPS_DISCONNECTED     type DWORD value('20000400'xu);
 dcl FPS_FATAL_ERROR      type DWORD value('20000800'xu);
 dcl FPS_NOT_FAX_CALL     type DWORD value('20001000'xu);
 dcl FPS_CALL_DELAYED     type DWORD value('20002000'xu);
 dcl FPS_CALL_BLACKLISTED type DWORD value('20004000'xu);
 dcl FPS_INITIALIZING     type DWORD value('20008000'xu);
 dcl FPS_OFFLINE          type DWORD value('20010000'xu);
 dcl FPS_RINGING          type DWORD value('20020000'xu);

 dcl FPS_AVAILABLE        type DWORD value('20100000'xu);
 dcl FPS_ABORTING         type DWORD value('20200000'xu);
 dcl FPS_ROUTING          type DWORD value('20400000'xu);
 dcl FPS_ANSWERED         type DWORD value('20800000'xu);


 /* fax port capability mask */

 dcl FPF_RECEIVE          type DWORD value('00000001'xu);
 dcl FPF_SEND             type DWORD value('00000002'xu);
 dcl FPF_VIRTUAL          type DWORD value('00000004'xu);

 define structure
   1 FAX_PORT_INFOA,
     2 SizeOfStruct type DWORD,/* size of this structure */
     2 DeviceId     type DWORD,
     2 State        type DWORD,
     2 Flags        type DWORD,
     2 Rings        type DWORD,
     2 Priority     type DWORD,
     2 DeviceName   type LPCSTR,
     2 Tsid         type LPCSTR,
     2 Csid         type LPCSTR;
 define alias PFAX_PORT_INFOA handle FAX_PORT_INFOA;

 define structure
   1 FAX_PORT_INFOW,
     2 SizeOfStruct type DWORD,/* size of this structure */
     2 DeviceId     type DWORD,
     2 State        type DWORD,
     2 Flags        type DWORD,
     2 Rings        type DWORD,
     2 Priority     type DWORD,
     2 DeviceName   type LPCWSTR,
     2 Tsid         type LPCWSTR,
     2 Csid         type LPCWSTR;
 define alias PFAX_PORT_INFOW handle FAX_PORT_INFOW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_PORT_INFO type  FAX_PORT_INFOW;
 define alias PFAX_PORT_INFO type PFAX_PORT_INFOW;
 %end; %else %do;
 define alias  FAX_PORT_INFO type  FAX_PORT_INFOA;
 define alias PFAX_PORT_INFO type PFAX_PORT_INFOA;
 %end; /* UNICODE */


 define structure
   1 FAX_ROUTING_METHODA,
     2 SizeOfStruct          type DWORD,/* size of this structure */
     2 DeviceId              type DWORD,/* device identifier */
     2 Enabled               type BOOL,
         /* is this method enabled for this device? */
     2 DeviceName            type LPCSTR,/* device name */
     2 Guid                  type LPCSTR,
         /* guid that identifies this routing method */
     2 FriendlyName          type LPCSTR,
         /* friendly name for this method */
     2 FunctionName          type LPCSTR,
         /* exported function name that identifies this method */
     2 ExtensionImageName    type LPCSTR,
         /* module (dll) name that implements this method */
     2 ExtensionFriendlyName type LPCSTR;
         /* displayable string that identifies the extension */
 define alias PFAX_ROUTING_METHODA handle FAX_ROUTING_METHODA;

 define structure
   1 FAX_ROUTING_METHODW,
     2 SizeOfStruct          type DWORD,/* size of this structure */
     2 DeviceId              type DWORD,/* device identifier */
     2 Enabled               type BOOL,
         /* is this method enabled for this device? */
     2 DeviceName            type LPCWSTR,/* device name */
     2 Guid                  type LPCWSTR,
         /* guid that identifies this routing method */
     2 FriendlyName          type LPCWSTR,
         /* friendly name for this method */
     2 FunctionName          type LPCWSTR,
         /* exported function name that identifies this method */
     2 ExtensionImageName    type LPCWSTR,
         /* module (dll) name that implements this method */
     2 ExtensionFriendlyName type LPCWSTR;
         /* displayable string that identifies the extension */
 define alias PFAX_ROUTING_METHODW handle FAX_ROUTING_METHODW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_ROUTING_METHOD type  FAX_ROUTING_METHODW;
 define alias PFAX_ROUTING_METHOD type PFAX_ROUTING_METHODW;
 %end; %else %do;
 define alias  FAX_ROUTING_METHOD type  FAX_ROUTING_METHODA;
 define alias PFAX_ROUTING_METHOD type PFAX_ROUTING_METHODA;
 %end; /* UNICODE */


 define structure
   1 FAX_GLOBAL_ROUTING_INFOA,
     2 SizeOfStruct          type DWORD,/* size of this structure */
     2 Priority              type DWORD,/* priority of this device */
     2 Guid                  type LPCSTR,
         /* guid that identifies this routing method */
     2 FriendlyName          type LPCSTR,
         /* friendly name for this method */
     2 FunctionName          type LPCSTR,
         /* exported function name that identifies this method */
     2 ExtensionImageName    type LPCSTR,
         /* module (dll) name that implements this method */
     2 ExtensionFriendlyName type LPCSTR;
         /* displayable string that identifies the extension */
 define alias PFAX_GLOBAL_ROUTING_INFOA handle FAX_GLOBAL_ROUTING_INFOA;

 define structure
   1 FAX_GLOBAL_ROUTING_INFOW,
     2 SizeOfStruct          type DWORD,/* size of this structure */
     2 Priority              type DWORD,/* priority of this device */
     2 Guid                  type LPCWSTR,
         /* guid that identifies this routing method */
     2 FriendlyName          type LPCWSTR,
         /* friendly name for this method */
     2 FunctionName          type LPCWSTR,
         /* exported function name that identifies this method */
     2 ExtensionImageName    type LPCWSTR,
         /* module (dll) name that implements this method */
     2 ExtensionFriendlyName type LPCWSTR;
         /* displayable string that identifies the extension */
 define alias PFAX_GLOBAL_ROUTING_INFOW handle FAX_GLOBAL_ROUTING_INFOW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_GLOBAL_ROUTING_INFO type  FAX_GLOBAL_ROUTING_INFOW;
 define alias PFAX_GLOBAL_ROUTING_INFO type PFAX_GLOBAL_ROUTING_INFOW;
 %end; %else %do;
 define alias  FAX_GLOBAL_ROUTING_INFO type  FAX_GLOBAL_ROUTING_INFOA;
 define alias PFAX_GLOBAL_ROUTING_INFO type PFAX_GLOBAL_ROUTING_INFOA;
 %end; /* UNICODE */


 define structure
   1 FAX_COVERPAGE_INFOA,
     2 SizeOfStruct        type DWORD,/* Size of this structure */

   /* general */
     2 CoverPageName      type LPCSTR,/* coverpage document name */
     2 UseServerCoverPage type BOOL,
        /* coverpage exists on the fax server */

   /* Recipient information */
     2 RecName            type LPCSTR,
     2 RecFaxNumber       type LPCSTR,
     2 RecCompany         type LPCSTR,
     2 RecStreetAddress   type LPCSTR,
     2 RecCity            type LPCSTR,
     2 RecState           type LPCSTR,
     2 RecZip             type LPCSTR,
     2 RecCountry         type LPCSTR,
     2 RecTitle           type LPCSTR,
     2 RecDepartment      type LPCSTR,
     2 RecOfficeLocation  type LPCSTR,
     2 RecHomePhone       type LPCSTR,
     2 RecOfficePhone     type LPCSTR,

   /* Sender information */
     2 SdrName            type LPCSTR,
     2 SdrFaxNumber       type LPCSTR,
     2 SdrCompany         type LPCSTR,
     2 SdrAddress         type LPCSTR,
     2 SdrTitle           type LPCSTR,
     2 SdrDepartment      type LPCSTR,
     2 SdrOfficeLocation  type LPCSTR,
     2 SdrHomePhone       type LPCSTR,
     2 SdrOfficePhone     type LPCSTR,

   /* Misc information */
     2 Note               type LPCSTR,
     2 Subject            type LPCSTR,
     2 TimeSent           type SYSTEMTIME,/* Time the fax was sent */
     2 PageCount          type DWORD; /* Number of pages */
 define alias PFAX_COVERPAGE_INFOA handle FAX_COVERPAGE_INFOA;

 define structure
   1 FAX_COVERPAGE_INFOW,
     2 SizeOfStruct       type DWORD,/* Size of this structure */

   /* general */
     2 CoverPageName      type LPCWSTR,/* coverpage document name */
     2 UseServerCoverPage type BOOL,
         /* coverpage exists on the fax server  */

   /* Recipient information */
     2 RecName            type LPCWSTR,
     2 RecFaxNumber       type LPCWSTR,
     2 RecCompany         type LPCWSTR,
     2 RecStreetAddress   type LPCWSTR,
     2 RecCity            type LPCWSTR,
     2 RecState           type LPCWSTR,
     2 RecZip             type LPCWSTR,
     2 RecCountry         type LPCWSTR,
     2 RecTitle           type LPCWSTR,
     2 RecDepartment      type LPCWSTR,
     2 RecOfficeLocation  type LPCWSTR,
     2 RecHomePhone       type LPCWSTR,
     2 RecOfficePhone     type LPCWSTR,

   /* Sender information */
     2 SdrName            type LPCWSTR,
     2 SdrFaxNumber       type LPCWSTR,
     2 SdrCompany         type LPCWSTR,
     2 SdrAddress         type LPCWSTR,
     2 SdrTitle           type LPCWSTR,
     2 SdrDepartment      type LPCWSTR,
     2 SdrOfficeLocation  type LPCWSTR,
     2 SdrHomePhone       type LPCWSTR,
     2 SdrOfficePhone     type LPCWSTR,

   /* Misc information */
     2 Note              type LPCWSTR,
     2 Subject           type LPCWSTR,
     2 TimeSent          type SYSTEMTIME,/* Time the fax was sent */
     2 PageCount         type DWORD; /* Number of pages */
 define alias PFAX_COVERPAGE_INFOW handle FAX_COVERPAGE_INFOW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_COVERPAGE_INFO type  FAX_COVERPAGE_INFOW;
 define alias PFAX_COVERPAGE_INFO type PFAX_COVERPAGE_INFOW;
 %end; %else %do;
 define alias  FAX_COVERPAGE_INFO type  FAX_COVERPAGE_INFOA;
 define alias PFAX_COVERPAGE_INFO type PFAX_COVERPAGE_INFOA;
 %end; /* UNICODE */

 dcl JSA_NOW             fixed bin(31) value(0);
 dcl JSA_SPECIFIC_TIME   fixed bin(31) value(1);
 dcl JSA_DISCOUNT_PERIOD fixed bin(31) value(2);

 dcl DRT_NONE            fixed bin(31) value(0);
 dcl DRT_EMAIL           fixed bin(31) value(1);
 dcl DRT_INBOX           fixed bin(31) value(2);


 define structure
   1 FAX_JOB_PARAMA,
     2 SizeOfStruct    type DWORD, /* size of this structure */
     2 RecipientNumber type LPCSTR,/* recipient fax number */
     2 RecipientName   type LPCSTR,/* recipient name */
     2 Tsid            type LPCSTR,/* transmitter's id */
     2 SenderName      type LPCSTR,/* sender name */
     2 SenderCompany   type LPCSTR,/* sender company */
     2 SenderDept      type LPCSTR,/* sender department */
     2 BillingCode     type LPCSTR,/* billing code */
     2 ScheduleAction  type DWORD,
                       /* when to schedule the fax, see JSA defines */
     2 ScheduleTime    type SYSTEMTIME,
                       /* time to send the fax when JSA_SPECIFIC_TIME */
                       /* is used (must be local time) */
     2 DeliveryReportType type DWORD,
                       /* delivery report type, see DRT defines */
     2 DeliveryReportAddress type LPCSTR,
                     /* email address for delivery report (ndr or dr) */
     2 DocumentName    type LPCSTR,/* document name (optional) */
     2 CallHandle      type HCALL, /* call handle */
     2 Reserved (3)    type DWORD_PTR;/* reserved for ms use only */
 define alias PFAX_JOB_PARAMA handle FAX_JOB_PARAMA;

 define structure
   1 FAX_JOB_PARAMW,
     2 SizeOfStruct    type DWORD,  /* size of this structure */
     2 RecipientNumber type LPCWSTR,/* recipient fax number */
     2 RecipientName   type LPCWSTR,/* recipient name */
     2 Tsid            type LPCWSTR,/* transmitter's id */
     2 SenderName      type LPCWSTR,/* sender name */
     2 SenderCompany   type LPCWSTR,/* sender company */
     2 SenderDept      type LPCWSTR,/* sender department */
     2 BillingCode     type LPCWSTR,/* billing code */
     2 ScheduleAction  type DWORD,
                       /* when to schedule the fax, see JSA defines */
     2 ScheduleTime    type SYSTEMTIME,
                       /* time to send the fax when JSA_SPECIFIC_TIME */
                       /* is used (must be local time) */
     2 DeliveryReportType type DWORD,
                       /* delivery report type, see DRT defines */
     2 DeliveryReportAddress type LPCWSTR,
                     /* email address for delivery report (ndr or dr) */
     2 DocumentName    type LPCWSTR,/* document name (optional) */
     2 CallHandle      type HCALL,  /* call handle */
     2 Reserved (3)    type DWORD_PTR;/* reserved for ms use only */
 define alias PFAX_JOB_PARAMW handle FAX_JOB_PARAMW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_JOB_PARAM type  FAX_JOB_PARAMW;
 define alias PFAX_JOB_PARAM type PFAX_JOB_PARAMW;
 %end; %else %do;
 define alias  FAX_JOB_PARAM type  FAX_JOB_PARAMA;
 define alias PFAX_JOB_PARAM type PFAX_JOB_PARAMA;
 %end; /* UNICODE */



 /* Event Ids */

 /* FEI_NEVENTS is the number of events */


 dcl FEI_DIALING           type DWORD value('00000001'xu);
 dcl FEI_SENDING           type DWORD value('00000002'xu);
 dcl FEI_RECEIVING         type DWORD value('00000003'xu);
 dcl FEI_COMPLETED         type DWORD value('00000004'xu);
 dcl FEI_BUSY              type DWORD value('00000005'xu);
 dcl FEI_NO_ANSWER         type DWORD value('00000006'xu);
 dcl FEI_BAD_ADDRESS       type DWORD value('00000007'xu);
 dcl FEI_NO_DIAL_TONE      type DWORD value('00000008'xu);
 dcl FEI_DISCONNECTED      type DWORD value('00000009'xu);
 dcl FEI_FATAL_ERROR       type DWORD value('0000000a'xu);
 dcl FEI_NOT_FAX_CALL      type DWORD value('0000000b'xu);
 dcl FEI_CALL_DELAYED      type DWORD value('0000000c'xu);
 dcl FEI_CALL_BLACKLISTED  type DWORD value('0000000d'xu);
 dcl FEI_RINGING           type DWORD value('0000000e'xu);
 dcl FEI_ABORTING          type DWORD value('0000000f'xu);
 dcl FEI_ROUTING           type DWORD value('00000010'xu);
 dcl FEI_MODEM_POWERED_ON  type DWORD value('00000011'xu);
 dcl FEI_MODEM_POWERED_OFF type DWORD value('00000012'xu);
 dcl FEI_IDLE              type DWORD value('00000013'xu);
 dcl FEI_FAXSVC_ENDED      type DWORD value('00000014'xu);
 dcl FEI_ANSWERED          type DWORD value('00000015'xu);
 dcl FEI_JOB_QUEUED        type DWORD value('00000016'xu);
 dcl FEI_DELETED           type DWORD value('00000017'xu);
 dcl FEI_INITIALIZING      type DWORD value('00000018'xu);
 dcl FEI_LINE_UNAVAILABLE  type DWORD value('00000019'xu);
 dcl FEI_HANDLED           type DWORD value('0000001a'xu);
 dcl FEI_FAXSVC_STARTED    type DWORD value('0000001b'xu);


 dcl FEI_NEVENTS           type DWORD value(FEI_FAXSVC_STARTED);

 define structure
   1 FAX_EVENTA,
     2 SizeOfStruct type DWORD,/* Size of this structure */
     2 TimeStamp    type FILETIME,
                    /* Timestamp for when the event was generated */
     2 DeviceId     type DWORD,/* Permanent line id */
     2 EventId      type DWORD,/* Current event id */
     2 JobId        type DWORD;
                    /* Fax Job Id, 0xffffffff indicates inactive job */
 define alias PFAX_EVENTA handle FAX_EVENTA;

 define structure
   1 FAX_EVENTW,
     2 SizeOfStruct type DWORD,/* Size of this structure */
     2 TimeStamp    type FILETIME,
                    /* Timestamp for when the event was generated */
     2 DeviceId     type DWORD,/* Permanent line id */
     2 EventId      type DWORD,/* Current event id */
     2 JobId        type DWORD;
                    /* Fax Job Id, 0xffffffff indicates inactive job */
 define alias PFAX_EVENTW handle FAX_EVENTW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_EVENT type  FAX_EVENTW;
 define alias PFAX_EVENT type PFAX_EVENTW;
 %end; %else %do;
 define alias  FAX_EVENT type  FAX_EVENTA;
 define alias PFAX_EVENT type PFAX_EVENTA;
 %end; /* UNICODE */


 define structure
   1 FAX_PRINT_INFOA,
     2 SizeOfStruct    type DWORD, /* Size of this structure */
     2 DocName         type LPCSTR,
                       /* Document name that appearsthe spooler */
     2 RecipientName   type LPCSTR,/* Recipient name */
     2 RecipientNumber type LPCSTR,
                       /* Recipient fax number (non-canonical number) */
     2 SenderName      type LPCSTR,/* Sender name */
     2 SenderCompany   type LPCSTR,/* Sender company (optional) */
     2 SenderDept      type LPCSTR,/* Sender department */
     2 SenderBillingCode type LPCSTR,/* Billing code */
     2 DrProfileName   type LPCSTR,
       /* Profile name   for delivery report <--| mutually exclusive */
     2 DrEmailAddress  type LPCSTR,
       /* E.Mail address for delivery report <--| */
     2 OutputFileName  type LPCSTR;
                       /* for print to file, resulting file name */
 define alias PFAX_PRINT_INFOA handle FAX_PRINT_INFOA;

 define structure
   1 FAX_PRINT_INFOW,
     2 SizeOfStruct    type DWORD,/* Size of this structure */
     2 DocName         type LPCWSTR,
                       /* Document name that appearsthe spooler */
     2 RecipientName   type LPCWSTR,/* Recipient name */
     2 RecipientNumber type LPCWSTR,
                       /* Recipient fax number (non-canonical number) */
     2 SenderName      type LPCWSTR,/* Sender name */
     2 SenderCompany   type LPCWSTR,/* Sender company (optional) */
     2 SenderDept      type LPCWSTR,/* Sender department */
     2 SenderBillingCode type LPCWSTR,/* Billing code */
     2 DrProfileName   type LPCWSTR,
       /* Profile name   for delivery report <--| mutually exclusive */
     2 DrEmailAddress  type LPCWSTR,
       /* E.Mail address for delivery report <--| */
     2 OutputFileName  type LPCWSTR;
                       /* for print to file, resulting file name */
 define alias PFAX_PRINT_INFOW handle FAX_PRINT_INFOW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_PRINT_INFO type  FAX_PRINT_INFOW;
 define alias PFAX_PRINT_INFO type PFAX_PRINT_INFOW;
 %end; %else %do;
 define alias  FAX_PRINT_INFO type  FAX_PRINT_INFOA;
 define alias PFAX_PRINT_INFO type PFAX_PRINT_INFOA;
 %end; /* UNICODE */


 define structure
   1 FAX_CONTEXT_INFOA,
     2 SizeOfStruct type DWORD,/* Size of this structure */
     2 hDC        type HDC,    /* Device Context */
     2 ServerName char (MAX_COMPUTERNAME_LENGTH) varz;/* Server name */
 define alias PFAX_CONTEXT_INFOA handle FAX_CONTEXT_INFOA;

 define structure
   1 FAX_CONTEXT_INFOW,
     2 SizeOfStruct type DWORD,/* Size of this structure */
     2 hDC        type HDC,    /* Device Context */
     2 ServerName WCHAR (MAX_COMPUTERNAME_LENGTH) varz;/* Server name */
 define alias PFAX_CONTEXT_INFOW handle FAX_CONTEXT_INFOW;

 %if UNICODE ^= '' %then %do;
 define alias  FAX_CONTEXT_INFO type  FAX_CONTEXT_INFOW;
 define alias PFAX_CONTEXT_INFO type PFAX_CONTEXT_INFOW;
 %end; %else %do;
 define alias  FAX_CONTEXT_INFO type  FAX_CONTEXT_INFOA;
 define alias PFAX_CONTEXT_INFO type PFAX_CONTEXT_INFOA;
 %end; /* UNICODE */



 /* Fax Specific Access Rights */

 dcl FAX_JOB_SUBMIT   type DWORD value('0001'xu);
 dcl FAX_JOB_QUERY    type DWORD value('0002'xu);
 dcl FAX_CONFIG_QUERY type DWORD value('0004'xu);
 dcl FAX_CONFIG_SET   type DWORD value('0008'xu);
 dcl FAX_PORT_QUERY   type DWORD value('0010'xu);
 dcl FAX_PORT_SET     type DWORD value('0020'xu);
 dcl FAX_JOB_MANAGE   type DWORD value('0040'xu);

 dcl FAX_READ         type DWORD value (ior (STANDARD_RIGHTS_READ,
                                             FAX_JOB_QUERY,
                                             FAX_CONFIG_QUERY,
                                             FAX_PORT_QUERY));

 dcl FAX_WRITE        type DWORD value (ior (STANDARD_RIGHTS_WRITE,
                                             FAX_JOB_SUBMIT));

 dcl FAX_ALL_ACCESS   type DWORD value (ior (STANDARD_RIGHTS_ALL,
                                             FAX_JOB_SUBMIT,
                                             FAX_JOB_QUERY,
                                             FAX_CONFIG_QUERY,
                                             FAX_CONFIG_SET,
                                             FAX_PORT_QUERY,
                                             FAX_PORT_SET,
                                             FAX_JOB_MANAGE));


 /* prototypes */

 dcl FaxConnectFaxServerA
     entry (char(*) varz byaddr nonasgn optional,
            type HANDLE byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxConnectFaxServerA');

 dcl FaxConnectFaxServerW
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type HANDLE byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxConnectFaxServerW');

 %dcl FaxConnectFaxServer char ext;
 %if UNICODE ^= '' %then %do;
   %FaxConnectFaxServer='FaxConnectFaxServerW';
 %end; %else %do;
   %FaxConnectFaxServer='FaxConnectFaxServerA';
 %end; /* !UNICODE */

 define alias PFAXCONNECTFAXSERVERA
        entry (char(*) varz byaddr nonasgn optional,
               type HANDLE byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXCONNECTFAXSERVERW
        entry (WCHAR(*) varz byaddr nonasgn optional,
               type HANDLE byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXCONNECTFAXSERVER type PFAXCONNECTFAXSERVERW;
 %end; %else %do;
 define alias PFAXCONNECTFAXSERVER type PFAXCONNECTFAXSERVERA;
 %end; /* !UNICODE */

 dcl FaxClose
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxClose');

 define alias PFAXCLOSE
        entry (type HANDLE)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;


 dcl FaxAccessCheck
     entry (type HANDLE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxAccessCheck');

 define alias  PFAXACCESSCHECK
        entry (type HANDLE,
               type DWORD)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;


 dcl PORT_OPEN_QUERY  type DWORD value('00000001'xu);
 dcl PORT_OPEN_MODIFY type DWORD value('00000002'xu);

 dcl FaxOpenPort
     entry (type HANDLE,
            type DWORD,
            type DWORD,
            type HANDLE byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxOpenPort');

 define alias PFAXOPENPORT
        entry (type HANDLE,
               type DWORD,
               type DWORD,
               type HANDLE byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;


 dcl FaxCompleteJobParamsA
     entry (type PFAX_JOB_PARAMA byaddr,
            type PFAX_COVERPAGE_INFOA byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxCompleteJobParamsA');

 dcl FaxCompleteJobParamsW
     entry (type PFAX_JOB_PARAMW byaddr,
            type PFAX_COVERPAGE_INFOW byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxCompleteJobParamsW');

 %dcl FaxCompleteJobParams char ext;
 %if UNICODE ^= '' %then %do;
   %FaxCompleteJobParams='FaxCompleteJobParamsW';
 %end; %else %do;
   %FaxCompleteJobParams='FaxCompleteJobParamsA';
 %end; /* !UNICODE */

 define alias PFAXCOMPLETEJOBPARAMSA
        entry (type PFAX_JOB_PARAMA byaddr,
               type PFAX_COVERPAGE_INFOA byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXCOMPLETEJOBPARAMSW
        entry (type PFAX_JOB_PARAMW byaddr,
               type PFAX_COVERPAGE_INFOW byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXCOMPLETEJOBPARAMS type PFAXCOMPLETEJOBPARAMSW;
 %end; %else %do;
 define alias PFAXCOMPLETEJOBPARAMS type PFAXCOMPLETEJOBPARAMSA;
 %end; /* !UNICODE */


 dcl FaxSendDocumentA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type PFAX_JOB_PARAMA,
            type FAX_COVERPAGE_INFOA byaddr nonasgn optional,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSendDocumentA');

 dcl FaxSendDocumentW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type PFAX_JOB_PARAMW,
            type FAX_COVERPAGE_INFOW byaddr nonasgn optional,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSendDocumentW');

 %dcl FaxSendDocument char ext;
 %if UNICODE ^= '' %then %do;
   %FaxSendDocument='FaxSendDocumentW';
 %end; %else %do;
   %FaxSendDocument='FaxSendDocumentA';
 %end; /* !UNICODE */

 define alias PFAXSENDDOCUMENTA
        entry (type HANDLE,
               char(*) varz byaddr nonasgn,
               type PFAX_JOB_PARAMA,
               type FAX_COVERPAGE_INFOA byaddr nonasgn optional,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXSENDDOCUMENTW
        entry (type HANDLE,
               WCHAR(*) varz byaddr nonasgn,
               type PFAX_JOB_PARAMW,
               type FAX_COVERPAGE_INFOW byaddr nonasgn optional,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXSENDDOCUMENT type PFAXSENDDOCUMENTW;
 %end; %else %do;
 define alias PFAXSENDDOCUMENT type PFAXSENDDOCUMENTA;
 %end; /* !UNICODE */

 define alias PFAX_RECIPIENT_CALLBACKA
        entry (type HANDLE,
               type DWORD,
               type LPVOID,
               type FAX_JOB_PARAMA byaddr,
               type FAX_COVERPAGE_INFOA byaddr)
        returns (type BOOL byvalue optional)
        CALLBACK limited;

 define alias PFAX_RECIPIENT_CALLBACKW
        entry (type HANDLE,
               type DWORD,
               type LPVOID,
               type FAX_JOB_PARAMW byaddr,
               type FAX_COVERPAGE_INFOW byaddr)
        returns (type BOOL byvalue optional)
        CALLBACK limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAX_RECIPIENT_CALLBACK type PFAX_RECIPIENT_CALLBACKW;
 %end; %else %do;
 define alias PFAX_RECIPIENT_CALLBACK type PFAX_RECIPIENT_CALLBACKA;
 %end; /* !UNICODE */

 dcl FaxSendDocumentForBroadcastA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type DWORD byaddr,
            type PFAX_RECIPIENT_CALLBACKA,
            type LPVOID)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSendDocumentForBroadcastA');

 dcl FaxSendDocumentForBroadcastW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD byaddr,
            type PFAX_RECIPIENT_CALLBACKW,
            type LPVOID)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSendDocumentForBroadcastW');

 %dcl FaxSendDocumentForBroadcast char ext;
 %if UNICODE ^= '' %then %do;
   %FaxSendDocumentForBroadcast='FaxSendDocumentForBroadcastW';
 %end; %else %do;
   %FaxSendDocumentForBroadcast='FaxSendDocumentForBroadcastA';
 %end; /* !UNICODE */

 define alias PFAXSENDDOCUMENTFORBROADCASTA
        entry (type HANDLE,
               char(*) varz byaddr nonasgn,
               type DWORD byaddr,
               type PFAX_RECIPIENT_CALLBACKA,
               type LPVOID)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXSENDDOCUMENTFORBROADCASTW
        entry (type HANDLE,
               WCHAR(*) varz byaddr nonasgn,
               type DWORD byaddr,
               type PFAX_RECIPIENT_CALLBACKW,
               type LPVOID)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXSENDDOCUMENTFORBROADCAST
         type PFAXSENDDOCUMENTFORBROADCASTW;
 %end; %else %do;
 define alias PFAXSENDDOCUMENTFORBROADCAST
         type PFAXSENDDOCUMENTFORBROADCASTA;
 %end; /* !UNICODE */

 dcl FaxEnumJobsA
     entry (type HANDLE,
            type PFAX_JOB_ENTRYA byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxEnumJobsA');

 dcl FaxEnumJobsW
     entry (type HANDLE,
            type PFAX_JOB_ENTRYW byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxEnumJobsW');

 %dcl FaxEnumJobs char ext;
 %if UNICODE ^= '' %then %do;
   %FaxEnumJobs='FaxEnumJobsW';
 %end; %else %do;
   %FaxEnumJobs='FaxEnumJobsA';
 %end; /* !UNICODE */

 define alias PFAXENUMJOBSA
        entry (type HANDLE,
               type PFAX_JOB_ENTRYA byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXENUMJOBSW
        entry (type HANDLE,
               type PFAX_JOB_ENTRYW byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXENUMJOBS type PFAXENUMJOBSW;
 %end; %else %do;
 define alias PFAXENUMJOBS type PFAXENUMJOBSA;
 %end; /* !UNICODE */

 dcl FaxGetJobA
     entry (type HANDLE,
            type DWORD,
            type PFAX_JOB_ENTRYA byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetJobA');

 dcl FaxGetJobW
     entry (type HANDLE,
            type DWORD,
            type PFAX_JOB_ENTRYW byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetJobW');

 %dcl FaxGetJob char ext;
 %if UNICODE ^= '' %then %do;
   %FaxGetJob='FaxGetJobW';
 %end; %else %do;
   %FaxGetJob='FaxGetJobA';
 %end; /* !UNICODE */

 define alias PFAXGETJOBA
        entry (type HANDLE,
               type DWORD,
               type PFAX_JOB_ENTRYA byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXGETJOBW
        entry (type HANDLE,
               type DWORD,
               type PFAX_JOB_ENTRYW byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXGETJOB type PFAXGETJOBW;
 %end; %else %do;
 define alias PFAXGETJOB type PFAXGETJOBA;
 %end; /* !UNICODE */

 dcl FaxSetJobA
     entry (type HANDLE,
            type DWORD,
            type DWORD,
            type FAX_JOB_ENTRYA byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetJobA');

 dcl FaxSetJobW
     entry (type HANDLE,
            type DWORD,
            type DWORD,
            type FAX_JOB_ENTRYW byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetJobW');

 %dcl FaxSetJob char ext;
 %if UNICODE ^= '' %then %do;
   %FaxSetJob='FaxSetJobW';
 %end; %else %do;
   %FaxSetJob='FaxSetJobA';
 %end; /* !UNICODE */

 define alias PFAXSETJOBA
        entry (type HANDLE,
               type DWORD,
               type DWORD,
               type FAX_JOB_ENTRYA byaddr nonasgn)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXSETJOBW
        entry (type HANDLE,
               type DWORD,
               type DWORD,
               type FAX_JOB_ENTRYW byaddr nonasgn)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXSETJOB type PFAXSETJOBW;
 %end; %else %do;
 define alias PFAXSETJOB type PFAXSETJOBA;
 %end; /* !UNICODE */

 dcl FaxGetPageData
     entry (type HANDLE,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetPageData');

 define alias PFAXGETPAGEDATA
        entry (type HANDLE,
               type DWORD,
               type LPBYTE byaddr,
               type DWORD byaddr,
               type DWORD byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;


 dcl FaxGetDeviceStatusA
     entry (type HANDLE,
            type PFAX_DEVICE_STATUSA byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetDeviceStatusA');

 dcl FaxGetDeviceStatusW
     entry (type HANDLE,
            type PFAX_DEVICE_STATUSW byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetDeviceStatusW');

 %dcl FaxGetDeviceStatus char ext;
 %if UNICODE ^= '' %then %do;
   %FaxGetDeviceStatus='FaxGetDeviceStatusW';
 %end; %else %do;
   %FaxGetDeviceStatus='FaxGetDeviceStatusA';
 %end; /* !UNICODE */

 define alias PFAXGETDEVICESTATUSA
        entry (type HANDLE,
               type PFAX_DEVICE_STATUSA byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXGETDEVICESTATUSW
        entry (type HANDLE,
               type PFAX_DEVICE_STATUSW byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXGETDEVICESTATUS type PFAXGETDEVICESTATUSW;
 %end; %else %do;
 define alias PFAXGETDEVICESTATUS type PFAXGETDEVICESTATUSA;
 %end; /* !UNICODE */


 dcl FaxAbort
     entry (type HANDLE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxAbort');

 define alias PFAXABORT
        entry (type HANDLE,
               type DWORD)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;


 dcl FaxGetConfigurationA
     entry (type HANDLE,
            type PFAX_CONFIGURATIONA byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetConfigurationA');

 dcl FaxGetConfigurationW
     entry (type HANDLE,
            type PFAX_CONFIGURATIONW byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetConfigurationW');

 %dcl FaxGetConfiguration char ext;
 %if UNICODE ^= '' %then %do;
   %FaxGetConfiguration='FaxGetConfigurationW';
 %end; %else %do;
   %FaxGetConfiguration='FaxGetConfigurationA';
 %end; /* !UNICODE */

 define alias PFAXGETCONFIGURATIONA
        entry (type HANDLE,
               type PFAX_CONFIGURATIONA byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXGETCONFIGURATIONW
        entry (type HANDLE,
               type PFAX_CONFIGURATIONW byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXGETCONFIGURATION type PFAXGETCONFIGURATIONW;
 %end; %else %do;
 define alias PFAXGETCONFIGURATION type PFAXGETCONFIGURATIONA;
 %end; /* !UNICODE */

 dcl FaxSetConfigurationA
     entry (type HANDLE,
            type FAX_CONFIGURATIONA byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetConfigurationA');

 dcl FaxSetConfigurationW
     entry (type HANDLE,
            type FAX_CONFIGURATIONW byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetConfigurationW');

 %dcl FaxSetConfiguration char ext;
 %if UNICODE ^= '' %then %do;
   %FaxSetConfiguration='FaxSetConfigurationW';
 %end; %else %do;
   %FaxSetConfiguration='FaxSetConfigurationA';
 %end; /* !UNICODE */

 define alias PFAXSETCONFIGURATIONA
        entry (type HANDLE,
               type FAX_CONFIGURATIONA byaddr nonasgn)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXSETCONFIGURATIONW
        entry (type HANDLE,
               type FAX_CONFIGURATIONW byaddr nonasgn)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXSETCONFIGURATION type PFAXSETCONFIGURATIONW;
 %end; %else %do;
 define alias PFAXSETCONFIGURATION type PFAXSETCONFIGURATIONA;
 %end; /* !UNICODE */

 dcl FaxGetLoggingCategoriesA
     entry (type HANDLE,
            type PFAX_LOG_CATEGORYA byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetLoggingCategoriesA');

 dcl FaxGetLoggingCategoriesW
     entry (type HANDLE,
            type PFAX_LOG_CATEGORYW byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetLoggingCategoriesW');

 %dcl FaxGetLoggingCategories char ext;
 %if UNICODE ^= '' %then %do;
   %FaxGetLoggingCategories='FaxGetLoggingCategoriesW';
 %end; %else %do;
   %FaxGetLoggingCategories='FaxGetLoggingCategoriesA';
 %end; /* !UNICODE */

 define alias PFAXGETLOGGINGCATEGORIESA
        entry (type HANDLE,
               type PFAX_LOG_CATEGORYA byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXGETLOGGINGCATEGORIESW
        entry (type HANDLE,
               type PFAX_LOG_CATEGORYW byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXGETLOGGINGCATEGORIES type PFAXGETLOGGINGCATEGORIESW;
 %end; %else %do;
 define alias PFAXGETLOGGINGCATEGORIES type PFAXGETLOGGINGCATEGORIESA;
 %end; /* !UNICODE */

 dcl FaxSetLoggingCategoriesA
     entry (type HANDLE,
            (*) type FAX_LOG_CATEGORYA byaddr nonasgn,
            type DWORD)
          returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetLoggingCategoriesA');

 dcl FaxSetLoggingCategoriesW
     entry (type HANDLE,
            (*) type FAX_LOG_CATEGORYW byaddr nonasgn,
            type DWORD)
          returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetLoggingCategoriesW');

 %dcl FaxSetLoggingCategories char ext;
 %if UNICODE ^= '' %then %do;
   %FaxSetLoggingCategories='FaxSetLoggingCategoriesW';
 %end; %else %do;
   %FaxSetLoggingCategories='FaxSetLoggingCategoriesA';
 %end; /* !UNICODE */

 define alias PFAXSETLOGGINGCATEGORIESA
        entry (type HANDLE,
               (*) type FAX_LOG_CATEGORYA byaddr nonasgn,
               type DWORD)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXSETLOGGINGCATEGORIESW
        entry (type HANDLE,
               (*) type FAX_LOG_CATEGORYW byaddr nonasgn,
               type DWORD)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXSETLOGGINGCATEGORIES type PFAXSETLOGGINGCATEGORIESW;
 %end; %else %do;
 define alias PFAXSETLOGGINGCATEGORIES type PFAXSETLOGGINGCATEGORIESA;
 %end; /* !UNICODE */

 dcl FaxEnumPortsA
     entry (type HANDLE,
            type PFAX_PORT_INFOA byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxEnumPortsA');

 dcl FaxEnumPortsW
     entry (type HANDLE,
            type PFAX_PORT_INFOW byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxEnumPortsW');

 %dcl FaxEnumPorts char ext;
 %if UNICODE ^= '' %then %do;
   %FaxEnumPorts='FaxEnumPortsW';
 %end; %else %do;
   %FaxEnumPorts='FaxEnumPortsA';
 %end; /* !UNICODE */

 define alias PFAXENUMPORTSA
        entry (type HANDLE,
               type PFAX_PORT_INFOA byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXENUMPORTSW
        entry (type HANDLE,
               type PFAX_PORT_INFOW byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXENUMPORTS type PFAXENUMPORTSW;
 %end; %else %do;
 define alias PFAXENUMPORTS type PFAXENUMPORTSA;
 %end; /* !UNICODE */

 dcl FaxGetPortA
     entry (type HANDLE,
            type PFAX_PORT_INFOA byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetPortA');

 dcl FaxGetPortW
     entry (type HANDLE,
            type PFAX_PORT_INFOW byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetPortW');

 %dcl FaxGetPort char ext;
 %if UNICODE ^= '' %then %do;
   %FaxGetPort='FaxGetPortW';
 %end; %else %do;
   %FaxGetPort='FaxGetPortA';
 %end; /* !UNICODE */

 define alias PFAXGETPORTA
        entry (type HANDLE,
               type PFAX_PORT_INFOA byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXGETPORTW
        entry (type HANDLE,
               type PFAX_PORT_INFOW byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXGETPORT type PFAXGETPORTW;
 %end; %else %do;
 define alias PFAXGETPORT type PFAXGETPORTA;
 %end; /* !UNICODE */


 dcl FaxSetPortA
     entry (type HANDLE,
            type FAX_PORT_INFOA byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetPortA');

 dcl FaxSetPortW
     entry (type HANDLE,
            type FAX_PORT_INFOW byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetPortW');

 %dcl FaxSetPort char ext;
 %if UNICODE ^= '' %then %do;
   %FaxSetPort='FaxSetPortW';
 %end; %else %do;
   %FaxSetPort='FaxSetPortA';
 %end; /* !UNICODE */

 define alias PFAXSETPORTA
        entry (type HANDLE,
               type FAX_PORT_INFOA byaddr nonasgn)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXSETPORTW
        entry (type HANDLE,
               type FAX_PORT_INFOW byaddr nonasgn)
        returns (type BOOL byvalue optional)
         WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXSETPORT type PFAXSETPORTW;
 %end; %else %do;
 define alias PFAXSETPORT type PFAXSETPORTA;
 %end; /* !UNICODE */


 dcl FaxEnumRoutingMethodsA
     entry (type HANDLE,
            type PFAX_ROUTING_METHODA byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxEnumRoutingMethodsA');

 dcl FaxEnumRoutingMethodsW
     entry (type HANDLE,
            type PFAX_ROUTING_METHODW byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxEnumRoutingMethodsW');

 %dcl FaxEnumRoutingMethods char ext;
 %if UNICODE ^= '' %then %do;
   %FaxEnumRoutingMethods='FaxEnumRoutingMethodsW';
 %end; %else %do;
   %FaxEnumRoutingMethods='FaxEnumRoutingMethodsA';
 %end; /* !UNICODE */

 define alias PFAXENUMROUTINGMETHODSA
        entry (type HANDLE,
               type PFAX_ROUTING_METHODA byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXENUMROUTINGMETHODSW
        entry (type HANDLE,
               type PFAX_ROUTING_METHODW byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXENUMROUTINGMETHODS type PFAXENUMROUTINGMETHODSW;
 %end; %else %do;
 define alias PFAXENUMROUTINGMETHODS type PFAXENUMROUTINGMETHODSA;
 %end; /* !UNICODE */

 dcl FaxEnableRoutingMethodA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type BOOL)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxEnableRoutingMethodA');

 dcl FaxEnableRoutingMethodW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type BOOL)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxEnableRoutingMethodW');

 %dcl FaxEnableRoutingMethod char ext;
 %if UNICODE ^= '' %then %do;
   %FaxEnableRoutingMethod='FaxEnableRoutingMethodW';
 %end; %else %do;
   %FaxEnableRoutingMethod='FaxEnableRoutingMethodA';
 %end; /* !UNICODE */

 define alias PFAXENABLEROUTINGMETHODA
        entry (type HANDLE,
               char(*) varz byaddr nonasgn,
               type BOOL)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXENABLEROUTINGMETHODW
        entry (type HANDLE,
               WCHAR(*) varz byaddr nonasgn,
               type BOOL)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXENABLEROUTINGMETHOD type PFAXENABLEROUTINGMETHODW;
 %end; %else %do;
 define alias PFAXENABLEROUTINGMETHOD type PFAXENABLEROUTINGMETHODA;
 %end; /* !UNICODE */


 dcl FaxEnumGlobalRoutingInfoA
     entry (type HANDLE,
            type PFAX_GLOBAL_ROUTING_INFOA byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxEnumGlobalRoutingInfoA');

 dcl FaxEnumGlobalRoutingInfoW
     entry (type HANDLE,
            type PFAX_GLOBAL_ROUTING_INFOW byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxEnumGlobalRoutingInfoW');

 %dcl FaxEnumGlobalRoutingInfo char ext;
 %if UNICODE ^= '' %then %do;
   %FaxEnumGlobalRoutingInfo='FaxEnumGlobalRoutingInfoW';
 %end; %else %do;
   %FaxEnumGlobalRoutingInfo='FaxEnumGlobalRoutingInfoA';
 %end; /* !UNICODE */

 define alias PFAXENUMGLOBALROUTINGINFOA
        entry (type HANDLE,
               type PFAX_GLOBAL_ROUTING_INFOA byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXENUMGLOBALROUTINGINFOW
        entry (type HANDLE,
               type PFAX_GLOBAL_ROUTING_INFOW byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXENUMGLOBALROUTINGINFO type PFAXENUMGLOBALROUTINGINFOW;
 %end; %else %do;
 define alias PFAXENUMGLOBALROUTINGINFO type PFAXENUMGLOBALROUTINGINFOA;
 %end; /* !UNICODE */

 dcl FaxSetGlobalRoutingInfoA
     entry (type HANDLE,
            type FAX_GLOBAL_ROUTING_INFOA byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetGlobalRoutingInfoA');

 dcl FaxSetGlobalRoutingInfoW
     entry (type HANDLE,
            type FAX_GLOBAL_ROUTING_INFOW byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetGlobalRoutingInfoW');

 %dcl FaxSetGlobalRoutingInfo char ext;
 %if UNICODE ^= '' %then %do;
   %FaxSetGlobalRoutingInfo='FaxSetGlobalRoutingInfoW';
 %end; %else %do;
   %FaxSetGlobalRoutingInfo='FaxSetGlobalRoutingInfoA';
 %end; /* !UNICODE */

 define alias PFAXSETGLOBALROUTINGINFOA
        entry (type HANDLE,
               type FAX_GLOBAL_ROUTING_INFOA byaddr nonasgn)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXSETGLOBALROUTINGINFOW
        entry (type HANDLE,
               type FAX_GLOBAL_ROUTING_INFOW byaddr nonasgn)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXSETGLOBALROUTINGINFO type PFAXSETGLOBALROUTINGINFOW;
 %end; %else %do;
 define alias PFAXSETGLOBALROUTINGINFO type PFAXSETGLOBALROUTINGINFOA;
 %end; /* !UNICODE */


 dcl FaxGetRoutingInfoA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type LPBYTE byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetRoutingInfoA');

 dcl FaxGetRoutingInfoW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type LPBYTE byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxGetRoutingInfoW');

 %dcl FaxGetRoutingInfo char ext;
 %if UNICODE ^= '' %then %do;
   %FaxGetRoutingInfo='FaxGetRoutingInfoW';
 %end; %else %do;
   %FaxGetRoutingInfo='FaxGetRoutingInfoA';
 %end; /* !UNICODE */

 define alias PFAXGETROUTINGINFOA
        entry (type HANDLE,
               char(*) varz byaddr nonasgn,
               type LPBYTE byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXGETROUTINGINFOW
        entry (type HANDLE,
               WCHAR(*) varz byaddr nonasgn,
               type LPBYTE byaddr,
               type DWORD byaddr)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXGETROUTINGINFO type PFAXGETROUTINGINFOW;
 %end; %else %do;
 define alias PFAXGETROUTINGINFO type PFAXGETROUTINGINFOA;
 %end; /* !UNICODE */


 dcl FaxSetRoutingInfoA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type LPBYTE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetRoutingInfoA');

 dcl FaxSetRoutingInfoW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type LPBYTE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxSetRoutingInfoW');

 %dcl FaxSetRoutingInfo char ext;
 %if UNICODE ^= '' %then %do;
   %FaxSetRoutingInfo='FaxSetRoutingInfoW';
 %end; %else %do;
   %FaxSetRoutingInfo='FaxSetRoutingInfoA';
 %end; /* !UNICODE */

 define alias PFAXSETROUTINGINFOA
        entry (type HANDLE,
               char(*) varz byaddr nonasgn,
               type LPBYTE,
               type DWORD)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXSETROUTINGINFOW
        entry (type HANDLE,
               WCHAR(*) varz byaddr nonasgn,
               type LPBYTE,
               type DWORD)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXSETROUTINGINFO type PFAXSETROUTINGINFOW;
 %end; %else %do;
 define alias PFAXSETROUTINGINFO type PFAXSETROUTINGINFOA;
 %end; /* !UNICODE */


 dcl FaxInitializeEventQueue
     entry (type HANDLE,
            type HANDLE,
            type ULONG_PTR,
            type HWND,
            type UINT)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxInitializeEventQueue');

 define alias PFAXINITIALIZEEVENTQUEUE
        entry (type HANDLE,
               type HANDLE,
               type ULONG_PTR,
               type HWND,
               type UINT)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;


 dcl FaxFreeBuffer
     entry (type LPVOID)
     WINFAXAPI WINAPI external('FaxFreeBuffer');

 define alias PFAXFREEBUFFER
        entry (type LPVOID)
        WINFAXAPI WINAPI limited;


 dcl FaxStartPrintJobA
     entry (char(*) varz byaddr nonasgn,
            type FAX_PRINT_INFOA byaddr nonasgn,
            type DWORD byaddr,
            type PFAX_CONTEXT_INFOA)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxStartPrintJobA');

 dcl FaxStartPrintJobW
     entry (WCHAR(*) varz byaddr nonasgn,
            type FAX_PRINT_INFOW byaddr nonasgn,
            type DWORD byaddr,
            type PFAX_CONTEXT_INFOW)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxStartPrintJobW');

 %dcl FaxStartPrintJob char ext;
 %if UNICODE ^= '' %then %do;
   %FaxStartPrintJob='FaxStartPrintJobW';
 %end; %else %do;
   %FaxStartPrintJob='FaxStartPrintJobA';
 %end; /* !UNICODE */

 define alias PFAXSTARTPRINTJOBA
        entry (char(*) varz byaddr nonasgn,
               type FAX_PRINT_INFOA byaddr nonasgn,
               type DWORD byaddr,
               type PFAX_CONTEXT_INFOA)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 define alias PFAXSTARTPRINTJOBW
        entry (WCHAR(*) varz byaddr nonasgn,
               type FAX_PRINT_INFOW byaddr nonasgn,
               type DWORD byaddr,
               type PFAX_CONTEXT_INFOW)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXSTARTPRINTJOB type PFAXSTARTPRINTJOBW;
 %end; %else %do;
 define alias PFAXSTARTPRINTJOB type PFAXSTARTPRINTJOBA;
 %end; /* !UNICODE */

 dcl FaxPrintCoverPageA
     entry (type FAX_CONTEXT_INFOA byaddr nonasgn,
            type FAX_COVERPAGE_INFOA byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxPrintCoverPageA');

 dcl FaxPrintCoverPageW
     entry (type FAX_CONTEXT_INFOW byaddr nonasgn,
            type FAX_COVERPAGE_INFOW byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxPrintCoverPageW');

 %dcl FaxPrintCoverPage char ext;
 %if UNICODE ^= '' %then %do;
   %FaxPrintCoverPage='FaxPrintCoverPageW';
 %end; %else %do;
   %FaxPrintCoverPage='FaxPrintCoverPageA';
 %end; /* !UNICODE */

 define alias PFAXPRINTCOVERPAGEA
        entry (type FAX_CONTEXT_INFOA byaddr nonasgn,
               type FAX_COVERPAGE_INFOA byaddr nonasgn)
        returns (type BOOL byvalue optional)
         WINFAXAPI WINAPI limited;

 define alias PFAXPRINTCOVERPAGEW
        entry (type FAX_CONTEXT_INFOW byaddr nonasgn,
               type FAX_COVERPAGE_INFOW byaddr nonasgn)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %if UNICODE ^= '' %then %do;
 define alias PFAXPRINTCOVERPAGE type PFAXPRINTCOVERPAGEW;
 %end; %else %do;
 define alias PFAXPRINTCOVERPAGE type PFAXPRINTCOVERPAGEA;
 %end; /* !UNICODE */

 dcl FaxRegisterServiceProviderW
     entry (WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxRegisterServiceProviderW');

 %dcl FaxRegisterServiceProvider char ext;
 %FaxRegisterServiceProvider='FaxRegisterServiceProviderW';

 define alias PFAXREGISTERSERVICEPROVIDERW
        entry (WCHAR(*) varz byaddr nonasgn,
               WCHAR(*) varz byaddr nonasgn,
               WCHAR(*) varz byaddr nonasgn,
               WCHAR(*) varz byaddr nonasgn)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %dcl PFAXREGISTERSERVICEPROVIDER char ext;
 %PFAXREGISTERSERVICEPROVIDER='PFAXREGISTERSERVICEPROVIDERW';

 define alias PFAX_ROUTING_INSTALLATION_CALLBACKW
        entry (type HANDLE,
               type LPVOID,
               WCHAR(*) varz byaddr,
               WCHAR(*) varz byaddr,
               WCHAR(*) varz byaddr,
               WCHAR(*) varz byaddr)
        returns (type BOOL byvalue optional)
        CALLBACK limited;

 %dcl PFAX_ROUTING_INSTALLATION_CALLBACK char ext;
 %PFAX_ROUTING_INSTALLATION_CALLBACK
   ='PFAX_ROUTING_INSTALLATION_CALLBACKW';

 dcl FaxRegisterRoutingExtensionW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type PFAX_ROUTING_INSTALLATION_CALLBACKW,
            type LPVOID)
     returns (type BOOL byvalue optional)
     WINFAXAPI WINAPI external('FaxRegisterRoutingExtensionW');

 %dcl FaxRegisterRoutingExtension char ext;
 %FaxRegisterRoutingExtension='FaxRegisterRoutingExtensionW';


 define alias PFAXREGISTERROUTINGEXTENSIONW
        entry (type HANDLE,
               WCHAR(*) varz byaddr nonasgn,
               WCHAR(*) varz byaddr nonasgn,
               WCHAR(*) varz byaddr nonasgn,
               type PFAX_ROUTING_INSTALLATION_CALLBACKW,
               type LPVOID)
        returns (type BOOL byvalue optional)
        WINFAXAPI WINAPI limited;

 %dcl PFAXREGISTERROUTINGEXTENSION char ext;
 %PFAXREGISTERROUTINGEXTENSION='PFAXREGISTERROUTINGEXTENSIONW';

 %end;
