 /*********************************************************************/
 /*                                                                   */
 /* PRODUCT   = Data Description and Conversion                       */
 /*                                                                   */
 /*             IBM Confidential                                      */
 /*             (IBM Confidential-Restricted                          */
 /*             when combined with the aggregated OCO                 */
 /*             source modules for this program.)                     */
 /*                                                                   */
 /*             OCO SOURCE MATERIALS                                  */
 /*                                                                   */
 /* COPYRIGHT = 5622-75101 (c) IBM Corp. 1994                         */
 /*                                                                   */
 /* SOURCE FILE NAME = cdrasrv.h                                      */
 /*                                                                   */
 /* DESCRIPTIVE NAME = cdra service definition                        */
 /*                                                                   */
 /* STATUS = VERSION 1, RELEASE 1, MODIFICATION 0                     */
 /*                                                                   */
 /* CONTENT = included definitions (types, constants, prototypes etc.)*/
 /*                                                                   */
 /*********************************************************************/
 /* $Header: P:\PROJECTS\CDRASRV\CDRASRV.H_V 1.2                      */
 /*           26 May 1994 14:13:14 MTN  $                             */
 /*  $Log:   P:\PROJECTS\CDRASRV\CDRASRV.H_V  $                       */
 /*                                                                   */
 /* Rev 1.3 12/19/96 11:07:00 Windows Port                            */
 /* $W0 =           KY   : Changes done for porting to Windows        */
 /*                        12/19/96 11:07:00                          */
 /*                                                                   */
 /*    Rev 1.2   26 May 1994 14:13:14   MTN                           */
 /* $I= I0000307   MTN   : Changes made for port to MVS.              */
 /*                                                                   */
 /*    Rev 1.1   11 Aug 1993 13:43:26   MTN                           */
 /* $I= I0000265   MTN   : CDRASRV enabling to allow different naming */
 /*                        of the DLL and config. file and resources. */
 /*                        The names of these files are derived from  */
 /*                        the name of the DLL.                       */
 /*                        CONFIG:  dllname.CFG                       */
 /*                        CCSID:   dllnameC                          */
 /*                        GCCST:   dllnameG                          */
 /*                                                                   */
 /*    Rev 1.0   28 Jul 1993 14:13:36   MTN                           */
 /* Initial revision.                                                 */
 /*  $Workfile:   cdrasrv.h  $                                        */
 /*********************************************************************/

 %dcl CDRASRV_INCLUDED char ext;
 %if CDRASRV_INCLUDED = '' %then %do;
 %CDRASRV_INCLUDED = 'Y';

 define alias CDRASRV_CCSID_T  fixed bin(31);
 define alias CDRASRV_CPGID_T  fixed bin(31);
 define alias CDRASRV_ESIDA_T  fixed bin(31);
 define alias CDRASRV_GCSGID_T fixed bin(31);

 define structure
   1 CDRASRV_FeedBack_T,   /* structure used to return a return code */
     2 Status    fixed bin(15),
     2 Reason    fixed bin(15),
     2 reserved1 fixed bin(31),
     2 reserved2 fixed bin(31);


 define structure
   1 CDRASRV_ESID_T,
     2 ESID type CDRASRV_ESIDA_T,    /* entire Encoding Scheme ID */
     2 BasicEncoding fixed bin(31),  /* parts */
     2 NumberOfBytes fixed bin(31),  /* of */
     2 CodeExtension fixed bin(31);  /* the ESID */

 define structure
   1 CDRASRV_CSCPpair_T,
     2 GCSGID type CDRASRV_GCSGID_T, /* Character Set ID */
     2 CPGID  type CDRASRV_CPGID_T;  /* Code Page ID */


 /* CGCSGID - Coded Graphic Character Set Global Identifiers */

 define structure
   1 CDRASRV_CTLFDF_T,
     2 CodePoint fixed bin(31),
     2 Width     fixed bin(31),
     2 State     fixed bin(31);

  dcl CDRASRV_ESID_BasEncStrEBCDIC         fixed bin(31) value(1);
  dcl CDRASRV_ESID_BasEncStrIBM_PC_Data    fixed bin(31) value(2);
  dcl CDRASRV_ESID_BasEncStrIBM_PC_Display fixed bin(31) value(3);
  dcl CDRASRV_ESID_BasEncStrISO_8          fixed bin(31) value(4);
  dcl CDRASRV_ESID_BasEncStrISO_7          fixed bin(31) value(5);
  dcl CDRASRV_ESID_NrOfBytes_SB            fixed bin(31) value(1);
  dcl CDRASRV_ESID_NrOfBytes_DB            fixed bin(31) value(2);
  dcl CDRASRV_ESID_NrOfBytes_MixedSBDB     fixed bin(31) value(3);
  dcl CDRASRV_ESID_ExtMtd_None             fixed bin(31) value('00'xn);
  dcl CDRASRV_ESID_ExtMtd_SOSI             fixed bin(31) value('01'xn);


  dcl CDRASRV_ST_NoError                   fixed bin(31) value(0);
  dcl CDRASRV_ST_NotFound                  fixed bin(31) value(1);
  dcl CDRASRV_ST_Value0                    fixed bin(31) value(2);
  dcl CDRASRV_ST_SpecialValue              fixed bin(31) value(3);
  dcl CDRASRV_ST_Overflow                  fixed bin(31) value(4);
  dcl CDRASRV_ST_Syntax                    fixed bin(31) value(5);
  dcl CDRASRV_ST_CantProceed               fixed bin(31) value(6);
  dcl CDRASRV_ST_ResourceDamaged           fixed bin(31) value(7);
  dcl CDRASRV_ST_ParameterRangeError       fixed bin(31) value(8);
  dcl CDRASRV_ST_ConvertSpecific           fixed bin(31) value('100'xn);
  dcl CDRASRV_ST_OS2Specific               fixed bin(31) value('800'xn);

  dcl CDRASRV_RSN_EntryExit                fixed bin(31) value(1);
  dcl CDRASRV_RSN_Init                     fixed bin(31) value(2);
  dcl CDRASRV_RSN_TraceError               fixed bin(31) value(3);


 /* Name of Configuration File */

 %dcl CDRASRV_Entry char;
 %CDRASRV_Entry = 'options (byvalue nodescriptor linkage(optlink))';


 dcl CDRASRV_MSC_Token_T (8) fixed bin (31) based;   /* for LIKE */

 dcl CDRXSRF
     entry (type CDRASRV_FeedBack_T byaddr nonasgn,  /* InputFeedBack */
            fixed bin (31) byaddr,                   /* Status */
            fixed bin (31) byaddr,                   /* Reason */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRXSRF');

 dcl CDRGESE
     entry (type CDRASRV_CCSID_T byaddr nonasgn,     /* ccsid */
            type CDRASRV_ESID_T byaddr,              /* esel */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRGESE');

 dcl CDRGCSP
     entry (type CDRASRV_CCSID_T byaddr nonasgn,     /* ccsid */
            fixed bin (31) byaddr nonasgn,           /* n1 */
            fixed bin (31) byaddr,                   /* n2 */
            fixed bin (31) byaddr,                   /* cscpl */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRGCSP');

 dcl CDRGESP
     entry (type CDRASRV_CCSID_T byaddr nonasgn,     /* ccsid */
            fixed bin (31) byaddr nonasgn,           /* n1 */
            fixed bin (31) byaddr,                   /* n2 */
            type CDRASRV_ESIDA_T byaddr,             /* edis */
            fixed bin (31) byaddr,                   /* cscpl */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRGESP');

 dcl CDRGCTL
     entry (type CDRASRV_CCSID_T byaddr nonasgn,     /* ccsid */
            fixed bin (31) byaddr nonasgn,           /* Sel */
            fixed bin (31) byaddr nonasgn,           /* n1 */
            fixed bin (31) byaddr,                   /* n2 */
            fixed bin (31) byaddr,                   /* cltFdF */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRGCTL');

 dcl CDRGSTE
     entry (type CDRASRV_CCSID_T byaddr nonasgn,     /* ccsid1 */
            fixed bin (31) byaddr nonasgn,           /* Selection */
            type CDRASRV_CCSID_T byaddr nonasgn,     /* ccsid2 */
            fixed bin (31) byaddr nonasgn,           /* n1 */
            fixed bin (31) byaddr,                   /* n2 */
            type CDRASRV_CCSID_T byaddr,             /* ccsid3 */
            pointer byvalue,                         /* to String */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRGSTE');

 dcl CDRSMXC
     entry (type CDRASRV_CPGID_T byaddr nonasgn,     /* cp */
            type CDRASRV_ESIDA_T byaddr nonasgn,     /* es */
            type CDRASRV_CCSID_T byaddr,             /* ccsid */
            type CDRASRV_ESIDA_T byaddr,             /* esr */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRSMXC');

 dcl CDRSCSP
     entry (fixed bin (31) byaddr nonasgn,           /* cscpl */
            fixed bin (31) byaddr nonasgn,           /* n1 */
            type CDRASRV_ESIDA_T byaddr nonasgn,     /* esin */
            type CDRASRV_CCSID_T byaddr,             /* ccsidr */
            type CDRASRV_ESIDA_T byaddr,             /* esr */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRSCSP');

 dcl CDRCVRT
     entry (type CDRASRV_CCSID_T byaddr nonasgn,     /* ccsid1 */
            fixed bin (31) byaddr nonasgn,           /* StringType1 */
            pointer byvalue,                         /* to String1 */
            fixed bin (31) byaddr nonasgn,           /* Length1 */
            type CDRASRV_CCSID_T byaddr nonasgn,     /* ccsid2 */
            fixed bin (31) byaddr nonasgn,           /* StringType2 */
            fixed bin (31) byaddr nonasgn,           /* gccasn */
            fixed bin (31) byaddr nonasgn,           /* Length2 */
            pointer byvalue,                         /* to String2 */
            fixed bin (31) byaddr,                   /* OutLength */
            fixed bin (31) byaddr,                   /* ErrorByteNr */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRCVRT');

 dcl CDRMSCI
     entry (type CDRASRV_CCSID_T byaddr nonasgn,     /* ccsid1 */
            fixed bin (31) byaddr nonasgn,           /* StringType1 */
            type CDRASRV_CCSID_T byaddr nonasgn,     /* ccsid2 */
            fixed bin (31) byaddr nonasgn,           /* StringType2 */
            fixed bin (31) byaddr nonasgn,           /* gccasn */
            fixed bin (31) byaddr,                   /* Token */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRMSCI');

 dcl CDRMSCP
     entry (fixed bin (31) byaddr nonasgn,           /* Token */
            pointer byvalue,                         /* to String1 */
            fixed bin (31) byaddr nonasgn,           /* Length1 */
            fixed bin (31) byaddr nonasgn,           /* Length2 */
            pointer byvalue,                         /* to String2 */
            fixed bin (31) byaddr,                   /* OutLength */
            fixed bin (31) byaddr,                   /* ErrorByteNr */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRMSCP');

 dcl CDRMSCC
     entry (fixed bin (31) byaddr,                   /* Token */
            type CDRASRV_FeedBack_T byaddr)          /* FeedBack */
     CDRASRV_Entry external ('CDRMSCC');

 %end;
