 /*********************************************************************/
 /*                                                                   */
 /*  commdlg.cpy -- This module defines the 32-Bit Common Dialog APIs */
 /*                                                                   */
 /*   Copyright 1992 - 1998 Microsoft Corp. All rights reserved.      */
 /*                                                                   */
 /*********************************************************************/
 %dcl #INC_COMMDLG char ext;
 %if #INC_COMMDLG = '' %then %do;
 %#INC_COMMDLG = 'Y';

 %dcl WINVER fixed ext;
 %dcl UNICODE char ext;

 %dcl #WINGDI_ char ext;
 %if #WINGDI_ = '' %then %do;
 %include wingdi;
 %end;
 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = '' %then %do;
 %include winuser;
 %end;
 %dcl #PRSHT_H_ char ext;
 %if #PRSHT_H_ = '' %then %do;
 %include prsht;
 %end;

 /* Note: byte packing throughout */


 %if WINVER >= 1024 %then %do;
 %dcl SNDMSG char ext;
 %if SNDMSG = '' %then %do;
 %SNDMSG = 'SendMessage';
 %end; /* ifndef SNDMSG */
 %end; /* WINVER >= 0x0400 */

 define alias LPOFNHOOKPROC
        entry (type HWND,
               type UINT,
               type WPARAM,
               type LPARAM)
        returns (type UINT byvalue optional)
        limited APIENTRY;

 %dcl #CDSIZEOF_STRUCT char ext;
 %if #CDSIZEOF_STRUCT = '' %then %do;
 %#CDSIZEOF_STRUCT = 'Y';
 %dcl CDSIZEOF_STRUCT entry;
 %CDSIZEOF_STRUCT: proc (structname, member) returns (char);
  dcl (structname, member) char;
   return ('location (bind (: ' || structname || ', sysnull() :) => ' ||
                      member || ') + ' ||
           'stg (bind (: ' || structname || ', sysnull() :) => ' ||
                 member || ')');
 %end CDSIZEOF_STRUCT;
 %end;

 define structure
   1 OPENFILENAMEA,
     2 lStructSize       type DWORD,
     2 hwndOwner         type HWND,
     2 hInstance         type HINSTANCE,
     2 lpstrFilter       type LPCSTR,
     2 lpstrCustomFilter type LPSTR,
     2 nMaxCustFilter    type DWORD,
     2 nFilterIndex      type DWORD,
     2 lpstrFile         type LPSTR,
     2 nMaxFile          type DWORD,
     2 lpstrFileTitle    type LPSTR,
     2 nMaxFileTitle     type DWORD,
     2 lpstrInitialDir   type LPCSTR,
     2 lpstrTitle        type LPCSTR,
     2 Flags             type DWORD,
     2 nFileOffset       type WORD,
     2 nFileExtension    type WORD,
     2 lpstrDefExt       type LPCSTR,
     2 lCustData         type LPARAM,
     2 lpfnHook          type LPOFNHOOKPROC,
     2 lpTemplateName    type LPCSTR
 %if #WIN32_WINNT >= 1280 %then %do;
   , 2 pvReserved        pointer
   , 2 dwReserved        type DWORD
   , 2 FlagsEx           type DWORD
 %end; /* (_WIN32_WINNT >= 0x0500) */
   ;
 define alias LPOPENFILENAMEA handle OPENFILENAMEA;

 define structure
   1 OPENFILENAMEW,
     2 lStructSize       type DWORD,
     2 hwndOwner         type HWND,
     2 hInstance         type HINSTANCE,
     2 lpstrFilter       type LPCWSTR,
     2 lpstrCustomFilter type LPWSTR,
     2 nMaxCustFilter    type DWORD,
     2 nFilterIndex      type DWORD,
     2 lpstrFile         type LPWSTR,
     2 nMaxFile          type DWORD,
     2 lpstrFileTitle    type LPWSTR,
     2 nMaxFileTitle     type DWORD,
     2 lpstrInitialDir   type LPCWSTR,
     2 lpstrTitle        type LPCWSTR,
     2 Flags             type DWORD,
     2 nFileOffset       type WORD,
     2 nFileExtension    type WORD,
     2 lpstrDefExt       type LPCWSTR,
     2 lCustData         type LPARAM,
     2 lpfnHook          type LPOFNHOOKPROC,
     2 lpTemplateName    type LPCWSTR
 %if #WIN32_WINNT >= 1280 %then %do;
   , 2 pvReserved        pointer
   , 2 dwReserved        type DWORD
   , 2 FlagsEx           type DWORD
 %end; /* (_WIN32_WINNT >= 0x0500) */
   ;
 define alias LPOPENFILENAMEW handle OPENFILENAMEW;

 %if UNICODE ^= '' %then %do;
 define alias   OPENFILENAME type   OPENFILENAMEW;
 define alias LPOPENFILENAME type LPOPENFILENAMEW;
 %end; %else %do;
 define alias   OPENFILENAME type   OPENFILENAMEA;
 define alias LPOPENFILENAME type LPOPENFILENAMEA;
 %end; /* UNICODE */

 %if #WIN32_WINNT >= 1280 %then %do;
 dcl OPENFILENAME_SIZE_VERSION_400A fixed bin(31)
     value(CDSIZEOF_STRUCT (OPENFILENAMEA, lpTemplateName));
 dcl OPENFILENAME_SIZE_VERSION_400W fixed bin(31)
     value(CDSIZEOF_STRUCT(OPENFILENAMEW, lpTemplateName));
 %if UNICODE ^= '' %then %do;
 dcl OPENFILENAME_SIZE_VERSION_400 fixed bin(31)
     value(OPENFILENAME_SIZE_VERSION_400W);
 %end; %else %do;
 dcl OPENFILENAME_SIZE_VERSION_400 fixed bin(31)
     value(OPENFILENAME_SIZE_VERSION_400A);
 %end; /* UNICODE */
 %end; /* (_WIN32_WINNT >= 0x0500) */


 dcl GetOpenFileNameA
     entry (type OPENFILENAMEA byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetOpenFileNameA');

 dcl GetOpenFileNameW
     entry (type OPENFILENAMEW byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetOpenFileNameW');

 %dcl GetOpenFileName char ext;
 %if UNICODE ^= '' %then %do;
   %GetOpenFileName='GetOpenFileNameW';
 %end; %else %do;
   %GetOpenFileName='GetOpenFileNameA';
 %end; /* !UNICODE */

 dcl GetSaveFileNameA
     entry (type OPENFILENAMEA byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetSaveFileNameA');

 dcl GetSaveFileNameW
     entry (type OPENFILENAMEW byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('GetSaveFileNameW');

 %dcl GetSaveFileName char ext;
 %if UNICODE ^= '' %then %do;
   %GetSaveFileName='GetSaveFileNameW';
 %end; %else %do;
   %GetSaveFileName='GetSaveFileNameA';
 %end; /* !UNICODE */

 dcl GetFileTitleA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr optional,
            type WORD)
     returns (fixed bin(15) byvalue optional)
     APIENTRY external('GetFileTitleA');

 dcl GetFileTitleW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr optional,
            type WORD)
     returns (fixed bin(15) byvalue optional)
     APIENTRY external('GetFileTitleW');

 %dcl GetFileTitle char ext;
 %if UNICODE ^= '' %then %do;
   %GetFileTitle='GetFileTitleW';
 %end; %else %do;
   %GetFileTitle='GetFileTitleA';
 %end; /* !UNICODE */

 %dcl #OFN_READONLY fixed ext; %#OFN_READONLY = 1; /* ==> vfw.cpy */
 dcl OFN_READONLY             type DWORD value('00000001'xu);
 dcl OFN_OVERWRITEPROMPT      type DWORD value('00000002'xu);
 dcl OFN_HIDEREADONLY         type DWORD value('00000004'xu);
 dcl OFN_NOCHANGEDIR          type DWORD value('00000008'xu);
 dcl OFN_SHOWHELP             type DWORD value('00000010'xu);
 dcl OFN_ENABLEHOOK           type DWORD value('00000020'xu);
 dcl OFN_ENABLETEMPLATE       type DWORD value('00000040'xu);
 dcl OFN_ENABLETEMPLATEHANDLE type DWORD value('00000080'xu);
 dcl OFN_NOVALIDATE           type DWORD value('00000100'xu);
 dcl OFN_ALLOWMULTISELECT     type DWORD value('00000200'xu);
 dcl OFN_EXTENSIONDIFFERENT   type DWORD value('00000400'xu);
 dcl OFN_PATHMUSTEXIST        type DWORD value('00000800'xu);
 dcl OFN_FILEMUSTEXIST        type DWORD value('00001000'xu);
 dcl OFN_CREATEPROMPT         type DWORD value('00002000'xu);
 dcl OFN_SHAREAWARE           type DWORD value('00004000'xu);
 dcl OFN_NOREADONLYRETURN     type DWORD value('00008000'xu);
 dcl OFN_NOTESTFILECREATE     type DWORD value('00010000'xu);
 dcl OFN_NONETWORKBUTTON      type DWORD value('00020000'xu);
 dcl OFN_NOLONGNAMES          type DWORD value('00040000'xu);
     /* force no long names for 4.x modules */

 %if WINVER >= 1024 %then %do;
 dcl OFN_EXPLORER             type DWORD value('00080000'xu);
     /* new look commdlg */
 dcl OFN_NODEREFERENCELINKS   type DWORD value('00100000'xu);
 dcl OFN_LONGNAMES            type DWORD value('00200000'xu);
     /* force long names for 3.x modules */
 dcl OFN_ENABLEINCLUDENOTIFY  type DWORD value('00400000'xu);
     /* send include message to callback */
 dcl OFN_ENABLESIZING         type DWORD value('00800000'xu);
 %end; /* WINVER >= 0x0400 */
 %if #WIN32_WINNT >= 1280 %then %do;
 dcl OFN_DONTADDTORECENT      type DWORD value('02000000'xu);
 dcl OFN_FORCESHOWHIDDEN      type DWORD value('01000000'xu);
     /* Show All files including System and hidden files */
 %end; /* (_WIN32_WINNT >= 0x0500) */

 /* FlagsEx Values */
 %if #WIN32_WINNT >= 1280 %then %do;
 dcl OFN_EX_NOPLACESBAR       type DWORD value('00000001'xu);
 %end; /* (_WIN32_WINNT >= 0x0500) */

 /* Return values for the registered message sent to the hook function*/
 /* when a sharing violation occurs.  OFN_SHAREFALLTHROUGH allows the */
 /* filename to be accepted, OFN_SHARENOWARN rejects the name but puts*/
 /* up no warning (returned when the app has already put up a warning */
 /* message), and OFN_SHAREWARN puts up the default warning message   */
 /* for sharing violations.                                           */
 /*                                                                   */
 /* Note:  Undefined return values map to OFN_SHAREWARN, but are      */
 /*        reserved for future use.                                   */

 dcl OFN_SHAREFALLTHROUGH fixed bin(31) value(2);
 dcl OFN_SHARENOWARN      fixed bin(31) value(1);
 dcl OFN_SHAREWARN        fixed bin(31) value(0);

 define alias LPCCHOOKPROC
        entry (type HWND,
               type UINT,
               type WPARAM,
               type LPARAM)
        returns (type UINT byvalue optional)
        limited APIENTRY;

 %if WINVER >= 1024 %then %do;
 /* Structure used for all file based OpenFileName notifications */
 define structure
   1 OFNOTIFYA,
     2 hdr     type NMHDR,
     2 lpOFN   type LPOPENFILENAMEA,
     2 pszFile type LPSTR;/* May be SYSNULL */
 define alias LPOFNOTIFYA handle OFNOTIFYA;

 /* Structure used for all file based OpenFileName notifications */
 define structure
   1 OFNOTIFYW,
     2 hdr     type NMHDR,
     2 lpOFN   type LPOPENFILENAMEW,
     2 pszFile type LPWSTR;/* May be SYSNULL */
 define alias LPOFNOTIFYW handle OFNOTIFYW;

 %if UNICODE ^= '' %then %do;
 define alias   OFNOTIFY type   OFNOTIFYW;
 define alias LPOFNOTIFY type LPOFNOTIFYW;
 %end; %else %do;
 define alias   OFNOTIFY type   OFNOTIFYA;
 define alias LPOFNOTIFY type LPOFNOTIFYA;
 %end; /* UNICODE */


 /* Structure used for all object based OpenFileName notifications */
 define structure
   1 OFNOTIFYEXA,
     2 hdr   type NMHDR,
     2 lpOFN type LPOPENFILENAMEA,
     2 psf   type LPVOID,
     2 pidl  type LPVOID;/* May be SYSNULL */
 define alias LPOFNOTIFYEXA handle OFNOTIFYEXA;

 /* Structure used for all object based OpenFileName notifications */
 define structure
   1 OFNOTIFYEXW,
     2 hdr   type NMHDR,
     2 lpOFN type LPOPENFILENAMEW,
     2 psf   type LPVOID,
     2 pidl  type LPVOID;/* May be SYSNULL */
 define alias LPOFNOTIFYEXW handle OFNOTIFYEXW;

 %if UNICODE ^= '' %then %do;
 define alias   OFNOTIFYEX type   OFNOTIFYEXW;
 define alias LPOFNOTIFYEX type LPOFNOTIFYEXW;
 %end; %else %do;
 define alias   OFNOTIFYEX type   OFNOTIFYEXA;
 define alias LPOFNOTIFYEX type LPOFNOTIFYEXA;
 %end; /* UNICODE */

 dcl CDN_FIRST          fixed bin(31) value (0 - 601);
 dcl CDN_LAST           fixed bin(31) value (0 - 699);


 /* Notifications when Open or Save dialog status changes */
 dcl CDN_INITDONE       fixed bin(31) value(CDN_FIRST-'0000'xn);
 dcl CDN_SELCHANGE      fixed bin(31) value(CDN_FIRST-'0001'xn);
 dcl CDN_FOLDERCHANGE   fixed bin(31) value(CDN_FIRST-'0002'xn);
 dcl CDN_SHAREVIOLATION fixed bin(31) value(CDN_FIRST-'0003'xn);
 dcl CDN_HELP           fixed bin(31) value(CDN_FIRST-'0004'xn);
 dcl CDN_FILEOK         fixed bin(31) value(CDN_FIRST-'0005'xn);
 dcl CDN_TYPECHANGE     fixed bin(31) value(CDN_FIRST-'0006'xn);
 dcl CDN_INCLUDEITEM    fixed bin(31) value(CDN_FIRST-'0007'xn);

 dcl CDM_FIRST          fixed bin(31) value(WM_USER + 100);
 dcl CDM_LAST           fixed bin(31) value(WM_USER + 200);

 /* Messages to query information from the Open or Save dialogs */

 /* lParam = pointer to text buffer that gets filled in         */
 /* wParam = max number of characters of the text buffer        */
 /*          (including NULL)                                   */
 /* return = < 0 if error; number of characters needed          */
 /*          (including NULL)                                   */
 dcl CDM_GETSPEC fixed bin(31) value(CDM_FIRST+'0000'xn);

 CommDlg_OpenSave_GetSpecA: proc (_hdlg, _psz, _cbmax)
                            returns (type LRESULT byvalue optional)
                            options (inline reorder) internal;
   dcl _hdlg  type HWND byvalue,
       _psz   char (*) varz byaddr,
       _cbmax type WPARAM byvalue;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (_hdlg, CDM_GETSPEC, _cbmax, binvalue (addr (_psz))));
 end CommDlg_OpenSave_GetSpecA;

 CommDlg_OpenSave_GetSpecW: proc (_hdlg, _psz, _cbmax)
                            returns (type LRESULT byvalue optional)
                            options (inline reorder) internal;
   dcl _hdlg  type HWND byvalue,
       _psz   WCHAR (*) varz byaddr,
       _cbmax type WPARAM byvalue;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (_hdlg, CDM_GETSPEC, _cbmax, binvalue (addr (_psz))));
 end CommDlg_OpenSave_GetSpecW;

 %dcl CommDlg_OpenSave_GetSpec char ext;
 %if UNICODE ^= '' %then %do;
   %CommDlg_OpenSave_GetSpec='CommDlg_OpenSave_GetSpecW';
 %end; %else %do;
   %CommDlg_OpenSave_GetSpec='CommDlg_OpenSave_GetSpecA';
 %end; /* !UNICODE */

 /* lParam = pointer to text buffer that gets filled in   */
 /* wParam = max number of characters of the text buffer  */
 /*          (including NULL)                             */
 /* return = < 0 if error; number of characters needed    */
 /*          (including NULL)                             */
 dcl CDM_GETFILEPATH fixed bin(31) value(CDM_FIRST+'0001'xn);

 CommDlg_OpenSave_GetFilePathA: proc (_hdlg, _psz, _cbmax)
                                returns (type LRESULT byvalue optional)
                                options (inline reorder) internal;
   dcl _hdlg  type HWND byvalue,
       _psz   char (*) varz byaddr,
       _cbmax type WPARAM byvalue;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (_hdlg, CDM_GETFILEPATH, _cbmax,
                   binvalue (addr (_psz))));
 end CommDlg_OpenSave_GetFilePathA;

 CommDlg_OpenSave_GetFilePathW: proc (_hdlg, _psz, _cbmax)
                                returns (type LRESULT byvalue optional)
                                options (inline reorder) internal;
   dcl _hdlg  type HWND byvalue,
       _psz   WCHAR (*) varz byaddr,
       _cbmax type WPARAM byvalue;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (_hdlg, CDM_GETFILEPATH, _cbmax,
                   binvalue (addr (_psz))));
 end CommDlg_OpenSave_GetFilePathW;

 %dcl CommDlg_OpenSave_GetFilePath char ext;
 %if UNICODE ^= '' %then %do;
   %CommDlg_OpenSave_GetFilePath='CommDlg_OpenSave_GetFilePathW';
 %end; %else %do;
   %CommDlg_OpenSave_GetFilePath='CommDlg_OpenSave_GetFilePathA';
 %end; /* !UNICODE */

 /* lParam = pointer to text buffer that gets filled in    */
 /* wParam = max number of characters of the text buffer   */
 /*          (including NULL)                              */
 /* return = < 0 if error; number of characters needed     */
 /*          (including NULL)                              */
 dcl CDM_GETFOLDERPATH fixed bin(31) value(CDM_FIRST+'0002'xn);

 CommDlg_OpenSave_GetFolderPathA: proc (_hdlg, _psz, _cbmax)
                                 returns (type LRESULT byvalue optional)
                                  options (inline reorder) internal;
   dcl _hdlg  type HWND byvalue,
       _psz   char (*) varz byaddr,
       _cbmax type WPARAM byvalue;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (_hdlg, CDM_GETFOLDERPATH, _cbmax,
                   binvalue (addr (_psz))));
 end CommDlg_OpenSave_GetFolderPathA;

 CommDlg_OpenSave_GetFolderPathW: proc (_hdlg, _psz, _cbmax)
                                 returns (type LRESULT byvalue optional)
                                  options (inline reorder) internal;
   dcl _hdlg  type HWND byvalue,
       _psz   WCHAR (*) varz byaddr,
       _cbmax type WPARAM byvalue;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (_hdlg, CDM_GETFOLDERPATH, _cbmax,
                   binvalue (addr (_psz))));
 end CommDlg_OpenSave_GetFolderPathW;

 %dcl CommDlg_OpenSave_GetFolderPath char ext;
 %if UNICODE ^= '' %then %do;
   %CommDlg_OpenSave_GetFolderPath='CommDlg_OpenSave_GetFolderPathW';
 %end; %else %do;
   %CommDlg_OpenSave_GetFolderPath='CommDlg_OpenSave_GetFolderPathA';
 %end; /* !UNICODE */

 /* lParam = pointer to ITEMIDLIST buffer that gets filled in */
 /* wParam = size of the ITEMIDLIST buffer                    */
 /* return = < 0 if error; length of buffer needed            */
 dcl CDM_GETFOLDERIDLIST fixed bin(31) value(CDM_FIRST+'0003'xn);

 CommDlg_OpenSave_GetFolderIDList: proc (_hdlg, _pidl, _cbmax)
                                 returns (type LRESULT byvalue optional)
                                   options (inline reorder) internal;
   dcl _hdlg  type HWND byvalue,
       _pidl  pointer byvalue, /* to buffer */
       _cbmax type WPARAM byvalue;
   dcl binvalue builtin;
   return (SNDMSG (_hdlg, CDM_GETFOLDERPATH, _cbmax, binvalue (_pidl)));
 end CommDlg_OpenSave_GetFolderIDList;

 /* lParam = pointer to a string     */
 /* wParam = ID of control to change */
 /* return = not used                */
 dcl CDM_SETCONTROLTEXT fixed bin(31) value(CDM_FIRST+'0004'xn);

 CommDlg_OpenSave_SetControlText: proc (_hdlg, _id, _text)
                                  options (inline reorder) internal;
   dcl _hdlg  type HWND byvalue,
       _id    type WPARAM byvalue,
       _text  char (*) varz byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   call SNDMSG (_hdlg, CDM_SETCONTROLTEXT, _id,
                binvalue (addr (_text)));
 end CommDlg_OpenSave_SetControlText;

 /* lParam = not used                */
 /* wParam = ID of control to change */
 /* return = not used                */
 dcl CDM_HIDECONTROL fixed bin(31) value(CDM_FIRST+'0005'xn);

 CommDlg_OpenSave_HideControl: proc (_hdlg, _id)
                               options (inline reorder) internal;
   dcl _hdlg  type HWND byvalue,
       _id    type WPARAM byvalue;
   call SNDMSG (_hdlg, CDM_HIDECONTROL, _id, 0);
 end CommDlg_OpenSave_HideControl;


 /* lParam = pointer to default extension (no dot) */
 /* wParam = not used                              */
 /* return = not used                              */
 dcl CDM_SETDEFEXT fixed bin(31) value(CDM_FIRST+'0006'xn);

 CommDlg_OpenSave_SetDefExt: proc (_hdlg, _pszext)
                             options (inline reorder) internal;
   dcl _hdlg   type HWND byvalue,
       _pszext char (*) varz byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   call SNDMSG (_hdlg, CDM_SETDEFEXT, 0,
                binvalue (addr (_pszext)));
 end CommDlg_OpenSave_SetDefExt;

 %end; /* WINVER >= 0x0400 */

 define structure
   1 CHOOSECOLORA,
     2 lStructSize    type DWORD,
     2 hwndOwner      type HWND,
     2 hInstance      type HWND,
     2 rgbResult      type COLORREF,
     2 lpCustColors   type LPCOLORREF,
     2 Flags          type DWORD,
     2 lCustData      type LPARAM,
     2 lpfnHook       type LPCCHOOKPROC,
     2 lpTemplateName type LPCSTR;
 define alias LPCHOOSECOLORA handle CHOOSECOLORA;

 define structure
   1 CHOOSECOLORW,
     2 lStructSize    type DWORD,
     2 hwndOwner      type HWND,
     2 hInstance      type HWND,
     2 rgbResult      type COLORREF,
     2 lpCustColors   type LPCOLORREF,
     2 Flags          type DWORD,
     2 lCustData      type LPARAM,
     2 lpfnHook       type LPCCHOOKPROC,
     2 lpTemplateName type LPCWSTR;
 define alias LPCHOOSECOLORW handle CHOOSECOLORW;

 %if UNICODE ^= '' %then %do;
 define alias   CHOOSECOLOR type   CHOOSECOLORW;
 define alias LPCHOOSECOLOR type LPCHOOSECOLORW;
 %end; %else %do;
 define alias   CHOOSECOLOR type   CHOOSECOLORA;
 define alias LPCHOOSECOLOR type LPCHOOSECOLORA;
 %end; /* UNICODE */

 dcl ChooseColorA
     entry (type CHOOSECOLORA byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('ChooseColorA');

 dcl ChooseColorW
     entry (type CHOOSECOLORW byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('ChooseColorW');

 %dcl ChooseColor char ext;
 %if UNICODE ^= '' %then %do;
   %ChooseColor='ChooseColorW';
 %end; %else %do;
   %ChooseColor='ChooseColorA';
 %end; /* !UNICODE */

 dcl CC_RGBINIT              type DWORD value('00000001'xu);
 dcl CC_FULLOPEN             type DWORD value('00000002'xu);
 dcl CC_PREVENTFULLOPEN      type DWORD value('00000004'xu);
 dcl CC_SHOWHELP             type DWORD value('00000008'xu);
 dcl CC_ENABLEHOOK           type DWORD value('00000010'xu);
 dcl CC_ENABLETEMPLATE       type DWORD value('00000020'xu);
 dcl CC_ENABLETEMPLATEHANDLE type DWORD value('00000040'xu);

 %if WINVER >= 1024 %then %do;
 dcl CC_SOLIDCOLOR           type DWORD value('00000080'xu);
 dcl CC_ANYCOLOR             type DWORD value('00000100'xu);
 %end; /* WINVER >= 0x0400 */

 define alias LPFRHOOKPROC
        entry (type HWND,
               type UINT,
               type WPARAM,
               type LPARAM)
        returns (type UINT byvalue optional)
        limited APIENTRY;

 define structure
   1 FINDREPLACEA,
     2 lStructSize      type DWORD,/* size of this struct 0x20 */
     2 hwndOwner        type HWND,/* handle to owner's window */
     2 hInstance        type HINSTANCE,/* instance handle of.EXE that */
                                      /* contains cust. dlg. template */
     2 Flags            type DWORD,/* one or more of the FR_?? */
     2 lpstrFindWhat    type LPSTR,/* ptr. to search string */
     2 lpstrReplaceWith type LPSTR,/* ptr. to replace string */
     2 wFindWhatLen     type WORD,/* size of find buffer */
     2 wReplaceWithLen  type WORD,/* size of replace buffer */
     2 lCustData        type LPARAM,/* data passed to hook fn. */
     2 lpfnHook         type LPFRHOOKPROC,/* ptr. to hook fn. or NULL */
     2 lpTemplateName   type LPCSTR;/* custom template name */
 define alias LPFINDREPLACEA handle FINDREPLACEA;

 define structure
   1 FINDREPLACEW,
     2 lStructSize      type DWORD,/* size of this struct 0x20 */
     2 hwndOwner        type HWND,/* handle to owner's window */
     2 hInstance        type HINSTANCE,/* instance handle of.EXE that */
                                      /* contains cust. dlg. template */
     2 Flags            type DWORD,/* one or more of the FR_?? */
     2 lpstrFindWhat    type LPWSTR,/* ptr. to search string */
     2 lpstrReplaceWith type LPWSTR,/* ptr. to replace string */
     2 wFindWhatLen     type WORD,/* size of find buffer */
     2 wReplaceWithLen  type WORD,/* size of replace buffer */
     2 lCustData        type LPARAM,/* data passed to hook fn. */
     2 lpfnHook         type LPFRHOOKPROC,/* ptr. to hook fn. or NULL */
     2 lpTemplateName   type LPCWSTR;/* custom template name */
 define alias LPFINDREPLACEW handle FINDREPLACEW;

 %if UNICODE ^= '' %then %do;
 define alias   FINDREPLACE type   FINDREPLACEW;
 define alias LPFINDREPLACE type LPFINDREPLACEW;
 %end; %else %do;
 define alias   FINDREPLACE type   FINDREPLACEA;
 define alias LPFINDREPLACE type LPFINDREPLACEA;
 %end; /* UNICODE */

 dcl FR_DOWN                 type DWORD value('00000001'xu);
 dcl FR_WHOLEWORD            type DWORD value('00000002'xu);
 dcl FR_MATCHCASE            type DWORD value('00000004'xu);
 dcl FR_FINDNEXT             type DWORD value('00000008'xu);
 dcl FR_REPLACE              type DWORD value('00000010'xu);
 dcl FR_REPLACEALL           type DWORD value('00000020'xu);
 dcl FR_DIALOGTERM           type DWORD value('00000040'xu);
 dcl FR_SHOWHELP             type DWORD value('00000080'xu);
 dcl FR_ENABLEHOOK           type DWORD value('00000100'xu);
 dcl FR_ENABLETEMPLATE       type DWORD value('00000200'xu);
 dcl FR_NOUPDOWN             type DWORD value('00000400'xu);
 dcl FR_NOMATCHCASE          type DWORD value('00000800'xu);
 dcl FR_NOWHOLEWORD          type DWORD value('00001000'xu);
 dcl FR_ENABLETEMPLATEHANDLE type DWORD value('00002000'xu);
 dcl FR_HIDEUPDOWN           type DWORD value('00004000'xu);
 dcl FR_HIDEMATCHCASE        type DWORD value('00008000'xu);
 dcl FR_HIDEWHOLEWORD        type DWORD value('00010000'xu);

 dcl FindTextA
     entry (type FINDREPLACEA byaddr)
     returns (type HWND byvalue optional)
     APIENTRY external('FindTextA');

 dcl FindTextW
     entry (type FINDREPLACEW byaddr)
     returns (type HWND byvalue optional)
     APIENTRY external('FindTextW');

 %dcl FindText char ext;
 %if UNICODE ^= '' %then %do;
   %FindText='FindTextW';
 %end; %else %do;
   %FindText='FindTextA';
 %end; /* !UNICODE */

 dcl ReplaceTextA
     entry (type FINDREPLACEA byaddr)
     returns(type HWND byvalue optional)
     APIENTRY external('ReplaceTextA');

 dcl ReplaceTextW
     entry (type FINDREPLACEW byaddr)
     returns (type HWND byvalue optional)
     APIENTRY external('ReplaceTextW');

 %dcl ReplaceText char ext;
 %if UNICODE ^= '' %then %do;
   %ReplaceText='ReplaceTextW';
 %end; %else %do;
   %ReplaceText='ReplaceTextA';
 %end; /* !UNICODE */

 define alias LPCFHOOKPROC
        entry (type HWND,
               type UINT,
               type WPARAM,
               type LPARAM)
        returns (type UINT byvalue optional)
        limited APIENTRY;

 define structure
   1 CHOOSEFONTA,
     2 lStructSize    type DWORD,
     2 hwndOwner      type HWND,/* caller's window handle */
     2 hDC            type HDC, /* printer DC/IC or NULL */
     2 lpLogFont      type LPLOGFONTA,/* ptr. to a LOGFONT struct */
     2 iPointSize     type INT,/* 10 * size in points of selected font*/
     2 Flags          type DWORD,/* enum. type flags */
     2 rgbColors      type COLORREF,/* returned text color */
     2 lCustData      type LPARAM,/* data passed to hook fn. */
     2 lpfnHook       type LPCFHOOKPROC,/* ptr. to hook function */
     2 lpTemplateName type LPCSTR,/* custom template name */
     2 hInstance      type HINSTANCE,/* instance handle of.EXE that */
                                     /* contains cust. dlg. template */
     2 lpszStyle      type LPSTR,/* return the style field here */
                                 /* must be LF_FACESIZE or bigger */
     2 nFontType      type WORD,/* same value reported to the*/
                                /* EnumFonts call back with the  */
                                /* extra FONTTYPE_ bits added */
     2 #__MISSING_ALIGNMENT__ type WORD,
     2 nSizeMin       type INT, /* minimum pt size allowed & */
     2 nSizeMax       type INT; /* max pt size allowed if */
                                /* CF_LIMITSIZE is used */
 define alias LPCHOOSEFONTA handle CHOOSEFONTA;

 define structure
   1 CHOOSEFONTW,
     2 lStructSize    type DWORD,
     2 hwndOwner      type HWND,/* caller's window handle */
     2 hDC            type HDC, /* printer DC/IC or NULL */
     2 lpLogFont      type LPLOGFONTW,/* ptr. to a LOGFONT struct */
     2 iPointSize     type INT,/* 10 * size in points of selected font*/
     2 Flags          type DWORD,/* enum. type flags */
     2 rgbColors      type COLORREF,/* returned text color */
     2 lCustData      type LPARAM,/* data passed to hook fn. */
     2 lpfnHook       type LPCFHOOKPROC,/* ptr. to hook function */
     2 lpTemplateName type LPCWSTR,/* custom template name */
     2 hInstance      type HINSTANCE,/* instance handle of.EXE that */
                                     /* contains cust. dlg. template */
     2 lpszStyle      type LPWSTR,/* return the style field here */
                                  /* must be LF_FACESIZE or bigger */
     2 nFontType      type WORD,/* same value reported to the*/
                                /* EnumFonts call back with the  */
                                /* extra FONTTYPE_ bits added */
     2 #__MISSING_ALIGNMENT__ type WORD,
     2 nSizeMin       type INT, /* minimum pt size allowed & */
     2 nSizeMax       type INT; /* max pt size allowed if */
                                /* CF_LIMITSIZE is used */
 define alias LPCHOOSEFONTW handle CHOOSEFONTW;

 %if UNICODE ^= '' %then %do;
 define alias   CHOOSEFONT type   CHOOSEFONTW;
 define alias LPCHOOSEFONT type LPCHOOSEFONTW;
 %end; %else %do;
 define alias   CHOOSEFONT type   CHOOSEFONTA;
 define alias LPCHOOSEFONT type LPCHOOSEFONTA;
 %end; /* UNICODE */

 dcl ChooseFontA
     entry (type CHOOSEFONTA byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('ChooseFontA');

 dcl ChooseFontW
     entry (type CHOOSEFONTW byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('ChooseFontW');

 %dcl ChooseFont char ext;
 %if UNICODE ^= '' %then %do;
 %ChooseFont='ChooseFontW';
 %end; %else %do;
   %ChooseFont='ChooseFontA';
 %end; /* !UNICODE */

 dcl CF_SCREENFONTS          type DWORD value('00000001'xu);
 dcl CF_PRINTERFONTS         type DWORD value('00000002'xu);
 dcl CF_BOTH                 type DWORD
     value( ior (CF_SCREENFONTS, CF_PRINTERFONTS));
 dcl CF_SHOWHELP             type DWORD value('00000004'xu);
 dcl CF_ENABLEHOOK           type DWORD value('00000008'xu);
 dcl CF_ENABLETEMPLATE       type DWORD value('00000010'xu);
 dcl CF_ENABLETEMPLATEHANDLE type DWORD value('00000020'xu);
 dcl CF_INITTOLOGFONTSTRUCT  type DWORD value('00000040'xu);
 dcl CF_USESTYLE             type DWORD value('00000080'xu);
 dcl CF_EFFECTS              type DWORD value('00000100'xu);
 dcl CF_APPLY                type DWORD value('00000200'xu);
 dcl CF_ANSIONLY             type DWORD value('00000400'xu);
 %if WINVER >= 1024 %then %do;
 dcl CF_SCRIPTSONLY          type DWORD value(CF_ANSIONLY);
 %end; /* WINVER >= 0x0400 */
 dcl CF_NOVECTORFONTS        type DWORD value('00000800'xu);
 dcl CF_NOOEMFONTS           type DWORD value(CF_NOVECTORFONTS);
 dcl CF_NOSIMULATIONS        type DWORD value('00001000'xu);
 dcl CF_LIMITSIZE            type DWORD value('00002000'xu);
 dcl CF_FIXEDPITCHONLY       type DWORD value('00004000'xu);
 dcl CF_WYSIWYG              type DWORD value('00008000'xu);
     /* must also have CF_SCREENFONTS & CF_PRINTERFONTS */
 dcl CF_FORCEFONTEXIST       type DWORD value('00010000'xu);
 dcl CF_SCALABLEONLY         type DWORD value('00020000'xu);
 dcl CF_TTONLY               type DWORD value('00040000'xu);
 dcl CF_NOFACESEL            type DWORD value('00080000'xu);
 dcl CF_NOSTYLESEL           type DWORD value('00100000'xu);
 dcl CF_NOSIZESEL            type DWORD value('00200000'xu);
 %if WINVER >= 1024 %then %do;
 dcl CF_SELECTSCRIPT         type DWORD value('00400000'xu);
 dcl CF_NOSCRIPTSEL          type DWORD value('00800000'xu);
 dcl CF_NOVERTFONTS          type DWORD value('01000000'xu);
 %end; /* WINVER >= 0x0400 */

 /* these are extra nFontType bits that are added to what is returned */
 /* to the EnumFonts callback routine                                 */

 dcl SIMULATED_FONTTYPE      fixed bin(31) value('8000'xn);
 dcl PRINTER_FONTTYPE        fixed bin(31) value('4000'xn);
 dcl SCREEN_FONTTYPE         fixed bin(31) value('2000'xn);
 dcl BOLD_FONTTYPE           fixed bin(31) value('0100'xn);
 dcl ITALIC_FONTTYPE         fixed bin(31) value('0200'xn);
 dcl REGULAR_FONTTYPE        fixed bin(31) value('0400'xn);

 /* EnumFonts callback routine only uses these bits, so we can use */
 /* the rest                                                       */

 /* dcl RASTER_FONTTYPE      fixed bin(31) value('001'xn) */
 /* dcl DEVICE_FONTTYPE      fixed bin(31) value('002'xn) */
 /* dcl TRUETYPE_FONTTYPE    fixed bin(31) value('004'xn) */

 %dcl WINNT char ext;
 %if WINNT ^= '' %then %do;
 dcl OPENTYPE_FONTTYPE       fixed bin(31) value('10000'xn);
 dcl TYPE1_FONTTYPE          fixed bin(31) value('20000'xn);
 dcl DSIG_FONTTYPE           fixed bin(31) value('40000'xn);
 %end;

 dcl WM_CHOOSEFONT_GETLOGFONT fixed bin(31) value(WM_USER + 1);
 dcl WM_CHOOSEFONT_SETLOGFONT fixed bin(31) value(WM_USER + 101);
 dcl WM_CHOOSEFONT_SETFLAGS   fixed bin(31) value(WM_USER + 102);


 /* strings used to obtain unique window message for communication */
 /* between dialog and caller                                      */

 dcl LBSELCHSTRINGA char  value('commdlg_LBSelChangedNotify');
 dcl SHAREVISTRINGA char  value('commdlg_ShareViolation');
 dcl FILEOKSTRINGA  char  value('commdlg_FileNameOK');
 dcl COLOROKSTRINGA char  value('commdlg_ColorOK');
 dcl SETRGBSTRINGA  char  value('commdlg_SetRGBColor');
 dcl HELPMSGSTRINGA char  value('commdlg_help');
 dcl FINDMSGSTRINGA char  value('commdlg_FindReplace');

 dcl LBSELCHSTRINGW WCHAR value('commdlg_LBSelChangedNotify');
 dcl SHAREVISTRINGW WCHAR value('commdlg_ShareViolation');
 dcl FILEOKSTRINGW  WCHAR value('commdlg_FileNameOK');
 dcl COLOROKSTRINGW WCHAR value('commdlg_ColorOK');
 dcl SETRGBSTRINGW  WCHAR value('commdlg_SetRGBColor');
 dcl HELPMSGSTRINGW WCHAR value('commdlg_help');
 dcl FINDMSGSTRINGW WCHAR value('commdlg_FindReplace');


 %dcl LBSELCHSTRING char ext;
 %dcl SHAREVISTRING char ext;
 %dcl FILEOKSTRING  char ext;
 %dcl COLOROKSTRING char ext;
 %dcl SETRGBSTRING  char ext;
 %dcl HELPMSGSTRING char ext;
 %dcl FINDMSGSTRING char ext;
 %if UNICODE ^= '' %then %do;
 %LBSELCHSTRING = 'LBSELCHSTRINGW';
 %SHAREVISTRING = 'SHAREVISTRINGW';
 %FILEOKSTRING  = 'FILEOKSTRINGW';
 %COLOROKSTRING = 'COLOROKSTRINGW';
 %SETRGBSTRING  = 'SETRGBSTRINGW';
 %HELPMSGSTRING = 'HELPMSGSTRINGW';
 %FINDMSGSTRING = 'FINDMSGSTRINGW';
 %end; %else %do;
 %LBSELCHSTRING = 'LBSELCHSTRINGA';
 %SHAREVISTRING = 'SHAREVISTRINGA';
 %FILEOKSTRING  = 'FILEOKSTRINGA';
 %COLOROKSTRING = 'COLOROKSTRINGA';
 %SETRGBSTRING  = 'SETRGBSTRINGA';
 %HELPMSGSTRING = 'HELPMSGSTRINGA';
 %FINDMSGSTRING = 'FINDMSGSTRINGA';
 %end;

 /* HIWORD values for lParam of commdlg_LBSelChangeNotify message */
 dcl CD_LBSELNOITEMS fixed bin(31) value(-1);
 dcl CD_LBSELCHANGE  fixed bin(31) value(0);
 dcl CD_LBSELSUB     fixed bin(31) value(1);
 dcl CD_LBSELADD     fixed bin(31) value(2);

 define alias LPPRINTHOOKPROC
        entry (type HWND,
               type UINT,
               type WPARAM,
               type LPARAM)
        returns (type UINT byvalue optional)
        limited APIENTRY;

 define alias LPSETUPHOOKPROC
        entry (type HWND,
               type UINT,
               type WPARAM,
               type LPARAM)
     returns (type UINT byvalue optional)
        limited APIENTRY ;

 define structure
   1 PRINTDLGA unaligned,
     2 lStructSize         type DWORD,
     2 hwndOwner           type HWND,
     2 hDevMode            type HGLOBAL,
     2 hDevNames           type HGLOBAL,
     2 hDC                 type HDC,
     2 Flags               type DWORD,
     2 nFromPage           type WORD,
     2 nToPage             type WORD,
     2 nMinPage            type WORD,
     2 nMaxPage            type WORD,
     2 nCopies             type WORD,
     2 hInstance           type HINSTANCE,
     2 lCustData           type LPARAM,
     2 lpfnPrintHook       type LPPRINTHOOKPROC,
     2 lpfnSetupHook       type LPSETUPHOOKPROC,
     2 lpPrintTemplateName type LPCSTR,
     2 lpSetupTemplateName type LPCSTR,
     2 hPrintTemplate      type HGLOBAL,
     2 hSetupTemplate      type HGLOBAL;
 define alias LPPRINTDLGA handle PRINTDLGA;

 define structure
   1 PRINTDLGW unaligned,
     2 lStructSize         type DWORD,
     2 hwndOwner           type HWND,
     2 hDevMode            type HGLOBAL,
     2 hDevNames           type HGLOBAL,
     2 hDC                 type HDC,
     2 Flags               type DWORD,
     2 nFromPage           type WORD,
     2 nToPage             type WORD,
     2 nMinPage            type WORD,
     2 nMaxPage            type WORD,
     2 nCopies             type WORD,
     2 hInstance           type HINSTANCE,
     2 lCustData           type LPARAM,
     2 lpfnPrintHook       type LPPRINTHOOKPROC,
     2 lpfnSetupHook       type LPSETUPHOOKPROC,
     2 lpPrintTemplateName type LPCWSTR,
     2 lpSetupTemplateName type LPCWSTR,
     2 hPrintTemplate      type HGLOBAL,
     2 hSetupTemplate      type HGLOBAL;
 define alias LPPRINTDLGW handle PRINTDLGW;

 %if UNICODE ^= '' %then %do;
 define alias   PRINTDLG type   PRINTDLGW;
 define alias LPPRINTDLG type LPPRINTDLGW;
 %end; %else %do;
 define alias   PRINTDLG type   PRINTDLGA;
 define alias LPPRINTDLG type LPPRINTDLGA;
 %end; /* UNICODE */

 dcl PrintDlgA
     entry (type PRINTDLGA byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('PrintDlgA');

 dcl PrintDlgW
     entry (type PRINTDLGW byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('PrintDlgW');

 %dcl PrintDlg char ext;
 %if UNICODE ^= '' %then %do;
   %PrintDlg='PrintDlgW';
 %end; %else %do;
   %PrintDlg='PrintDlgA';
 %end; /* !UNICODE */

 %if WINVER >= 1280 %then %do;

 /* PL/I NOTE********************************************************/
 /* Dcl's for IPrintDialogCallback and IPrintDialogServices omitted */
 /* as there is no COM / ActiveX support in PL/I.                   */
 /*******************************************************************/

 /* Page Range structure for PrintDlgEx. */

 define structure
   1 PRINTPAGERANGE,
     2 nFromPage type DWORD,
     2 nToPage   type DWORD;
 define alias LPPRINTPAGERANGE handle PRINTPAGERANGE;

 /* PrintDlgEx structure. */

 define structure
   1 PRINTDLGEXA,
     2 lStructSize    type DWORD,  /* size of structure in bytes */
     2 hwndOwner      type HWND,   /* caller's window handle */
     2 hDevMode       type HGLOBAL,/* handle to DevMode */
     2 hDevNames      type HGLOBAL,/* handle to DevNames */
     2 hDC            type HDC,    /* printer DC/IC or NULL */
     2 Flags          type DWORD,  /* PD_ flags */
     2 Flags2         type DWORD,  /* reserved */
     2 ExclusionFlags type DWORD,
       /* items to exclude from driver pages */
     2 nPageRanges    type DWORD,  /* number of page ranges */
     2 nMaxPageRanges type DWORD,  /* max number of page ranges */
     2 lpPageRanges   type LPPRINTPAGERANGE,/* array of page ranges */
     2 nMinPage       type DWORD,  /* min page number */
     2 nMaxPage       type DWORD,  /* max page number */
     2 nCopies        type DWORD,  /* number of copies */
     2 hInstance      type HINSTANCE,/* instance handle */
     2 lpPrintTemplateName type LPCSTR,
       /* template name for app specific area */
     2 lpCallback     pointer, /* type LPUNKNOWN */
       /* app callback interface */
     2 nPropertyPages type DWORD,
       /* number of app property pages in lphPropertyPages */
     2 lphPropertyPages pointer, /* handle HPROPSHEETPAGE */
       /* array of app property page handles */
     2 nStartPage     type DWORD,  /* start page id */
     2 dwResultAction type DWORD;
       /* result action if S_OK is returned */
 define alias LPPRINTDLGEXA handle PRINTDLGEXA;

 /* PrintDlgEx structure. */

 define structure
   1 PRINTDLGEXW,
     2 lStructSize    type DWORD,  /* size of structure in bytes */
     2 hwndOwner      type HWND,   /* caller's window handle */
     2 hDevMode       type HGLOBAL,/* handle to DevMode */
     2 hDevNames      type HGLOBAL,/* handle to DevNames */
     2 hDC            type HDC,    /* printer DC/IC or NULL */
     2 Flags          type DWORD,  /* PD_ flags */
     2 Flags2         type DWORD,  /* reserved */
     2 ExclusionFlags type DWORD,
       /* items to exclude from driver pages */
     2 nPageRanges    type DWORD,  /* number of page ranges */
     2 nMaxPageRanges type DWORD,  /* max number of page ranges */
     2 lpPageRanges   type LPPRINTPAGERANGE,/* array of page ranges */
     2 nMinPage       type DWORD,  /* min page number */
     2 nMaxPage       type DWORD,  /* max page number */
     2 nCopies        type DWORD,  /* number of copies */
     2 hInstance      type HINSTANCE,/* instance handle */
     2 lpPrintTemplateName type LPCWSTR,
       /* template name for app specific area */
     2 lpCallback     pointer, /* type LPUNKNOWN */
       /* app callback interface */
     2 nPropertyPages type DWORD,
       /* number of app property pages in lphPropertyPages */
     2 lphPropertyPages pointer, /* handle HPROPSHEETPAGE */
       /* array of app property page handles */
     2 nStartPage     type DWORD,  /* start page id */
     2 dwResultAction type DWORD;
       /* result action if S_OK is returned */
 define alias LPPRINTDLGEXW handle PRINTDLGEXW;

 %if UNICODE ^= '' %then %do;
 define alias   PRINTDLGEX type   PRINTDLGEXW;
 define alias LPPRINTDLGEX type LPPRINTDLGEXW;
 %end; %else %do;
 define alias   PRINTDLGEX type   PRINTDLGEXA;
 define alias LPPRINTDLGEX type LPPRINTDLGEXA;
 %end; /* !UNICODE */

 dcl PrintDlgExA
     entry (type PRINTDLGEXA byaddr)
     returns (type HRESULT byvalue optional)
     APIENTRY external('PrintDlgExA');

 dcl PrintDlgExW
     entry (type PRINTDLGEXW byaddr)
     returns (type HRESULT byvalue optional)
     APIENTRY external('PrintDlgExW');

 %dcl PrintDlgEx char ext;
 %if UNICODE ^= '' %then %do;
   %PrintDlgEx='PrintDlgExW';
 %end; %else %do;
   %PrintDlgEx='PrintDlgExA';
 %end; /* !UNICODE */

 %end; /* WINVER >= 0x0500 */


 dcl PD_ALLPAGES                   type DWORD value('00000000'xu);
 dcl PD_SELECTION                  type DWORD value('00000001'xu);
 dcl PD_PAGENUMS                   type DWORD value('00000002'xu);
 dcl PD_NOSELECTION                type DWORD value('00000004'xu);
 dcl PD_NOPAGENUMS                 type DWORD value('00000008'xu);
 dcl PD_COLLATE                    type DWORD value('00000010'xu);
 dcl PD_PRINTTOFILE                type DWORD value('00000020'xu);
 dcl PD_PRINTSETUP                 type DWORD value('00000040'xu);
 dcl PD_NOWARNING                  type DWORD value('00000080'xu);
 dcl PD_RETURNDC                   type DWORD value('00000100'xu);
 dcl PD_RETURNIC                   type DWORD value('00000200'xu);
 dcl PD_RETURNDEFAULT              type DWORD value('00000400'xu);
 dcl PD_SHOWHELP                   type DWORD value('00000800'xu);
 dcl PD_ENABLEPRINTHOOK            type DWORD value('00001000'xu);
 dcl PD_ENABLESETUPHOOK            type DWORD value('00002000'xu);
 dcl PD_ENABLEPRINTTEMPLATE        type DWORD value('00004000'xu);
 dcl PD_ENABLESETUPTEMPLATE        type DWORD value('00008000'xu);
 dcl PD_ENABLEPRINTTEMPLATEHANDLE  type DWORD value('00010000'xu);
 dcl PD_ENABLESETUPTEMPLATEHANDLE  type DWORD value('00020000'xu);
 dcl PD_USEDEVMODECOPIES           type DWORD value('00040000'xu);
 dcl PD_USEDEVMODECOPIESANDCOLLATE type DWORD value('00040000'xu);
 dcl PD_DISABLEPRINTTOFILE         type DWORD value('00080000'xu);
 dcl PD_HIDEPRINTTOFILE            type DWORD value('00100000'xu);
 dcl PD_NONETWORKBUTTON            type DWORD value('00200000'xu);
 %if WINVER >= 1280 %then %do;
 dcl PD_CURRENTPAGE                type DWORD value('00400000'xu);
 dcl PD_NOCURRENTPAGE              type DWORD value('00800000'xu);
 dcl PD_EXCLUSIONFLAGS             type DWORD value('01000000'xu);
 dcl PD_USELARGETEMPLATE           type DWORD value('10000000'xu);
 %end; /* WINVER >= 0x0500 */

 %if WINVER >= 1280 %then %do;

 /* Exclusion flags for PrintDlgEx. */
 dcl PD_EXCL_COPIESANDCOLLATE      type DWORD
     value(ior(DM_COPIES, DM_COLLATE));

 /* Define the start page for the print dialog when using PrintDlgEx. */
 dcl START_PAGE_GENERAL            type DWORD value('ffffffff'xu);


 /* Result action ids for PrintDlgEx. */
 dcl PD_RESULT_CANCEL              type DWORD value(0);
 dcl PD_RESULT_PRINT               type DWORD value(1);
 dcl PD_RESULT_APPLY               type DWORD value(2);

 %end; /* WINVER >= 0x0500 */


 /*  Device Names structure for PrintDlg and PrintDlgEx. */
 define structure
   1 DEVNAMES,
     2 wDriverOffset type WORD,
     2 wDeviceOffset type WORD,
     2 wOutputOffset type WORD,
     2 wDefault      type WORD;
 define alias LPDEVNAMES handle DEVNAMES;

 dcl DN_DEFAULTPRN fixed bin(31) value('0001'xn);

 dcl CommDlgExtendedError
     entry ()
     returns (type DWORD byvalue optional)
     APIENTRY external('CommDlgExtendedError');


 %if WINVER >= 1024 %then %do;
 dcl WM_PSD_PAGESETUPDLG     fixed bin(31) value(WM_USER  );
 dcl WM_PSD_FULLPAGERECT     fixed bin(31) value(WM_USER+1);
 dcl WM_PSD_MINMARGINRECT    fixed bin(31) value(WM_USER+2);
 dcl WM_PSD_MARGINRECT       fixed bin(31) value(WM_USER+3);
 dcl WM_PSD_GREEKTEXTRECT    fixed bin(31) value(WM_USER+4);
 dcl WM_PSD_ENVSTAMPRECT     fixed bin(31) value(WM_USER+5);
 dcl WM_PSD_YAFULLPAGERECT   fixed bin(31) value(WM_USER+6);

 define alias LPPAGEPAINTHOOK
        entry (type HWND,
               type UINT,
               type WPARAM,
               type LPARAM)
        returns (type UINT byvalue optional)
        limited APIENTRY;

 define alias LPPAGESETUPHOOK
        entry (type HWND,
               type UINT,
               type WPARAM,
               type LPARAM)
        returns (type UINT byvalue optional)
        limited APIENTRY;

 define structure
   1 PAGESETUPDLGA,
     2 lStructSize             type DWORD,
     2 hwndOwner               type HWND,
     2 hDevMode                type HGLOBAL,
     2 hDevNames               type HGLOBAL,
     2 Flags                   type DWORD,
     2 ptPaperSize             type POINT,
     2 rtMinMargin             type RECT,
     2 rtMargin                type RECT,
     2 hInstance               type HINSTANCE,
     2 lCustData               type LPARAM,
     2 lpfnPageSetupHook       type LPPAGESETUPHOOK,
     2 lpfnPagePaintHook       type LPPAGEPAINTHOOK,
     2 lpPageSetupTemplateName type LPCSTR,
     2 hPageSetupTemplate      type HGLOBAL;
 define alias LPPAGESETUPDLGA handle PAGESETUPDLGA;

 define structure
   1 PAGESETUPDLGW,
     2 lStructSize             type DWORD,
     2 hwndOwner               type HWND,
     2 hDevMode                type HGLOBAL,
     2 hDevNames               type HGLOBAL,
     2 Flags                   type DWORD,
     2 ptPaperSize             type POINT,
     2 rtMinMargin             type RECT,
     2 rtMargin                type RECT,
     2 hInstance               type HINSTANCE,
     2 lCustData               type LPARAM,
     2 lpfnPageSetupHook       type LPPAGESETUPHOOK,
     2 lpfnPagePaintHook       type LPPAGEPAINTHOOK,
     2 lpPageSetupTemplateName type LPCWSTR,
     2 hPageSetupTemplate      type HGLOBAL;
 define alias LPPAGESETUPDLGW handle PAGESETUPDLGW;

 %if UNICODE ^= '' %then %do;
 define alias   PAGESETUPDLG type   PAGESETUPDLGW;
 define alias LPPAGESETUPDLG type LPPAGESETUPDLGW;
 %end; %else %do;
 define alias   PAGESETUPDLG type   PAGESETUPDLGA;
 define alias LPPAGESETUPDLG type LPPAGESETUPDLGA;
 %end; /* UNICODE */

 dcl PageSetupDlgA
     entry (type PAGESETUPDLGA byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('PageSetupDlgA');

 dcl PageSetupDlgW
     entry (type LPPAGESETUPDLGW byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('PageSetupDlgW');

 %dcl PageSetupDlg char ext;
 %if UNICODE ^= '' %then %do;
   %PageSetupDlg='PageSetupDlgW';
 %end; %else %do;
   %PageSetupDlg='PageSetupDlgA';
 %end; /* !UNICODE */

 dcl PSD_DEFAULTMINMARGINS            type DWORD value('00000000'xu);
     /* default (printer's) */
 dcl PSD_INWININIINTLMEASURE          type DWORD value('00000000'xu);
     /* 1st of 4 possible */

 dcl PSD_MINMARGINS                   type DWORD value('00000001'xu);
     /* use caller's */
 dcl PSD_MARGINS                      type DWORD value('00000002'xu);
     /* use caller's */
 dcl PSD_INTHOUSANDTHSOFINCHES        type DWORD value('00000004'xu);
     /* 2nd of 4 possible */
 dcl PSD_INHUNDREDTHSOFMILLIMETERS    type DWORD value('00000008'xu);
     /* 3rd of 4 possible */
 dcl PSD_DISABLEMARGINS               type DWORD value('00000010'xu);
 dcl PSD_DISABLEPRINTER               type DWORD value('00000020'xu);
 dcl PSD_NOWARNING                    type DWORD value('00000080'xu);
     /* must be same as PD_* */
 dcl PSD_DISABLEORIENTATION           type DWORD value('00000100'xu);
 dcl PSD_RETURNDEFAULT                type DWORD value('00000400'xu);
     /* must be same as PD_* */
 dcl PSD_DISABLEPAPER                 type DWORD value('00000200'xu);
 dcl PSD_SHOWHELP                     type DWORD value('00000800'xu);
     /* must be same as PD_* */
 dcl PSD_ENABLEPAGESETUPHOOK          type DWORD value('00002000'xu);
     /* must be same as PD_* */
 dcl PSD_ENABLEPAGESETUPTEMPLATE      type DWORD value('00008000'xu);
     /* must be same as PD_* */
 dcl PSD_ENABLEPAGESETUPTEMPLATEHANDLE
                                      type DWORD value('00020000'xu);
     /* must be same as PD_* */
 dcl PSD_ENABLEPAGEPAINTHOOK          type DWORD value('00040000'xu);
 dcl PSD_DISABLEPAGEPAINTING          type DWORD value('00080000'xu);
 dcl PSD_NONETWORKBUTTON              type DWORD value('00200000'xu);
     /* must be same as PD_* */
 %end; /* WINVER >= 0x0400 */

 %end; /* !_INC_COMMDLG */
