 /*++ BUILD Version: 0001                           */
 /*   Increment this if a change has global effects */

 /*********************************************************************/
 /*                                                                   */
 /*  ddeml.cpy -  DDEML API header file                               */
 /*                                                                   */
 /*               Version 3.10                                        */
 /*                                                                   */
 /* Copyright 1993 - 1998 Microsoft Corp.  All rights reserved.*      */
 /*                                                                   */
 /*                                                                   */
 /*********************************************************************/
 %dcl #INC_DDEMLH char ext;
 %if #INC_DDEMLH = '' %then %do;
 %#INC_DDEMLH = 'Y';

 %dcl UNICODE char ext;

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;

 /******** public types ********/

 DECLARE_HANDLE(HCONVLIST);
 DECLARE_HANDLE(HCONV);
 DECLARE_HANDLE(HSZ);
 DECLARE_HANDLE(HDDEDATA);
 /* following is not used, so why define it= */
 /* %dcl EXPENTRY char ext  */
 /* %EXPENTRY='CALLBACK'    */

 /* the following structure is for use with XTYP_WILDCONNECT */
 /* processing.                                              */

 define structure
   1 HSZPAIR,
     2 hszSvc   type HSZ,
     2 hszTopic type HSZ;

 define alias PHSZPAIR handle HSZPAIR;

 /* The following structure is used by DdeConnect() and       */
 /* DdeConnectList() and by XTYP_CONNECT and XTYP_WILDCONNECT */
 /* callbacks.                                                */

 define structure
   1 CONVCONTEXT,
     2 cb         type UINT,/* set to size(:CONVCONTEXT:) */
     2 wFlags     type UINT,/* none currently defined. */
     2 wCountryID type UINT,
                  /* country code for topic/item strings used. */
     2 iCodePage  fixed bin(31),
                  /* codepage used for topic/item strings. */
     2 dwLangID   type DWORD,/* language ID for topic/item strings. */
     2 dwSecurity type DWORD,/* Private security code. */
     2 qos        type SECURITY_QUALITY_OF_SERVICE;
                  /* client side's quality of service */

 define alias PCONVCONTEXT handle CONVCONTEXT;


 /* The following structure is used by DdeQueryConvInfo(): */

 define structure
   1 CONVINFO,
     2 cb            type DWORD,/* sizeof(CONVINFO) */
     2 hUser         type DWORD,/* user specified field */
     2 hConvPartner  type HCONV,
                     /* hConv on other end or 0 if non-ddemgr partner */
     2 hszSvcPartner type HSZ,/* app name of partner if obtainable */
     2 hszServiceReq type HSZ,/* AppName requested for connection */
     2 hszTopic      type HSZ,/* Topic name for conversation */
     2 hszItem       type HSZ,
                     /* transaction item name or SYSNULL if quiescent */
     2 wFmt          type UINT,
                     /* transaction format or SYSNULL if quiescent */
     2 wType         type UINT,/* XTYP_ for current transaction */
     2 wStatus       type UINT,
                     /* ST_ constant for current conversation */
     2 wConvst       type UINT,
                     /* XST_ constant for current transaction */
     2 wLastError    type UINT,/* last transaction error. */
     2 hConvList     type HCONVLIST,
                /* parent hConvList if this conversation is in a list */
     2 ConvCtxt      type CONVCONTEXT,/* conversation context */
     2 hwnd          type HWND,/* window handle for this conversation */
     2 hwndPartner   type HWND;
                     /* partner window handle for this conversation */

 define alias PCONVINFO handle CONVINFO;

 /***** conversation states (usState) *****/

 dcl XST_NULL           fixed bin(31) value(0);
 /* quiescent states */
 dcl XST_INCOMPLETE     fixed bin(31) value(1);
 dcl XST_CONNECTED      fixed bin(31) value(2);
 dcl XST_INIT1          fixed bin(31) value(3);
 /* mid-initiation states */
 dcl XST_INIT2          fixed bin(31) value(4);
 dcl XST_REQSENT        fixed bin(31) value(5);
 /* active conversation states */
 dcl XST_DATARCVD       fixed bin(31) value(6);
 dcl XST_POKESENT       fixed bin(31) value(7);
 dcl XST_POKEACKRCVD    fixed bin(31) value(8);
 dcl XST_EXECSENT       fixed bin(31) value(9);
 dcl XST_EXECACKRCVD    fixed bin(31) value(10);
 dcl XST_ADVSENT        fixed bin(31) value(11);
 dcl XST_UNADVSENT      fixed bin(31) value(12);
 dcl XST_ADVACKRCVD     fixed bin(31) value(13);
 dcl XST_UNADVACKRCVD   fixed bin(31) value(14);
 dcl XST_ADVDATASENT    fixed bin(31) value(15);
 dcl XST_ADVDATAACKRCVD fixed bin(31) value(16);

 /* used in LOWORD(dwData1) of XTYP_ADVREQ callbacks... */
 dcl CADV_LATEACK       fixed bin(16) unsigned value('FFFF'xn);

 /***** conversation status bits (fsStatus) *****/

 dcl ST_CONNECTED       fixed bin(16) unsigned value('0001'xn);
 dcl ST_ADVISE          fixed bin(16) unsigned value('0002'xn);
 dcl ST_ISLOCAL         fixed bin(16) unsigned value('0004'xn);
 dcl ST_BLOCKED         fixed bin(16) unsigned value('0008'xn);
 dcl ST_CLIENT          fixed bin(16) unsigned value('0010'xn);
 dcl ST_TERMINATED      fixed bin(16) unsigned value('0020'xn);
 dcl ST_INLIST          fixed bin(16) unsigned value('0040'xn);
 dcl ST_BLOCKNEXT       fixed bin(16) unsigned value('0080'xn);
 dcl ST_ISSELF          fixed bin(16) unsigned value('0100'xn);

 /* DDE constants for wStatus field */

 dcl DDE_FACK           fixed bin(16) unsigned value('8000'xn);
 dcl DDE_FBUSY          fixed bin(16) unsigned value('4000'xn);
 dcl DDE_FDEFERUPD      fixed bin(16) unsigned value('4000'xn);
 dcl DDE_FACKREQ        fixed bin(16) unsigned value('8000'xn);
 dcl DDE_FRELEASE       fixed bin(16) unsigned value('2000'xn);
 dcl DDE_FREQUESTED     fixed bin(16) unsigned value('1000'xn);
 dcl DDE_FAPPSTATUS     fixed bin(16) unsigned value('00ff'xn);
 dcl DDE_FNOTPROCESSED  fixed bin(16) unsigned value('0000'xn);

 dcl DDE_FACKRESERVED   fixed bin(16) unsigned
     value(inot (ior (DDE_FACK, DDE_FBUSY, DDE_FAPPSTATUS)));
 dcl DDE_FADVRESERVED   fixed bin(16) unsigned
     value(inot (ior (DDE_FACKREQ, DDE_FDEFERUPD)));
 dcl DDE_FDATRESERVED   fixed bin(16) unsigned
     value(inot (ior (DDE_FACKREQ, DDE_FRELEASE, DDE_FREQUESTED)));

 dcl DDE_FPOKRESERVED   fixed bin(16) unsigned
     value(inot (DDE_FRELEASE));

 /***** message filter hook types *****/

 dcl MSGF_DDEMGR        fixed bin(16) unsigned value('8001'xn);

 /***** codepage constants ****/

 dcl CP_WINANSI    fixed bin(15) value(1004);
 /* default codepage for windows & old DDE convs. */
 dcl CP_WINUNICODE fixed bin(15) value(1200);
 %if UNICODE ^= '' %then %do;
 dcl CP_WINNEUTRAL fixed bin(15) value (CP_WINUNICODE);
 %end; %else %do;
 dcl CP_WINNEUTRAL fixed bin(15) value (CP_WINANSI);
 %end; /* !UNICODE */

 /***** transaction types *****/

 dcl XTYPF_NOBLOCK        fixed bin(16) unsigned value('0002'xn);
     /* CBR_BLOCK will not work */
 dcl XTYPF_NODATA         fixed bin(16) unsigned value('0004'xn);
     /* DDE_FDEFERUPD */
 dcl XTYPF_ACKREQ         fixed bin(16) unsigned value('0008'xn);
     /* DDE_FACKREQ */

 dcl XCLASS_MASK          fixed bin(16) unsigned value('FC00'xn);
 dcl XCLASS_BOOL          fixed bin(16) unsigned value('1000'xn);
 dcl XCLASS_DATA          fixed bin(16) unsigned value('2000'xn);
 dcl XCLASS_FLAGS         fixed bin(16) unsigned value('4000'xn);
 dcl XCLASS_NOTIFICATION  fixed bin(16) unsigned value('8000'xn);

 dcl XTYP_ERROR           fixed bin(16) unsigned
     value (ior ('0000'xn, XCLASS_NOTIFICATION, XTYPF_NOBLOCK ));
 dcl XTYP_ADVDATA         fixed bin(16) unsigned
     value (ior ('0010'xn, XCLASS_FLAGS         ));
 dcl XTYP_ADVREQ          fixed bin(16) unsigned
     value (ior ('0020'xn, XCLASS_DATA, XTYPF_NOBLOCK ));
 dcl XTYP_ADVSTART        fixed bin(16) unsigned
     value (ior ('0030'xn, XCLASS_BOOL          ));
 dcl XTYP_ADVSTOP         fixed bin(16) unsigned
     value (ior ('0040'xn, XCLASS_NOTIFICATION));
 dcl XTYP_EXECUTE         fixed bin(16) unsigned
     value (ior ('0050'xn, XCLASS_FLAGS         ));
 dcl XTYP_CONNECT         fixed bin(16) unsigned
     value (ior ('0060'xn, XCLASS_BOOL, XTYPF_NOBLOCK));
 dcl XTYP_CONNECT_CONFIRM fixed bin(16) unsigned
     value (ior ('0070'xn, XCLASS_NOTIFICATION, XTYPF_NOBLOCK));
 dcl XTYP_XACT_COMPLETE   fixed bin(16) unsigned
     value (ior ('0080'xn, XCLASS_NOTIFICATION  ));
 dcl XTYP_POKE            fixed bin(16) unsigned
     value (ior ('0090'xn, XCLASS_FLAGS         ));
 dcl XTYP_REGISTER        fixed bin(16) unsigned
     value (ior ('00A0'xn, XCLASS_NOTIFICATION, XTYPF_NOBLOCK));
 dcl XTYP_REQUEST         fixed bin(16) unsigned
     value (ior ('00B0'xn, XCLASS_DATA          ));
 dcl XTYP_DISCONNECT      fixed bin(16) unsigned
     value (ior ('00C0'xn, XCLASS_NOTIFICATION, XTYPF_NOBLOCK));
 dcl XTYP_UNREGISTER      fixed bin(16) unsigned
     value (ior ('00D0'xn, XCLASS_NOTIFICATION, XTYPF_NOBLOCK));
 dcl XTYP_WILDCONNECT     fixed bin(16) unsigned
     value (ior ('00E0'xn, XCLASS_DATA, XTYPF_NOBLOCK));


 dcl XTYP_MASK            fixed bin(16) unsigned value('00F0'xn);
 dcl XTYP_SHIFT           fixed bin(31) value(4);
 /* shift to turn XTYP_ into an index */

 /***** Timeout constants *****/

 dcl TIMEOUT_ASYNC fixed bin(31) value('FFFFFFFF'xn);

 /***** Transaction ID constants *****/

 dcl QID_SYNC fixed bin(31) value('FFFFFFFF'xn);

 /****** public strings used in DDE ******/

 %if UNICODE ^= '' %then %do;
 dcl SZDDESYS_TOPIC         WCHAR value('System');
 dcl SZDDESYS_ITEM_TOPICS   WCHAR value('Topics');
 dcl SZDDESYS_ITEM_SYSITEMS WCHAR value('SysItems');
 dcl SZDDESYS_ITEM_RTNMSG   WCHAR value('ReturnMessage');
 dcl SZDDESYS_ITEM_STATUS   WCHAR value('Status');
 dcl SZDDESYS_ITEM_FORMATS  WCHAR value('Formats');
 dcl SZDDESYS_ITEM_HELP     WCHAR value('Help');
 dcl SZDDE_ITEM_ITEMLIST    WCHAR value('TopicItemList');
 %end; %else %do;
 dcl SZDDESYS_TOPIC         char value('System');
 dcl SZDDESYS_ITEM_TOPICS   char value('Topics');
 dcl SZDDESYS_ITEM_SYSITEMS char value('SysItems');
 dcl SZDDESYS_ITEM_RTNMSG   char value('ReturnMessage');
 dcl SZDDESYS_ITEM_STATUS   char value('Status');
 dcl SZDDESYS_ITEM_FORMATS  char value('Formats');
 dcl SZDDESYS_ITEM_HELP     char value('Help');
 dcl SZDDE_ITEM_ITEMLIST    char value('TopicItemList');
 %end;


 /****** API entry points ******/

 /* original C declaration:                                        */
 /* typedef HDDEDATA CALLBACK FNCALLBACK(UINT wType, UINT wFmt,    */
 /*         HCONV hConv, HSZ hsz1, HSZ hsz2, HDDEDATA hData,       */
 /*         DWORD dwData1, DWORD dwData2)                          */
 /* PL/I translation, used as "dcl callback_fn FNCALLBACK"         */
 /* to declare an external entry constant callback_fn              */

 %dcl FNCALLBACK char ext;
 %FNCALLBACK = 'entry  (type UINT, '
            ||         'type UINT, '
            ||         'type HCONV, '
            ||         'type HSZ, '
            ||         'type HSZ, '
            ||         'type HDDEDATA, '
            ||         'type DWORD, '
            ||         'type DWORD) '
            || 'returns (type HDDEDATA byvalue optional) '
            || 'CALLBACK';

 define alias PFNCALLBACK FNCALLBACK limited;

 dcl CBR_BLOCK type HDDEDATA  value(ptrvalue ('ffffffff'xn));

 /* DLL registration functions */

 dcl DdeInitializeA
     entry (type DWORD byaddr,
            type PFNCALLBACK,
            type DWORD,
            type DWORD)
     returns (type UINT byvalue optional)
     WINAPI external('DdeInitializeA');
 dcl DdeInitializeW
     entry (type DWORD byaddr,
            type PFNCALLBACK,
            type DWORD,
            type DWORD)
     returns (type UINT byvalue optional)
     WINAPI external('DdeInitializeW');
 %dcl DdeInitialize char ext;
 %if UNICODE ^= '' %then %do;
 %DdeInitialize='DdeInitializeW';
 %end; %else %do;
 %DdeInitialize='DdeInitializeA';
 %end; /* !UNICODE */

 /* Callback filter flags for use with standard apps. */

 dcl CBF_FAIL_SELFCONNECTIONS  fixed bin(31) value('00001000'xn);
 dcl CBF_FAIL_CONNECTIONS      fixed bin(31) value('00002000'xn);
 dcl CBF_FAIL_ADVISES          fixed bin(31) value('00004000'xn);
 dcl CBF_FAIL_EXECUTES         fixed bin(31) value('00008000'xn);
 dcl CBF_FAIL_POKES            fixed bin(31) value('00010000'xn);
 dcl CBF_FAIL_REQUESTS         fixed bin(31) value('00020000'xn);
 dcl CBF_FAIL_ALLSVRXACTIONS   fixed bin(31) value('0003f000'xn);

 dcl CBF_SKIP_CONNECT_CONFIRMS fixed bin(31) value('00040000'xn);
 dcl CBF_SKIP_REGISTRATIONS    fixed bin(31) value('00080000'xn);
 dcl CBF_SKIP_UNREGISTRATIONS  fixed bin(31) value('00100000'xn);
 dcl CBF_SKIP_DISCONNECTS      fixed bin(31) value('00200000'xn);
 dcl CBF_SKIP_ALLNOTIFICATIONS fixed bin(31) value('003c0000'xn);

 /* Application command flags */
 dcl APPCMD_CLIENTONLY         fixed bin(31) value('00000010'xn);
 dcl APPCMD_FILTERINITS        fixed bin(31) value('00000020'xn);
 dcl APPCMD_MASK               fixed bin(31) value('00000FF0'xn);

 /* Application classification flags */
 dcl APPCLASS_STANDARD         fixed bin(31) value('00000000'xn);
 dcl APPCLASS_MASK             fixed bin(31) value('0000000F'xn);

 dcl DdeUninitialize
     entry (type DWORD )
     returns (type BOOL byvalue optional)
     WINAPI external('DdeUninitialize');

 /* conversation enumeration functions */

 dcl DdeConnectList
     entry (type DWORD,
            type HSZ,
            type HSZ,
            type HCONVLIST,
            type CONVCONTEXT byaddr optional)
     returns (type HCONVLIST byvalue optional)
     WINAPI external('DdeConnectList');

 dcl DdeQueryNextServer
     entry (type HCONVLIST,
            type HCONV)
     returns (type HCONV byvalue optional)
     WINAPI external('DdeQueryNextServer');

 dcl DdeDisconnectList
     entry (type HCONVLIST)
     returns (type BOOL byvalue optional)
     WINAPI external('DdeDisconnectList');

 /* conversation control functions */

 dcl DdeConnect
     entry (type DWORD,
            type HSZ,
            type HSZ,
            type CONVCONTEXT byaddr optional)
     returns (type HCONV byvalue optional)
     WINAPI external('DdeConnect');

 dcl DdeDisconnect
     entry (type HCONV )
     returns (type BOOL byvalue optional)
     WINAPI external('DdeDisconnect');

 dcl DdeReconnect
     entry (type HCONV )
     returns (type HCONV byvalue optional)
     WINAPI external('DdeReconnect');

 dcl DdeQueryConvInfo
     entry (type HCONV,
            type DWORD,
            type CONVINFO byaddr)
     returns (type UINT byvalue optional)
     WINAPI external('DdeQueryConvInfo');

 dcl DdeSetUserHandle
     entry (type HCONV,
            type DWORD,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('DdeSetUserHandle');

 dcl DdeAbandonTransaction
     entry (type DWORD,
            type HCONV,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('DdeAbandonTransaction');


 /* app server interface functions */

 dcl DdePostAdvise
     entry (type DWORD,
            type HSZ,
            type HSZ)
     returns (type BOOL byvalue optional)
     WINAPI external('DdePostAdvise');

 dcl DdeEnableCallback
     entry (type DWORD,
            type HCONV,
            type UINT)
     returns (type BOOL byvalue optional)
     WINAPI external('DdeEnableCallback');

 dcl DdeImpersonateClient
     entry (type HCONV)
     returns (type BOOL byvalue optional)
     WINAPI external('DdeImpersonateClient');

 dcl EC_ENABLEALL    fixed bin(31) value(0);
 dcl EC_ENABLEONE    fixed bin(31) value(ST_BLOCKNEXT);
 dcl EC_DISABLE      fixed bin(31) value(ST_BLOCKED);
 dcl EC_QUERYWAITING fixed bin(31) value(2);

 dcl DdeNameService
     entry (type DWORD,
            type HSZ,
            type HSZ,
            type UINT)
     returns (type HDDEDATA byvalue optional)
     WINAPI external('DdeNameService');

 dcl DNS_REGISTER   fixed bin(15) value('0001'xn);
 dcl DNS_UNREGISTER fixed bin(15) value('0002'xn);
 dcl DNS_FILTERON   fixed bin(15) value('0004'xn);
 dcl DNS_FILTEROFF  fixed bin(15) value('0008'xn);

 /* app client interface functions */

 dcl DdeClientTransaction
     entry (type LPBYTE,
            type DWORD,
            type HCONV,
            type HSZ,
            type UINT,
            type UINT,
            type DWORD,
            type DWORD byaddr)
     returns (type HDDEDATA byvalue optional)
     WINAPI external('DdeClientTransaction');

 /* data transfer functions */

 dcl DdeCreateDataHandle
     entry (type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD,
            type HSZ,
            type UINT,
            type UINT)
     returns (type HDDEDATA byvalue optional)
     WINAPI external('DdeCreateDataHandle');

 dcl DdeAddData
     entry (type HDDEDATA,
            type LPBYTE,
            type DWORD,
            type DWORD)
     returns (type HDDEDATA byvalue optional)
     WINAPI external('DdeAddData');

 dcl DdeGetData
     entry (type HDDEDATA,
            type LPBYTE,
            type DWORD,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('DdeGetData');

 dcl DdeAccessData
     entry (type HDDEDATA,
            type DWORD byaddr)
     returns (type LPBYTE byvalue optional)
     WINAPI external('DdeAccessData');

 dcl DdeUnaccessData
     entry (type HDDEDATA)
     returns (type BOOL byvalue optional)
     WINAPI external('DdeUnaccessData');

 dcl DdeFreeDataHandle
     entry (type HDDEDATA)
     returns (type BOOL byvalue optional)
     WINAPI external('DdeFreeDataHandle');

 dcl HDATA_APPOWNED fixed bin(15) value('0001'xn);


 dcl DdeGetLastError
     entry (type DWORD )
     returns (type UINT byvalue optional)
     WINAPI external('DdeGetLastError');

 dcl DMLERR_NO_ERROR            fixed bin(31) value(0); /* must be 0 */

 dcl DMLERR_FIRST               fixed bin(15) value('4000'xn);

 dcl DMLERR_ADVACKTIMEOUT       fixed bin(15) value('4000'xn);
 dcl DMLERR_BUSY                fixed bin(15) value('4001'xn);
 dcl DMLERR_DATAACKTIMEOUT      fixed bin(15) value('4002'xn);
 dcl DMLERR_DLL_NOT_INITIALIZED fixed bin(15) value('4003'xn);
 dcl DMLERR_DLL_USAGE           fixed bin(15) value('4004'xn);
 dcl DMLERR_EXECACKTIMEOUT      fixed bin(15) value('4005'xn);
 dcl DMLERR_INVALIDPARAMETER    fixed bin(15) value('4006'xn);
 dcl DMLERR_LOW_MEMORY          fixed bin(15) value('4007'xn);
 dcl DMLERR_MEMORY_ERROR        fixed bin(15) value('4008'xn);
 dcl DMLERR_NOTPROCESSED        fixed bin(15) value('4009'xn);
 dcl DMLERR_NO_CONV_ESTABLISHED fixed bin(15) value('400a'xn);
 dcl DMLERR_POKEACKTIMEOUT      fixed bin(15) value('400b'xn);
 dcl DMLERR_POSTMSG_FAILED      fixed bin(15) value('400c'xn);
 dcl DMLERR_REENTRANCY          fixed bin(15) value('400d'xn);
 dcl DMLERR_SERVER_DIED         fixed bin(15) value('400e'xn);
 dcl DMLERR_SYS_ERROR           fixed bin(15) value('400f'xn);
 dcl DMLERR_UNADVACKTIMEOUT     fixed bin(15) value('4010'xn);
 dcl DMLERR_UNFOUND_QUEUE_ID    fixed bin(15) value('4011'xn);

 dcl DMLERR_LAST fixed bin(15) value('4011'xn);

 dcl DdeCreateStringHandleA
     entry (type DWORD,
            char (*) varz byaddr nonasgn,
        fixed bin(31))
     returns (type HSZ byvalue optional)
     WINAPI external('DdeCreateStringHandleA');
 dcl DdeCreateStringHandleW
     entry (type DWORD,
            WCHAR (*) varz byaddr nonasgn,
        fixed bin(31))
     returns (type HSZ byvalue optional)
     WINAPI external('DdeCreateStringHandleW');
 %dcl DdeCreateStringHandle char ext;
 %if UNICODE ^= '' %then %do;
   %DdeCreateStringHandle='DdeCreateStringHandleW';
 %end; %else %do;
   %DdeCreateStringHandle='DdeCreateStringHandleA';
 %end; /* !UNICODE */

 dcl DdeQueryStringA
     entry (type DWORD,
            type HSZ,
            char (*) varz byaddr,
            type DWORD,
            fixed bin(31))
     returns (type DWORD byvalue optional)
     WINAPI external('DdeQueryStringA');
 dcl DdeQueryStringW
     entry (type DWORD,
            type HSZ,
            WCHAR (*) varz byaddr,
            type DWORD,
            fixed bin(31))
     returns (type DWORD byvalue optional)
     WINAPI external('DdeQueryStringW');
 %dcl DdeQueryString char ext;
 %if UNICODE ^= '' %then %do;
   %DdeQueryString='DdeQueryStringW';
 %end; %else %do;
   %DdeQueryString='DdeQueryStringA';
 %end; /* !UNICODE */

 dcl DdeFreeStringHandle
     entry (type DWORD,
            type HSZ)
     returns (type BOOL byvalue optional)
     WINAPI external('DdeFreeStringHandle');

 dcl DdeKeepStringHandle
     entry (type DWORD,
            type HSZ)
     returns (type BOOL byvalue optional)
     WINAPI external('DdeKeepStringHandle');

 dcl DdeCmpStringHandles
     entry (type HSZ,
            type HSZ)
     returns (fixed bin(31) byvalue optional)
     WINAPI external('DdeCmpStringHandles');


 %dcl NODDEMLSPY char ext;
 %if NODDEMLSPY = '' %then %do;
 /* DDEML public debugging header file info */

 define structure
   1 DDEML_MSG_HOOK_DATA,  /* new for NT */
     2 uiLo     type UINT, /* unpacked lo and hi parts of lParam */
     2 uiHi     type UINT,
     2 cbData   type DWORD,/* amount of data in message, if any. */
                           /* May be > than 32 bytes. */
     2 Data (8) type DWORD;/* data peeking by DDESPY is limited  */
                           /* to 32 bytes. */
 define alias PDDEML_MSG_HOOK_DATA handle DDEML_MSG_HOOK_DATA;


 define structure
   1 MONMSGSTRUCT,
     2 cb     type UINT,
     2 hwndTo type HWND,
     2 dwTime type DWORD,
     2 hTask  type HANDLE,
     2 wMsg   type UINT,
     2 wParam type WPARAM,
     2 lParam type LPARAM,
     2 dmhd   type DDEML_MSG_HOOK_DATA;/* new for NT */
 define alias PMONMSGSTRUCT handle MONMSGSTRUCT;

 define structure
   1 MONCBSTRUCT,
     2 cb       type UINT,
     2 dwTime   type DWORD,
     2 hTask    type HANDLE,
     2 dwRet    type DWORD,
     2 wType    type UINT,
     2 wFmt     type UINT,
     2 hConv    type HCONV,
     2 hsz1     type HSZ,
     2 hsz2     type HSZ,
     2 hData    type HDDEDATA,
     2 dwData1  type DWORD,
     2 dwData2  type DWORD,
     2 cc       type CONVCONTEXT,
                /* new for NT for XTYP_CONNECT callbacks */
     2 cbData   type DWORD,/* new for NT for data peeking */
     2 Data (8) type DWORD;/* new for NT for data peeking */
 define alias PMONCBSTRUCT handle MONCBSTRUCT;

 define structure
   1 MONHSZSTRUCTA,
     2 cb       type UINT,
     2 fsAction type BOOL,/* MH_ value */
     2 dwTime   type DWORD,
     2 hsz      type HSZ,
     2 hTask    type HANDLE,
     2 str (1)  char; /* length is variable, str is nul-terminated */
 define alias PMONHSZSTRUCTA handle MONHSZSTRUCTA;

 define structure
   1 MONHSZSTRUCTW,
     2 cb       type UINT,
     2 fsAction type BOOL,/* MH_ value */
     2 dwTime   type DWORD,
     2 hsz      type HSZ,
     2 hTask    type HANDLE,
     2 str (1)  WCHAR; /* length is variable, str is nul-terminated */
 define alias PMONHSZSTRUCTW handle MONHSZSTRUCTW;

 %if UNICODE ^= '' %then %do;
 define alias  MONHSZSTRUCT type  MONHSZSTRUCTW;
 define alias PMONHSZSTRUCT type PMONHSZSTRUCTW;
 %end; %else %do;
 define alias  MONHSZSTRUCT type  MONHSZSTRUCTA;
 define alias PMONHSZSTRUCT type PMONHSZSTRUCTA;
 %end; /* UNICODE */

 dcl MH_CREATE  fixed bin(31) value(1);
 dcl MH_KEEP    fixed bin(31) value(2);
 dcl MH_DELETE  fixed bin(31) value(3);
 dcl MH_CLEANUP fixed bin(31) value(4);

 define structure
   1 MONERRSTRUCT,
     2 cb         type UINT,
     2 wLastError type UINT,
     2 dwTime     type DWORD,
     2 hTask      type HANDLE;
 define alias PMONERRSTRUCT handle MONERRSTRUCT;

 define structure
   1 MONLINKSTRUCT,
    2 cb           type UINT,
    2 dwTime       type DWORD,
    2 hTask        type HANDLE,
    2 fEstablished type BOOL,
    2 fNoData      type BOOL,
    2 hszSvc       type HSZ,
    2 hszTopic     type HSZ,
    2 hszItem      type HSZ,
    2 wFmt         type UINT,
    2 fServer      type BOOL,
    2 hConvServer  type HCONV,
    2 hConvClient  type HCONV;
 define alias PMONLINKSTRUCT handle MONLINKSTRUCT;

 define structure
   1 MONCONVSTRUCT,
     2 cb          type UINT,
     2 fConnect    type BOOL,
     2 dwTime      type DWORD,
     2 hTask       type HANDLE,
     2 hszSvc      type HSZ,
     2 hszTopic    type HSZ,
     2 hConvClient type HCONV,
                   /* Globally unique value != apps local hConv */
     2 hConvServer type HCONV;
                   /* Globally unique value != apps local hConv */
 define alias PMONCONVSTRUCT handle MONCONVSTRUCT;

 dcl MAX_MONITORS     fixed bin(31) value(4);
 dcl APPCLASS_MONITOR fixed bin(31) value('00000001'xn);
 dcl XTYP_MONITOR     fixed bin(16) unsigned
     value (ior ('00F0'xn, XCLASS_NOTIFICATION, XTYPF_NOBLOCK));

 /* Callback filter flags for use with MONITOR apps - 0 implies */
 /* no monitor callbacks.                                       */
 dcl MF_HSZ_INFO  fixed bin(31) value('01000000'xn);
 dcl MF_SENDMSGS  fixed bin(31) value('02000000'xn);
 dcl MF_POSTMSGS  fixed bin(31) value('04000000'xn);
 dcl MF_CALLBACKS fixed bin(31) value('08000000'xn);
 dcl MF_ERRORS    fixed bin(31) value('10000000'xn);
 dcl MF_LINKS     fixed bin(31) value('20000000'xn);
 dcl MF_CONV      fixed bin(31) value('40000000'xn);

 dcl MF_MASK      fixed bin(31) value('FF000000'xn);
 %end; /* NODDEMLSPY */

 %end; /* _INC_DDEMLH */

