 /*++ BUILD Version: 0003                                             */
 /*   -- Increment this if a change has global effects                */
 /*                                                                   */
 /* Copyright 1991-1998 Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmconfig.cpy                                                    */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This module defines the API function prototypes and data        */
 /*   structures for the following groups of NT API functions:        */
 /*       NetConfig                                                   */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /*   You must include NETCONS.CPY before this file, since this file  */
 /*   depends on values defined in NETCONS.CPY.                       */
 /*--                                                                 */

 %dcl #LMCONFIG_ char ext;
 %if #LMCONFIG_ = '' %then %do;
 %#LMCONFIG_ = 'Y';


 %dcl REVISED_CONFIG_APIS char ext;
 %REVISED_CONFIG_APIS = 'Y';


 /* Function Prototypes - Config */

 dcl NetConfigGet
     entry (WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
 %if REVISED_CONFIG_APIS ^= '' %then %do;
            type LPBYTE byaddr
 %end; %else %do;
            type LPBYTE byaddr,
            type DWORD byaddr optional
 %end;
           )
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetConfigGet');

 dcl NetConfigGetAll
     entry (WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
 %if REVISED_CONFIG_APIS ^= '' %then %do;
            type LPBYTE byaddr
 %end; %else %do;
            type LPBYTE byaddr,
            type LPDWORD byaddr optional
 %end;
           )
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetConfigGetAll');


 dcl NetConfigSet
     entry (WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            type DWORD,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetConfigSet');


 dcl NetRegisterDomainNameChangeNotification
     entry (type HANDLE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION
     external('NetRegisterDomainNameChangeNotification');

 dcl NetUnregisterDomainNameChangeNotification
     entry (type HANDLE)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION
     external('NetUnregisterDomainNameChangeNotification');

 /* Data Structures - Config */

 define structure
   1 CONFIG_INFO_0,
     2 cfgi0_key  type LPWSTR,
     2 cfgi0_data type LPWSTR;

 define alias  PCONFIG_INFO_0 handle CONFIG_INFO_0;
 define alias LPCONFIG_INFO_0 handle CONFIG_INFO_0;

 %end; /* _LMCONFIG_ */
