/* REXX utility to convert Microsoft LIB files from the       */
/* Microsoft Platform SDK to old format (readable by ILINK).  */

/* IMPORTANT: Run this utility from the LIB target directory. */

/* Some LIB files cannot be converted and some give warnings, */
/* this is normal (contact MS if this is unacceptable)        */

/* REXX is supplied with IBM VisualAge PL/I.                  */
/* The Platform SDK can be downloaded from www.microsoft.com  */

/* This utility can be modified to work with Visual Studio.   */
/* You need to change the first 3 assignment statements.      */

mssdk = strip(value('MSSDK',, 'ENVIRONMENT'))
mssdklib = mssdk || '\Lib'
linker = mssdk || '\Bin\Link\LINK.EXE'
newlibdir = directory()

call RxFuncAdd 'SysLoadFuncs', 'rexxutil', 'SysLoadFuncs'
call SysLoadFuncs

say 'Convert LIBs from' mssdklib 'to' newlibdir 'using' linker || '? [yes/NO]'
pull answer
if translate(substr(answer, 1, 1)) = 'Y' then do
  call sysfiletree mssdklib || '\*.lib', 'file', 'FO'
  do i = 1 to file.0
    say 'Converting' file.i || '...'
    outlib = filespec('name', file.i)
    linker '/lib /convert /out:' || outlib file.i
  end
end
