 /* ++ BUILD Version: 0001                                            */
 /*  Increment this if a change has global effects                    */
 /*                                                                   */
 /* Copyright (c) 1996-1997  Microsoft Corporation                    */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     pdhmsg.cpy                                                    */
 /*        (generated from pdhmsg.mc)                                 */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*    Event message definititions used by routines by PDH.DLL        */
 /*                                                                   */
 /* Created:                                                          */
 /*                                                                   */
 /*     6-Feb-96   Bob Watson (a-robw)                                */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /* --                                                                */

 %dcl #PDH_MSG_H_ char ext;
 %if #PDH_MSG_H_ = '' %then %do;
 %#PDH_MSG_H_ = 'Y';

 /*                                                                   */
 /*     PDH DLL messages                                              */
 /*                                                                   */
 /*                                                                   */
 /*      Success Messages                                             */
 /*                                                                   */
 /*         the Win32 error value ERROR_SUCCESS is used for success   */
 /*         returns                                                   */
 /*                                                                   */
 /*      MESSAGE NAME FORMAT                                          */
 /*                                                                   */
 /*          PDH_CSTATUS_...   messages are data item status message  */
 /*                     and are returned in reference to the status   */
 /*                     of a data item                                */
 /*          PDH_...           messages are returned by FUNCTIONS     */
 /*                     only and not used as data item status values  */
 /*                                                                   */
 /*      Success Messages                                             */
 /*         These messages are normally returned when the operation   */
 /*         completed successfully.                                   */
 /*                                                                   */
 /*                                                                   */
 /*  Values are 32 bit values layed out as follows:                   */
 /*                                                                   */
 /*   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1                     */
 /*   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 */
 /*  +---+-+-+-----------------------+-------------------------------+*/
 /*  |Sev|C|R|     Facility          |               Code            |*/
 /*  +---+-+-+-----------------------+-------------------------------+*/
 /*                                                                   */
 /*  where                                                            */
 /*                                                                   */
 /*      Sev - is the severity code                                   */
 /*                                                                   */
 /*          00 - Success                                             */
 /*          01 - Informational                                       */
 /*          10 - Warning                                             */
 /*          11 - Error                                               */
 /*                                                                   */
 /*      C - is the Customer code flag                                */
 /*                                                                   */
 /*      R - is a reserved bit                                        */
 /*                                                                   */
 /*      Facility - is the facility code                              */
 /*                                                                   */
 /*      Code - is the facility's status code                         */
 /*                                                                   */
 /*                                                                   */
 /* Define the facility codes                                         */
 /*                                                                   */


 /*                                                                   */
 /* Define the severity codes                                         */
 /*                                                                   */
 dcl STATUS_SEVERITY_WARNING       fixed bin(7) value('2'xn);
 dcl STATUS_SEVERITY_SUCCESS       fixed bin(7) value('0'xn);
 dcl STATUS_SEVERITY_INFORMATIONAL fixed bin(7) value('1'xn);
 dcl STATUS_SEVERITY_ERROR         fixed bin(7) value('3'xn);


 /*                                                                   */
 /* MessageId: PDH_CSTATUS_VALID_DATA                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The returned data is valid.                                      */
 /*                                                                   */
 dcl PDH_CSTATUS_VALID_DATA              type DWORD value('00000000'xu);

 /*                                                                   */
 /* MessageId: PDH_CSTATUS_NEW_DATA                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The return data value is valid and different from the last       */
 /*  sample.                                                          */
 /*                                                                   */
 dcl PDH_CSTATUS_NEW_DATA                type DWORD value('00000001'xu);

 /*                                                                   */
 /*        Informational messages                                     */
 /*                                                                   */
 /*  None                                                             */
 /*                                                                   */
 /*      Warning Messages                                             */
 /*         These messages are returned when the function has         */
 /*         completed successfully but the results may be different   */
 /*         than expected.                                            */
 /*                                                                   */
 /*                                                                   */
 /* MessageId: PDH_CSTATUS_NO_MACHINE                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to connect to specified machine or machine is off line.   */
 /*                                                                   */
 dcl PDH_CSTATUS_NO_MACHINE              type DWORD value('800007D0'xu);

 /*                                                                   */
 /* MessageId: PDH_CSTATUS_NO_INSTANCE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified instance is not present.                           */
 /*                                                                   */
 dcl PDH_CSTATUS_NO_INSTANCE             type DWORD value('800007D1'xu);

 /*                                                                   */
 /* MessageId: PDH_MORE_DATA                                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is more data to return than would fit in the supplied      */
 /*  buffer. Allocate a larger buffer and call the function again.    */
 /*                                                                   */
 dcl PDH_MORE_DATA                       type DWORD value('800007D2'xu);

 /*                                                                   */
 /* MessageId: PDH_CSTATUS_ITEM_NOT_VALIDATED                         */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The data item has been added to the query, but has not been      */
 /*  validated nor accessed. No other status information on this data */
 /*  item is available.                                               */
 /*                                                                   */
 dcl PDH_CSTATUS_ITEM_NOT_VALIDATED      type DWORD value('800007D3'xu);

 /*                                                                   */
 /* MessageId: PDH_RETRY                                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The selected operation should be retried.                        */
 /*                                                                   */
 dcl PDH_RETRY                           type DWORD value('800007D4'xu);

 /*                                                                   */
 /* MessageId: PDH_NO_DATA                                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No data to return.                                               */
 /*                                                                   */
 dcl PDH_NO_DATA                         type DWORD value('800007D5'xu);

 /*                                                                   */
 /* MessageId: PDH_CALC_NEGATIVE_DENOMINATOR                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A counter with a negative denominator value was detected.        */
 /*                                                                   */
 dcl PDH_CALC_NEGATIVE_DENOMINATOR       type DWORD value('800007D6'xu);

 /*                                                                   */
 /* MessageId: PDH_CALC_NEGATIVE_TIMEBASE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A counter with a negative timebase value was detected.           */
 /*                                                                   */
 dcl PDH_CALC_NEGATIVE_TIMEBASE          type DWORD value('800007D7'xu);

 /*                                                                   */
 /* MessageId: PDH_CALC_NEGATIVE_VALUE                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A counter with a negative value was detected.                    */
 /*                                                                   */
 dcl PDH_CALC_NEGATIVE_VALUE             type DWORD value('800007D8'xu);

 /*                                                                   */
 /* MessageId: PDH_DIALOG_CANCELLED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The user cancelled the dialog box.                               */
 /*                                                                   */
 dcl PDH_DIALOG_CANCELLED                type DWORD value('800007D9'xu);

 /*                                                                   */
 /* MessageId: PDH_END_OF_LOG_FILE                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The end of the log file was reached.                             */
 /*                                                                   */
 dcl PDH_END_OF_LOG_FILE                 type DWORD value('800007DA'xu);

 /*                                                                   */
 /*     Error Messages                                                */
 /*        These messages are returned when the function could not    */
 /*        complete as requested and some corrective action may be    */
 /*        required by the caller or the user.                        */
 /*                                                                   */
 /*                                                                   */
 /* MessageId: PDH_CSTATUS_NO_OBJECT                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified object is not found on the system.                 */
 /*                                                                   */
 dcl PDH_CSTATUS_NO_OBJECT               type DWORD value('C0000BB8'xu);

 /*                                                                   */
 /* MessageId: PDH_CSTATUS_NO_COUNTER                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified counter could not be found.                        */
 /*                                                                   */
 dcl PDH_CSTATUS_NO_COUNTER              type DWORD value('C0000BB9'xu);

 /*                                                                   */
 /* MessageId: PDH_CSTATUS_INVALID_DATA                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The returned data is not valid.                                  */
 /*                                                                   */
 dcl PDH_CSTATUS_INVALID_DATA            type DWORD value('C0000BBA'xu);

 /*                                                                   */
 /* MessageId: PDH_MEMORY_ALLOCATION_FAILURE                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A PDH function could not allocate enough temporary memory to     */
 /*  complete the operation. Close some applications or extend the    */
 /*  pagefile and retry the function.                                 */
 /*                                                                   */
 dcl PDH_MEMORY_ALLOCATION_FAILURE       type DWORD value('C0000BBB'xu);

 /*                                                                   */
 /* MessageId: PDH_INVALID_HANDLE                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The handle is not a valid PDH object.                            */
 /*                                                                   */
 dcl PDH_INVALID_HANDLE                  type DWORD value('C0000BBC'xu);

 /*                                                                   */
 /* MessageId: PDH_INVALID_ARGUMENT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  A required argument is missing or incorrect.                     */
 /*                                                                   */
 dcl PDH_INVALID_ARGUMENT                type DWORD value('C0000BBD'xu);

 /*                                                                   */
 /* MessageId: PDH_FUNCTION_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to find the specified function.                           */
 /*                                                                   */
 dcl PDH_FUNCTION_NOT_FOUND              type DWORD value('C0000BBE'xu);

 /*                                                                   */
 /* MessageId: PDH_CSTATUS_NO_COUNTERNAME                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No counter was specified.                                        */
 /*                                                                   */
 dcl PDH_CSTATUS_NO_COUNTERNAME          type DWORD value('C0000BBF'xu);

 /*                                                                   */
 /* MessageId: PDH_CSTATUS_BAD_COUNTERNAME                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to parse the counter path. Check the format and syntax of */
 /*  the specified path.                                              */
 /*                                                                   */
 dcl PDH_CSTATUS_BAD_COUNTERNAME         type DWORD value('C0000BC0'xu);

 /*                                                                   */
 /* MessageId: PDH_INVALID_BUFFER                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The buffer passed by the caller is invalid.                      */
 /*                                                                   */
 dcl PDH_INVALID_BUFFER                  type DWORD value('C0000BC1'xu);

 /*                                                                   */
 /* MessageId: PDH_INSUFFICIENT_BUFFER                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The requested data is larger than the buffer supplied.           */
 /*  Unable to return the requested data.                             */
 /*                                                                   */
 dcl PDH_INSUFFICIENT_BUFFER             type DWORD value('C0000BC2'xu);

 /*                                                                   */
 /* MessageId: PDH_CANNOT_CONNECT_MACHINE                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to connect to the requested machine.                      */
 /*                                                                   */
 dcl PDH_CANNOT_CONNECT_MACHINE          type DWORD value('C0000BC3'xu);

 /*                                                                   */
 /* MessageId: PDH_INVALID_PATH                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified counter path could not be interpreted.             */
 /*                                                                   */
 dcl PDH_INVALID_PATH                    type DWORD value('C0000BC4'xu);

 /*                                                                   */
 /* MessageId: PDH_INVALID_INSTANCE                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The instance name could not be read from the specified counter   */
 /* path.                                                             */
 /*                                                                   */
 dcl PDH_INVALID_INSTANCE                type DWORD value('C0000BC5'xu);

 /*                                                                   */
 /* MessageId: PDH_INVALID_DATA                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The data is not valid.                                           */
 /*                                                                   */
 dcl PDH_INVALID_DATA                    type DWORD value('C0000BC6'xu);

 /*                                                                   */
 /* MessageId: PDH_NO_DIALOG_DATA                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The dialog box data block was missing or invalid.                */
 /*                                                                   */
 dcl PDH_NO_DIALOG_DATA                  type DWORD value('C0000BC7'xu);

 /*                                                                   */
 /* MessageId: PDH_CANNOT_READ_NAME_STRINGS                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to read the counter and/or explain text from the          */
 /* specified machine.                                                */
 /*                                                                   */
 dcl PDH_CANNOT_READ_NAME_STRINGS        type DWORD value('C0000BC8'xu);

 /*                                                                   */
 /* MessageId: PDH_LOG_FILE_CREATE_ERROR                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to create the specified log file.                         */
 /*                                                                   */
 dcl PDH_LOG_FILE_CREATE_ERROR           type DWORD value('C0000BC9'xu);

 /*                                                                   */
 /* MessageId: PDH_LOG_FILE_OPEN_ERROR                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to open the specified log file.                           */
 /*                                                                   */
 dcl PDH_LOG_FILE_OPEN_ERROR             type DWORD value('C0000BCA'xu);

 /*                                                                   */
 /* MessageId: PDH_LOG_TYPE_NOT_FOUND                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified log file type has not been installed on this       */
 /*  system.                                                          */
 /*                                                                   */
 dcl PDH_LOG_TYPE_NOT_FOUND              type DWORD value('C0000BCB'xu);

 /*                                                                   */
 /* MessageId: PDH_NO_MORE_DATA                                       */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more data is available.                                       */
 /*                                                                   */
 dcl PDH_NO_MORE_DATA                    type DWORD value('C0000BCC'xu);

 /*                                                                   */
 /* MessageId: PDH_ENTRY_NOT_IN_LOG_FILE                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified record was not found in the log file.              */
 /*                                                                   */
 dcl PDH_ENTRY_NOT_IN_LOG_FILE           type DWORD value('C0000BCD'xu);

 /*                                                                   */
 /* MessageId: PDH_DATA_SOURCE_IS_LOG_FILE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified data source is a log file.                         */
 /*                                                                   */
 dcl PDH_DATA_SOURCE_IS_LOG_FILE         type DWORD value('C0000BCE'xu);

 /*                                                                   */
 /* MessageId: PDH_DATA_SOURCE_IS_REAL_TIME                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified data source is the current activity.               */
 /*                                                                   */
 dcl PDH_DATA_SOURCE_IS_REAL_TIME        type DWORD value('C0000BCF'xu);

 /*                                                                   */
 /* MessageId: PDH_UNABLE_READ_LOG_HEADER                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The log file header could not be read.                           */
 /*                                                                   */
 dcl PDH_UNABLE_READ_LOG_HEADER          type DWORD value('C0000BD0'xu);

 /*                                                                   */
 /* MessageId: PDH_FILE_NOT_FOUND                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to find the specified file.                               */
 /*                                                                   */
 dcl PDH_FILE_NOT_FOUND                  type DWORD value('C0000BD1'xu);

 /*                                                                   */
 /* MessageId: PDH_FILE_ALREADY_EXISTS                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  There is already a file with the specified file name.            */
 /*                                                                   */
 dcl PDH_FILE_ALREADY_EXISTS             type DWORD value('C0000BD2'xu);

 /*                                                                   */
 /* MessageId: PDH_NOT_IMPLEMENTED                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The function referenced has not been implemented.                */
 /*                                                                   */
 dcl PDH_NOT_IMPLEMENTED                 type DWORD value('C0000BD3'xu);

 /*                                                                   */
 /* MessageId: PDH_STRING_NOT_FOUND                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to find the specified string in the list of performance   */
 /*  name and explain text strings.                                   */
 /*                                                                   */
 dcl PDH_STRING_NOT_FOUND                type DWORD value('C0000BD4'xu);

 /*                                                                   */
 /* MessageId: PDH_UNABLE_MAP_NAME_FILES                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  Unable to map to the performance counter name data files.        */
 /*  The data will be read from the registry and stored locally.      */
 /*                                                                   */
 dcl PDH_UNABLE_MAP_NAME_FILES           type DWORD value('80000BD5'xu);

 /*                                                                   */
 /* MessageId: PDH_UNKNOWN_LOG_FORMAT                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The format of the specified log file is not recognized by the    */
 /*  PDH DLL.                                                         */
 /*                                                                   */
 dcl PDH_UNKNOWN_LOG_FORMAT              type DWORD value('C0000BD6'xu);

 /*                                                                   */
 /* MessageId: PDH_UNKNOWN_LOGSVC_COMMAND                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified Log Service command value is not recognized.       */
 /*                                                                   */
 dcl PDH_UNKNOWN_LOGSVC_COMMAND          type DWORD value('C0000BD7'xu);

 /*                                                                   */
 /* MessageId: PDH_LOGSVC_QUERY_NOT_FOUND                             */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified Query from the Log Service could not be found or   */
 /* could notbe opened.                                               */
 /*                                                                   */
 dcl PDH_LOGSVC_QUERY_NOT_FOUND          type DWORD value('C0000BD8'xu);

 /*                                                                   */
 /* MessageId: PDH_LOGSVC_NOT_OPENED                                  */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The Performance Data Log Service key could not be opened.        */
 /*  This may be due to insufficient privilege or because the service */
 /*  has not been installed.                                          */
 /*                                                                   */
 dcl PDH_LOGSVC_NOT_OPENED               type DWORD value('C0000BD9'xu);

 %end; /*_PDH_MSG_H_ */

