 /* ++                                                                */
 /*                                                                   */
 /* Copyright (c) 1997-1999 Microsoft Corporation                     */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     qosname.cpy                                                   */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     This module contains the type definitions for the QOS name    */
 /*     management routines, such as WSAInstallQOSTemplate etc.       */
 /*                                                                   */
 /* Author:                                                           */
 /*                                                                   */
 /*     Jim Stewart     July 2, 1997                                  */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /* --                                                                */

 %dcl #WINSOCK2API_ char ext;
 %if #WINSOCK2API_ = '' %then %do;
   %include winsock2;
 %end;

 /* Built-in QoS Templates */
 dcl QT_1 char value('G711');
 dcl QT_2 char value('G723.1');
 dcl QT_3 char value('G729');
 dcl QT_4 char value('H263QCIF');
 dcl QT_5 char value('H263CIF');
 dcl QT_6 char value('H261QCIF');
 dcl QT_7 char value('H261CIF');
 dcl QT_8 char value('GSM6.10');

 dcl WSCINSTALL_QOS_TEMPLATE char value('WSCInstallQOSTemplate');
 dcl WSCREMOVE_QOS_TEMPLATE  char value('WSCRemoveQOSTemplate');
 dcl WPUGET_QOS_TEMPLATE     char value('WPUGetQOSTemplate');

 define alias WSC_INSTALL_QOS_TEMPLATE
        entry (type GUID byaddr nonasgn,
               type WSABUF byaddr,
               type QOS byaddr)
        returns (type BOOL byvalue optional)
        limited APIENTRY;

 define alias  WSC_REMOVE_QOS_TEMPLATE
        entry (type GUID byaddr nonasgn,
               type WSABUF byaddr)
        returns (type BOOL byvalue optional)
        limited APIENTRY;

 define alias  WPU_GET_QOS_TEMPLATE
        entry (type GUID byaddr nonasgn,
               type WSABUF byaddr,
               type QOS byaddr)
        returns (type BOOL byvalue optional)
        limited APIENTRY;
