 /*********************************************************************/
 /*                                                                   */
 /* Source File Name: SQLAPREP                                        */
 /*                                                                   */
 /* (C) COPYRIGHT International Business Machines Corp. 1988, 1997    */
 /* All Rights Reserved                                               */
 /* Licensed Materials - Property of IBM                              */
 /*                                                                   */
 /* US Government Users Restricted Rights - Use, duplication or       */
 /* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
 /*                                                                   */
 /* Function = Include File defining:                                 */
 /*              Global equates, structures, and prototypes for       */
 /*              Precompiler and Runtime Command Interfaces           */
 /*                                                                   */
 /* Operating System =  Windows NT                                    */
 /*                                                                   */
 /*********************************************************************/
 %dcl SQL_H_SQLAPREP char ext;
 %if SQL_H_SQLAPREP = '' %then %do;
 %SQL_H_SQLAPREP = 'Y';

 /* Required Include Files  */
 %dcl SQL_H_SQLSYSTM char ext;
 %if SQL_H_SQLSYSTM = '' %then %do;
 %include sqlsystm; /* System dependent defines  */
 %end;
 %dcl #SQLCA_T_INC char ext;
 %if #SQLCA_T_INC = '' %then %do;
 %include sqlca_t;
 %end;
 %dcl SQL_H_SQLENV char ext;
 %if SQL_H_SQLENV = '' %then %do;
 %include sqlenv;
 %end;
 %dcl SQL_H_SQLADEF char ext;
 %if SQL_H_SQLADEF = '' %then %do;
 %include sqladef;
 %end;

 /* Macro used to calculate size of a precompiler option array,  */
 /* an input parameter of SQLAINIT.                              */
 %SQLA_NUM_OPTIONS: proc (n) returns (char);
   dcl n char;
   return ('( size (: sqla_options_header :) + (' || n ||
           ') * size (: sqla_option :))');
 %end SQLA_NUM_OPTIONS;
 %activate SQLA_NUM_OPTIONS;


 /* Values used for option[n].type, an input parameter of SQLAINIT.   */
 dcl SQLA_FORMAT                fixed bin(31) value(SQL_FRMT_OPT);
                                /* Option: date/time format           */
 dcl SQLA_ACCESS_PLAN           fixed bin(31) value(2);
                                /* Option: access plan creation       */
 dcl SQLA_BIND_FILE             fixed bin(31) value(3);
                                /* Option: bind file creation         */
 dcl SQLA_ISOLATION             fixed bin(31) value(SQL_ISO_OPT);
                                /* Option: isolation level            */
 dcl SQLA_BLOCK                 fixed bin(31) value(SQL_BLOCK_OPT);
                                /* Option: record blocking            */
 dcl SQLA_FLAG_OPT              fixed bin(31) value(SQL_FLAG_OPT);
                                /* Flagger option                     */
 dcl SQLA_STDS_LEVEL            fixed bin(31) value(7);
                                /* Option: standards compliance       */
 dcl SQLA_CNULREQD_OPT          fixed bin(31) value(SQL_CNULREQD_OPT);
                                /* C NULL required option             */
 dcl SQLA_GENERIC_OPT           fixed bin(31) value(SQL_GENERIC_OPT);
                                /* Generic option                     */
 dcl SQLA_DEFERRED_PREPARE_OPT  fixed bin(31)
                                value(SQL_DEFERRED_PREPARE_OPT);
                                /* Option for Deferred Prepare        */
 dcl SQLA_LEVEL_OPT             fixed bin(31) value(SQL_LEVEL_OPT);
                                /* Level of a module                  */
 dcl SQLA_COLLECTION_OPT        fixed bin(31) value(SQL_COLLECTION_OPT);
                                /* Package collection id              */
 dcl SQLA_VERSION_OPT           fixed bin(31) value(SQL_VERSION_OPT);
                                /* Package version id                 */
 dcl SQLA_OWNER_OPT             fixed bin(31) value(SQL_OWNER_OPT);
                                /* Package owner auth id              */
 dcl SQLA_SCHEMA_OPT            fixed bin(31) value(SQL_SCHEMA_OPT);
                                /* Synonym for owner                  */
 dcl SQLA_QUALIFIER_OPT         fixed bin(31) value(SQL_QUALIFIER_OPT);
                                /* Authorization identifier that is   */
                                /* to be used as qualifier for        */
                                /* unqualified objects                */
 dcl SQLA_CATALOG_OPT           fixed bin(31) value(SQL_CATALOG_OPT);
                                /* Synonym for qualifier.             */
 dcl SQLA_TEXT_OPT              fixed bin(31) value(SQL_TEXT_OPT);
                                /* Package description                */
 dcl SQLA_VALIDATE_OPT          fixed bin(31) value(SQL_VALIDATE_OPT);
                                /* Indicates when object              */
                                /* validation occurs                  */
 dcl SQLA_EXPLAIN_OPT           fixed bin(31) value(SQL_EXPLAIN_OPT);
                                /* Determines whether information     */
                                /* will be produced about how the     */
                                /* statements in a package            */
                                /* will be executed                   */
 dcl SQLA_ACTION_OPT            fixed bin(31) value(SQL_ACTION_OPT);
                                /* Indicates whether a package is to  */
                                /* be added or replaced               */
 dcl SQLA_SQLERROR_OPT          fixed bin(31) value(SQL_SYNTAX_OPT);
                                /* Indicates under what conditions a  */
                                /* package will be created            */
 dcl SQLA_REPLVER_OPT           fixed bin(31) value(SQL_REPLVER_OPT);
                                /* Replaces a specific                */
                                /* version of a package               */
 dcl SQLA_RETAIN_OPT            fixed bin(31) value(SQL_RETAIN_OPT);
                                /* Indicates whether EXECUTE          */
                                /* authorities are to be preserved    */
                                /* when a package is replaced         */
 dcl SQLA_RELEASE_OPT           fixed bin(31) value(SQL_RELEASE_OPT);
                                /* Indicates whether resources are    */
                                /* released at each COMMIT or when    */
                                /* the application terminates         */
 dcl SQLA_DEGREE_OPT            fixed bin(31) value(SQL_DEGREE_OPT);
                                /* Specifies whether or not the query */
                                /* is executed using I/O parallelism  */
 dcl SQLA_STRDEL_OPT            fixed bin(31) value(SQL_STRDEL_OPT);
                                /* Designates whether an apostrophe   */
                                /* or quote will be used as a string  */
                                /* delimiter                          */
 dcl SQLA_DECDEL_OPT            fixed bin(31) value(SQL_DECDEL_OPT);
                                /* Designates whether a period or     */
                                /* comma will be used as a decimal    */
                                /* point indicator                    */
 dcl SQLA_CHARSUB_OPT           fixed bin(31) value(SQL_CHARSUB_OPT);
                                /* Designates default character       */
                                /* subtype that is to be used for     */
                                /* column definitions in the CREATE   */
                                /* and ALTER TABLE SQL statements     */
 dcl SQLA_CCSIDS_OPT            fixed bin(31) value(SQL_CCSIDS_OPT);
                                /* Designates what CCSID will be used */
                                /* for single byte characters for     */
                                /* character column definitions       */
                                /* without a specific CCSID clause in */
                                /* the CREATE and ALTER TABLE SQL     */
                                /* statements                         */
 dcl SQLA_CCSIDM_OPT            fixed bin(31) value(SQL_CCSIDM_OPT);
                                /* Designates what CCSID will be used */
                                /* for mixed byte characters for      */
                                /* character column definitions       */
                                /* without a specific CCSID clause in */
                                /* the CREATE and ALTER TABLE SQL     */
                                /* statements                         */
 dcl SQLA_CCSIDG_OPT            fixed bin(31) value(SQL_CCSIDG_OPT);
                                /* Designates what CCSID will be used */
                                /* for double byte characters for     */
                                /* character column definitions       */
                                /* without a specific CCSID clause in */
                                /* the CREATE and ALTER TABLE SQL     */
                                /* statements                         */
 dcl SQLA_DEC_OPT               fixed bin(31) value(SQL_DEC_OPT);
                                /* Specifies the maximum precision to */
                                /* be used in decimal arithmetic      */
                                /* operations                         */
 dcl SQLA_CONNECT_OPT           fixed bin(31) value(SQL_CONNECT_OPT);
                                /* Specifies whether one or multiple  */
                                /* connections can exist at the same  */
                                /* time.                              */
 dcl SQLA_SQLRULES_OPT          fixed bin(31) value(SQL_RULES_OPT);
                                /* Specifies the set of rules used for*/
                                /* connection to multiple databases   */
                                /* within a single unit of work       */
 dcl SQLA_DISCONNECT_OPT        fixed bin(31) value(SQL_DISCONNECT_OPT);
                                /* Specifies which databases          */
                                /* disconnected when a COMMIT or      */
                                /* ROLLBACK is issued.                */
 dcl SQLA_SYNCPOINT_OPT         fixed bin(31) value(SQL_SYNCPOINT_OPT);
                                /* Specifies what syncpoint option    */
                                /* (for example one or two phase)     */
                                /* will be used.                      */
 dcl SQLA_DYNAMICRULES_OPT    fixed bin(31) value(SQL_DYNAMICRULES_OPT);
                                /* Specifies which authorization      */
                                /* identifier to use when dynamic SQL */
                                /* in a package is executed.          */
 dcl SQLA_INSERT                fixed bin(31) value(SQL_INSERT_OPT);
                                /* Buffers VALUE inserts - bind and   */
                                /* precompile option for DB2/PE       */
                                /* servers only                       */
 dcl SQLA_EXPLSNAP_OPT          fixed bin(31) value(SQL_EXPLSNAP_OPT);
                                /* Capture explain snapshot - bind    */
                                /* and precompile option              */
 dcl SQLA_FUNCTION_PATH         fixed bin(31) value(SQL_FUNCTION_PATH);
                                /* Path for user-defined function     */
                                /* resolution - bind and precompile   */
                                /* option                             */
 dcl SQLA_SQLWARN_OPT           fixed bin(31) value(SQL_SQLWARN_OPT);
                                /* Disable prepare-time SQL warnings  */
                                /* - bind and precompile option       */
 dcl SQLA_QUERYOPT_OPT          fixed bin(31) value(SQL_QUERYOPT_OPT);
                                /* Set query optimization class       */
                                /* - bind and precompile option       */
 dcl SQLA_TARGET_OPT            fixed bin(31) value(SQL_TARGET_OPT);
                                /* Target compiler precompile option  */
 dcl SQLA_PREP_OUTPUT_OPT      fixed bin(31) value(SQL_PREP_OUTPUT_OPT);
                                /* Name of precompiler output file    */
                                /* - precompile option                */
 dcl SQLA_TOKEN_USE_INITIALIZED_OPT fixed bin(31) value(1000);
                                /* Internal use only                  */
 dcl SQLA_USE_LONG_LABELS       fixed bin(31) value(1001);
                                /* Internal use only                  */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_FORMAT in the Precompiler Option Array.         */
 dcl SQLA_POA_DEF               fixed bin(31) value(0);
                                /* Default date/time format           */
 dcl SQLA_POA_USA               fixed bin(31) value(1);
                                /* USA date/time format               */
 dcl SQLA_POA_EUR               fixed bin(31) value(2);
                                /* European date/time format          */
 dcl SQLA_POA_ISO               fixed bin(31) value(3);
                                /* International date/time format     */
 dcl SQLA_POA_JIS               fixed bin(31) value(4);
                                /* Japanese date/time format          */
 dcl SQLA_POA_LOC               fixed bin(31) value(5);
                                /* Local date/time format             */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_ACCESS_PLAN in the Precompiler Option Array.    */
 dcl SQLA_CREATE_PLAN           fixed bin(31) value(1);
                                /* Create an access plan              */
 dcl SQLA_NO_PLAN               fixed bin(31) value(0);
                                /* Do not create an access plan       */
 dcl SQLA_NO_PLAN_SYNTAX        fixed bin(31) value(3);
                                /* Set ocb->syntax to TRUE            */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_BIND_FILE in the Precompiler Option Array.      */
 dcl SQLA_CREATE_BIND_FILE      fixed bin(31) value(1);
                                /* Create a bind file                 */
 dcl SQLA_NO_BIND_FILE          fixed bin(31) value(0);
                                /* Do not create a bind file          */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_ISOLATION in the Precompiler Option Array.      */
 dcl SQLA_REPEATABLE_READ       fixed bin(31) value(SQL_REP_READ);
                                /* RR isolation level                 */
 dcl SQLA_CURSOR_STABILITY      fixed bin(31) value(SQL_CURSOR_STAB);
                                /* CS Isolation level                 */
 dcl SQLA_UNCOMMITTED_READ      fixed bin(31) value(SQL_UNCOM_READ);
                                /* UR Isolation level                 */
 dcl SQLA_READ_STABILITY        fixed bin(31) value(SQL_READ_STAB);
                                /* RS Isolation level                 */
 dcl SQLA_NO_COMMIT             fixed bin(31) value(SQL_NO_COMMIT);
                                /* NC Isolation level                 */

 /* Values used for option[n].val when option[n].type is SQLA_BLOCK */
 /* in the Precompiler Option Array.                                */
 dcl SQLA_BLOCK_UNAMBIG         fixed bin(31) value(SQL_BL_UNAMBIG);
 dcl SQLA_BLOCK_ALL             fixed bin(31) value(SQL_BL_ALL);
 dcl SQLA_NO_BLOCK              fixed bin(31) value(SQL_NO_BL);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQLA_LEVEL_OPT                                                  */
 dcl SQLA_MAX_LEVEL             fixed bin(31) value(SQL_MAX_LEVEL);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQLA_COLLECTION_OPT                                             */
 dcl SQLA_MAX_COLLECTION        fixed bin(31) value(SQL_MAX_COLLECTION);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQLA_VERSION_OPT                                                */
 dcl SQLA_MAX_VERSION           fixed bin(31) value(SQL_MAX_VERSION);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQLA_OWNER_OPT                                                  */
 dcl SQLA_MAX_OWNER             fixed bin(31) value(SQL_MAX_OWNER);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQLA_SCHEMA_OPT                                                 */
 dcl SQLA_MAX_SCHEMA            fixed bin(31) value(SQLA_MAX_OWNER);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQLA_QUALIFIER_OPT                                              */
 dcl SQLA_MAX_QUALIFIER         fixed bin(31) value(SQL_MAX_QUALIFIER);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQLA_CATALOG_OPT                                                */
 dcl SQLA_MAX_CATALOG           fixed bin(31) value(SQLA_MAX_QUALIFIER);

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQLA_TEXT_OPT                                                   */
 dcl SQLA_MAX_TEXT              fixed bin(31) value(SQL_MAX_TEXT);

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_VALIDATE_OPT.                                   */
 dcl SQLA_VALIDATE_BIND         fixed bin(31) value(SQL_VALIDATE_BIND);
                                /* Validate objects during BIND       */
 dcl SQLA_VALIDATE_RUN          fixed bin(31) value(SQL_VALIDATE_RUN);
                                /* Validate objects during execution  */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_EXPLAIN_OPT.                                    */
 dcl SQLA_EXPLAIN_NO            fixed bin(31) value(SQL_EXPLAIN_NO);
                                /* No EXPLAIN output produced         */
 dcl SQLA_EXPLAIN_YES           fixed bin(31) value(SQL_EXPLAIN_YES);
                                /* EXPLAIN output produced            */
 dcl SQLA_EXPLAIN_ALL           fixed bin(31) value(SQL_EXPLAIN_ALL);
                                /* EXPLAIN output produced for all    */
                                /* static and dynamic statements.     */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_ACTION_OPT.                                     */
 dcl SQLA_ACTION_ADD            fixed bin(31) value(SQL_ACTION_ADD);
                                /* Package is added                   */
 dcl SQLA_ACTION_REPLACE        fixed bin(31) value(SQL_ACTION_REPLACE);
                                /* Package is replaced                */

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQLA_REPLVER_OPT                                                */
 dcl SQLA_MAX_REPLVER           fixed bin(31) value(SQL_MAX_REPLVER);

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_SQLERROR_OPT.                                   */
 dcl SQLA_SQLERROR_NOPACKAGE   fixed bin(31) value(SQL_NO_SYNTAX_CHECK);
                                /* Do not create a package if errors  */
                                /* are encountered                    */
 dcl SQLA_SQLERROR_CHECK        fixed bin(31) value(SQL_SYNTAX_CHECK);
                                /* Do not create a package            */
 dcl SQLA_SQLERROR_CONTINUE  fixed bin(31) value(SQL_SQLERROR_CONTINUE);
                                /* Create a package even if errors    */
                                /* are encountered                    */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_RETAIN_OPT.                                     */
 dcl SQLA_RETAIN_NO             fixed bin(31) value(SQL_RETAIN_NO);
                                /* Do not preserve EXECUTE authorities*/
                                /* when a package is replaced         */
 dcl SQLA_RETAIN_YES            fixed bin(31) value(SQL_RETAIN_YES);
                                /* Preserve EXECUTE authorities when  */
                                /* a package is replaced              */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_RELEASE_OPT.                                    */
 dcl SQLA_RELEASE_COMMIT        fixed bin(31) value(SQL_RELEASE_COMMIT);
                                /* Release resources at COMMIT        */
 dcl SQLA_RELEASE_DEALLOCATE    fixed bin(31)
                                value(SQL_RELEASE_DEALLOCATE);
                                /* Release resources when a program   */
                                /* terminates                         */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_STRDEL_OPT.                                     */
 dcl SQLA_STRDEL_APOSTROPHE     fixed bin(31)
                                value(SQL_STRDEL_APOSTROPHE);
                                /* Apostrophe string delimiter        */
 dcl SQLA_STRDEL_QUOTE          fixed bin(31) value(SQL_STRDEL_QUOTE);
                                /* Quote string delimiter             */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_DECDEL_OPT.                                     */
 dcl SQLA_DECDEL_PERIOD         fixed bin(31) value(SQL_DECDEL_PERIOD);
                                /* Period is used as a decimal point  */
                                /* indicator in decimal and floating  */
                                /* point literals                     */
 dcl SQLA_DECDEL_COMMA          fixed bin(31) value(SQL_DECDEL_COMMA);
                                /* Comma is used as a decimal point   */
                                /* indicator in decimal and floating  */
                                /* point literals                     */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_CHARSUB_OPT.                                    */
 dcl SQLA_CHARSUB_DEFAULT      fixed bin(31) value(SQL_CHARSUB_DEFAULT);
                                /* Use the target system defined      */
                                /* default for all new character      */
                                /* columns for which an explicit      */
                                /* subtype is not specified           */
 dcl SQLA_CHARSUB_BIT           fixed bin(31) value(SQL_CHARSUB_BIT);
                                /* Use the bit character subtype for  */
                                /* all new character columns for      */
                                /* which an explicit subtype is not   */
                                /* specified                          */
 dcl SQLA_CHARSUB_SBCS          fixed bin(31) value(SQL_CHARSUB_SBCS);
                                /* Use the SBCS character subtype for */
                                /* all new character columns for      */
                                /* which an explicit subtype is not   */
                                /* specified                          */
 dcl SQLA_CHARSUB_MIXED         fixed bin(31) value(SQL_CHARSUB_MIXED);
                                /* Use the mixed character subtype    */
                                /* for all new character columns for  */
                                /* which an explicit subtype is not   */
                                /* specified                          */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_DEC_OPT.                                        */
 dcl SQLA_DEC_15                fixed bin(31) value(SQL_DEC_15);
                                /* 15 bit precision is used in        */
                                /* decimal arithmetic operations      */
 dcl SQLA_DEC_31                fixed bin(31) value(SQL_DEC_31);
                                /* 31 bit precision is used in        */
                                /* decimal arithmetic operations      */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_DEGREE_OPT.                                     */
 dcl SQLA_DEGREE_1              fixed bin(31) value(SQL_DEGREE_1);
                                /* Prohibits parallel I/O operations  */
 dcl SQLA_DEGREE_ANY            fixed bin(31) value(SQL_DEGREE_ANY);
                                /* Allows the target database system  */
                                /* to determine the degree of         */
                                /* parallel I/O operations            */
 dcl SQLA_MAX_DEGREE_VAL        fixed bin(31) value(SQL_MAX_DEGREE_VAL);
                                /* Maximum value                      */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_CNULREQD_OPT in the Precompiler Option array    */
 dcl SQLA_CNULREQD_NO           fixed bin(31) value(SQL_CNULREQD_NO);
                                /* C NULL is not required             */
 dcl SQLA_CNULREQD_YES          fixed bin(31) value(SQL_CNULREQD_YES);
                                /* C NULL is not required             */

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQLA_GENERIC_OPT                                                */
 dcl SQLA_MAX_GENERIC           fixed bin(31) value(SQL_MAX_GENERIC);

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_DEFERRED_PREPARE_OPT.                           */
 dcl SQLA_DEFERRED_PREPARE_YES  fixed bin(31)
                                value(SQL_DEFERRED_PREPARE_YES);
                                /* Enable Deferred Prepare except     */
                                /* for a PREPARE...INTO statement     */
                                /* which contains parameter markers.  */
 dcl SQLA_DEFERRED_PREPARE_NO   fixed bin(31)
                                value(SQL_DEFERRED_PREPARE_NO);
                                /* Disable Deferred Prepare           */
 dcl SQLA_DEFERRED_PREPARE_ALL  fixed bin(31)
                                value(SQL_DEFERRED_PREPARE_ALL);
                                /* Same as YES except that a          */
                                /* PREPARE...INTO which contains      */
                                /* parameter markers will also be     */
                                /* deferred                           */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_CONNECT_OPT.                                    */
 dcl SQLA_CONNECT_1           fixed bin(31) value(SQL_CONNECT_1);
                              /* Indicates that only one connection   */
                              /* to a database can exist at any       */
                              /* given time.                          */
 dcl SQLA_CONNECT_2           fixed bin(31) value(SQL_CONNECT_2);
                              /* Indicates that multiple              */
                              /* connections can exist                */
                              /* simultaneously, with one being       */
                              /* active and the others dormant.       */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_RULES_OPT.                                      */
 dcl SQLA_RULES_DB2           fixed bin(31) value(SQL_RULES_DB2);
                              /* Indicates that CONNECT TO can be     */
                              /* used to make a dormant connection    */
                              /* the current connection.              */
 dcl SQLA_RULES_STD           fixed bin(31) value(SQL_RULES_STD);
                              /* Indicates that CONNECT TO is not     */
                              /* valid for making a dormant           */
                              /* connection current, and SET          */
                              /* CONNECTION must be used instead.     */
 /* Values used for option[n].val when option[n].type is */
 /* SQLA_DISCONNECT_OPT.                                 */
 dcl SQLA_DISCONNECT_EXPL     fixed bin(31) value(SQL_DISCONNECT_EXPL);
                              /* Indicates that all connections       */
                              /* marked by the RELEASE statement      */
                              /* will be the only connections         */
                              /* released when a COMMIT or ROLLBACK   */
                              /* is issued.                           */
 dcl SQLA_DISCONNECT_COND     fixed bin(31) value(SQL_DISCONNECT_COND);
                              /* Indicates that all connections       */
                              /* which don't have open WITH HOLD      */
                              /* cursors will be the only             */
                              /* connections released when a COMMIT   */
                              /* or ROLLBACK is issued.               */
 dcl SQLA_DISCONNECT_AUTO     fixed bin(31) value(SQL_DISCONNECT_AUTO);
                              /* Indicates that all connections       */
                              /* will be released when a COMMIT       */
                              /* or ROLLBACK is issued.               */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_SYNCPOINT_OPT.                                  */
 dcl SQLA_SYNC_ONEPHASE       fixed bin(31) value(SQL_SYNC_ONEPHASE);
                              /* Do not use a transaction manager     */
                              /* to perform two phase commit, but     */
                              /* enforce that one database is         */
                              /* updated when multiple databases      */
                              /* are accessed within a single         */
                              /* transaction.              */
 dcl SQLA_SYNC_TWOPHASE       fixed bin(31) value(SQL_SYNC_TWOPHASE);
                              /* Use a transaction manager to         */
                              /* coordinate two phase commit.         */
 dcl SQLA_SYNC_NONE           fixed bin(31) value(SQL_SYNC_NONE);
                              /* No two-phase commit and no single    */
                              /* updater enforcement.                 */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_DYNAMICRULES_OPT.                               */
 dcl SQLA_DYNAMICRULES_RUN    fixed bin(31) value(SQL_DYNAMICRULES_RUN);
                              /* Dynamic SQL in package will use      */
                              /* authid of person running the package */
 dcl SQLA_DYNAMICRULES_BIND   fixed bin(31)
                              value(SQL_DYNAMICRULES_BIND);
                              /* Dynamic SQL in package will use      */
                              /* authid of person who owns the        */
                              /* package                              */
 dcl SQLA_DYNAMICRULES_INVOKE fixed bin(31)
                              value(SQL_DYNAMICRULES_INVOKE);
                              /* Dynamic SQL in UDF or stored         */
                              /* procedure will use authid of invoker */
                              /* of UDF or stored procedure           */
 dcl SQLA_DYNAMICRULES_DEFINE fixed bin(31)
                              value(SQL_DYNAMICRULES_DEFINE);
                              /* Dynamic SQL in UDF or stored         */
                              /* procedure will use authid of definer */
                              /* of UDF or stored procedure           */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_FLAG_OPT in the Precompiler Option Array.       */
 dcl SQLA_DB2V23_SYNTAX       fixed bin(31) value(SQL_MVSDB2V23_SYNTAX);
 dcl SQLA_DB2V31_SYNTAX       fixed bin(31) value(SQL_MVSDB2V31_SYNTAX);
 dcl SQLA_DB2V41_SYNTAX       fixed bin(31) value(SQL_MVSDB2V41_SYNTAX);
 dcl SQLA_FIPS_SYNTAX         fixed bin(31) value(SQL_SQL92E_SYNTAX);

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_EXPLSNAP_OPT in the Precompiler Option array    */
 dcl SQLA_EXPLSNAP_NO         fixed bin(31) value(SQL_EXPLSNAP_NO);
                              /* Do not save explain snapshot         */
 dcl SQLA_EXPLSNAP_YES        fixed bin(31) value(SQL_EXPLSNAP_YES);
                              /* Save explain snapshot                */
 dcl SQLA_EXPLSNAP_ALL        fixed bin(31) value(SQL_EXPLSNAP_ALL);
                              /* Save explain snapshot for all static */
                              /* and dynamic statements               */

 /* Maximum sqlchar length for option[n].val when option[n].type is */
 /* SQLA_FUNCTION_PATH                                              */
 dcl SQLA_MAX_FUNCPATH        fixed bin(31) value(SQL_MAX_FUNCPATH);

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_SQLWARN_OPT in the Precompiler Option array     */
 dcl SQLA_SQLWARN_NO          fixed bin(31) value(SQL_SQLWARN_NO);
                              /* Suppress prepare-time     */
                              /* warning SQLCODEs          */
 dcl SQLA_SQLWARN_YES         fixed bin(31) value(SQL_SQLWARN_YES);
                              /* Permit prepare-time       */
                              /* warning SQLCODEs          */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_QUERYOPT_OPT in the Precompiler Option array    */
 dcl SQLA_QUERYOPT_0          fixed bin(31) value(SQL_QUERYOPT_0);
                              /* Class 0 query optimization           */
 dcl SQLA_QUERYOPT_1          fixed bin(31) value(SQL_QUERYOPT_1);
                              /* Class 1 query optimization           */
 dcl SQLA_QUERYOPT_2          fixed bin(31) value(SQL_QUERYOPT_2);
                              /* Class 2 query optimization           */
 dcl SQLA_QUERYOPT_3          fixed bin(31) value(SQL_QUERYOPT_3);
                              /* Class 3 query optimization           */
 dcl SQLA_QUERYOPT_5          fixed bin(31) value(SQL_QUERYOPT_5);
                              /* Class 5 query optimization           */
 dcl SQLA_QUERYOPT_7          fixed bin(31) value(SQL_QUERYOPT_7);
                              /* Class 7 query optimization           */
 dcl SQLA_QUERYOPT_9          fixed bin(31) value(SQL_QUERYOPT_9);
                              /* Class 9 query optimization           */

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_INSERT_OPT                                      */
 dcl SQLA_INSERT_DEF          fixed bin(31) value(SQL_INSERT_DEF);
                              /* Do not buffer VALUE inserts          */
 dcl SQLA_INSERT_BUF          fixed bin(31) value(SQL_INSERT_BUF);
                              /* Buffer VALUE inserts                 */

 /* Maximum target string length in option[n].val when option[n].type */
 /* is SQLA_TARGET_OPT                                                */
 dcl SQLA_MAX_TARGET_LEN    fixed bin(31) value(SQL_MAX_TARGET_LEN);

 /* Values used for option[n].val when option[n].type is */
 /* SQLA_STDS_LEVEL inthe Precompiler Option Array.      */
 dcl SQLA_STND_NONE           fixed bin(31) value(0);
                              /* No compliance required    */
 dcl SQLA_STND_MIA            fixed bin(31) value(1);
                              /* Comply with MIA standard  */
 dcl SQLA_STND_SQL92E         fixed bin(31) value(2);
                              /* Comply with SQL92E        */
                              /* standard                  */

 /* Values used for location, an input parameter of SQLAAHVR. */
 dcl SQLA_DECLARE_SECT        fixed bin(31) value(0);
                              /* Add host var found in a declare     */
                              /* section                             */
 dcl SQLA_SQL_STMT            fixed bin(31) value(1);
                              /* Add host var found in an SQL        */
                              /* statement                           */

 /* Values assigned to task[n].func, an output parameter of SQLACMPL. */
 dcl SQLA_START               fixed bin(31) value(0);
                              /* Generate a call to sqlastrt         */
 dcl SQLA_DECLARE             fixed bin(31) value(1);
                              /* Begin or end parsing hvar           */
                              /* declarations                        */
 dcl SQLA_INCLUDE             fixed bin(31) value(2);
                              /* Generate code for an SQLCA or       */
                              /* SQLDA                               */
 dcl SQLA_ALLOC_INPUT         fixed bin(31) value(3);
                              /* Allocate an input SQLDA using       */
                              /* SQLAALOC                            */
 dcl SQLA_ALLOC_OUTPUT        fixed bin(31) value(4);
                              /* Allocate an output SQLDA using      */
                              /* SQLAALOC                            */
 dcl SQLA_SETS                fixed bin(31) value(5);
                              /* Register a host variable using      */
                              /* SQLASETS                            */
 dcl SQLA_USDA_INPUT          fixed bin(31) value(6);
                              /* Register an input user-defined      */
                              /* SQLDA                               */
 dcl SQLA_USDA_OUTPUT         fixed bin(31) value(7);
                              /* Register an output user-defined     */
                              /* SQLDA                               */
 dcl SQLA_CALL                fixed bin(31) value(8);
                              /* Generate a call to SQLACALL         */
 dcl SQLA_DEALLOC             fixed bin(31) value(9);
                              /* Generate a call to SQLADLOC         */
 dcl SQLA_STOP                fixed bin(31) value(10);
                              /* Generate a call to SQLASTOP         */
 dcl SQLA_SQLERROR            fixed bin(31) value(11);
                              /* Generate code for WHENEVER          */
                              /* SQLERROR                            */
 dcl SQLA_SQLWARNING          fixed bin(31) value(12);
                              /* Generate code for WHENEVER          */
                              /* SQLWARNING                          */
 dcl SQLA_NOT_FOUND           fixed bin(31) value(13);
                              /* Generate code for WHENEVER NOT      */
                              /* FOUND                               */
 dcl SQLA_INC_TEXTFILE        fixed bin(31) value(14);
                              /* Process an INCLUDE text-file stmt   */
 dcl SQLA_BEGIN_COMPOUND      fixed bin(31) value(15);
                              /* Begin Compound SQL block            */
 dcl SQLA_CMPD                fixed bin(31) value(16);
                              /* Generate a call to SQLACMPD         */
 dcl SQLA_CMPD_TEST           fixed bin(31) value(17);
                              /* Generate a conditional branch       */
                              /* around subsequent Compound SQL      */
                              /* substatements.                      */
 dcl SQLA_CMPD_MARK           fixed bin(31) value(18);
                              /* Generate a target label for gotos   */
                              /* from cmpd_test (optional)           */
 dcl SQLA_NEXT_SUBSTATEMENT   fixed bin(31) value(19);
                              /* Request the outer precompiler to    */
                              /* get the next triggered SQL          */
                              /* statement                           */
 dcl SQLA_SQLCODE_COPY        fixed bin(31) value(20);
                              /* Generate code to copy SQLCODE       */
                              /* SQLSTATE                            */
 dcl SQLA_NEXT_STOREDPROC_STMT fixed bin(31) value(21);
                              /* Request the outer precompiler  */
                              /* to get the next stored         */
                              /* procedure SQL statement        */
 dcl SQLA_ASSOCIATE_LOCATOR   fixed bin(31) value(22);
                              /* Generate code for ASSOCIATE    */
                              /* LOCATOR                        */
 dcl SQLA_ASSOCIATE_PREV_PROC fixed bin(31) value(23);
                              /* Save last called procedure     */
                              /* informationor generate code    */
                              /* for ASSOCIATE LOCATOR          */
                              /* referring to the last called   */
                              /* procedure                      */
 dcl SQLA_ALLOCATE_CURSOR     fixed bin(31) value(24);
                              /* Generate code for ALLOCATE     */
                              /* CURSOR                         */

 /* Values returned in task[n].val when task[n].func is SQLA_DECLARE. */
 /* This is an output parameter of SQLACMPL.                          */
 dcl SQLA_BEGIN               fixed bin(31) value(0);
 dcl SQLA_END                 fixed bin(31) value(1);

 /* Values returned in task[n].val when task[n].func is SQLA_INCLUDE. */
 /* This is an output parameter of SQLACMPL.                          */
 dcl SQLA_SQLCA               fixed bin(31) value(10);
 dcl SQLA_SQLDA               fixed bin(31) value(11);

 /* Values returned in task[n].val when task[n].func is SQLA_CALL.    */
 /* This is an output parameter of SQLACMPL.                          */
 dcl SQLA_CLOSE                    fixed bin(31) value(20);
 dcl SQLA_COMMIT                   fixed bin(31) value(21);
 dcl SQLA_DESCRIBE                 fixed bin(31) value(22);
 dcl SQLA_EXECIMMD                 fixed bin(31) value(23);
 dcl SQLA_EXECUTE                  fixed bin(31) value(24);
 dcl SQLA_FETCH                    fixed bin(31) value(25);
 dcl SQLA_OPEN                     fixed bin(31) value(26);
 dcl SQLA_PREPARE                  fixed bin(31) value(27);
 dcl SQLA_ROLLBACK                 fixed bin(31) value(28);
 dcl SQLA_CONNECT                  fixed bin(31) value(29);
 dcl SQLA_CMPDEXEC                 fixed bin(31) value(30);
                                   /* Atomic Compound SQL call        */
 dcl SQLA_FREE_LOB_LOCATORS        fixed bin(31) value(37);
                                   /* SQL free locators call          */
 dcl SQLA_CMPDEXEC_NA              fixed bin(31) value(38);
                                   /* Not Atomic Compound SQL call    */
 dcl SQLA_DUOW                     fixed bin(31) value(40);
 dcl SQLA_CLOSE_REL                fixed bin(31) value(41);
                                   /* Close Cursor with Release       */
 dcl SQLA_CALLPROC                 fixed bin(31) value(42);
                                   /* Stored Procedure SQL call       */
 dcl SQLA_SET_CURRENT_PKGSET       fixed bin(31) value(43);
                                   /* Set Current Packageset          */
 dcl SQLA_EXECIMMD_ASYNC           fixed bin(31) value(44);
 dcl SQLA_EXECUTE_ASYNC            fixed bin(31) value(45);
 dcl SQLA_FETCH_ASYNC              fixed bin(31) value(46);
 dcl SQLA_OPEN_ASYNC               fixed bin(31) value(47);
 dcl SQLA_CALLPROC_ASYNC           fixed bin(31) value(48);
 dcl SQLA_CMPDEXEC_ASYNC           fixed bin(31) value(49);
 dcl SQLA_DESCRIBE_ASYNC           fixed bin(31) value(50);
 dcl SQLA_PREPARE_ASYNC            fixed bin(31) value(51);
 dcl SQLA_EXECIMMD_ASYNC_COMMIT    fixed bin(31) value(52);
 dcl SQLA_EXECUTE_ASYNC_COMMIT     fixed bin(31) value(53);
 dcl SQLA_CMPDEXEC_ASYNC_COMMIT    fixed bin(31) value(54);
 dcl SQLA_EXECIMMD_COMMIT          fixed bin(31) value(55);
 dcl SQLA_EXECUTE_COMMIT           fixed bin(31) value(56);
 dcl SQLA_CMPDEXEC_COMMIT          fixed bin(31) value(57);
 dcl SQLA_CMPDEXEC_NA_ASYNC        fixed bin(31) value(58);
 dcl SQLA_CMPDEXEC_NA_COMMIT       fixed bin(31) value(59);
 dcl SQLA_CMPDEXEC_NA_DIAG         fixed bin(31) value(60);
 dcl SQLA_CMPDEXEC_NA_ASYNC_COMMIT fixed bin(31) value(61);
 dcl SQLA_CMPDEXEC_NA_ASYNC_DIAG   fixed bin(31) value(62);
 dcl SQLA_CMPDEXEC_NA_COMMIT_DIAG  fixed bin(31) value(63);
 dcl SQLA_CMPDEXEC_NA_A_C_D        fixed bin(31) value(64);
 dcl SQLA_CLOSE_OPEN               fixed bin(31) value(65);
 dcl SQLA_CLOSE_OPEN_ASYNC         fixed bin(31) value(66);
 dcl SQLA_CLOSEREL_OPEN_ASYNC      fixed bin(31) value(67);
 dcl SQLA_CLOSEREL_OPEN            fixed bin(31) value(68);
 dcl SQLA_SETOPTION                fixed bin(31) value(69);
 dcl SQLA_DESCRIBE_CURSOR          fixed bin(31) value(70);
 dcl SQLA_DESCRIBE_CURSOR_ASYNC    fixed bin(31) value(71);
 dcl SQLA_ARRAYINPUT               fixed bin(31) value(72);
 dcl SQLA_ARRAYINPUT_ASYNC         fixed bin(31) value(73);
 dcl SQLA_GETINFO                  fixed bin(31) value(74);
 dcl SQLA_OPEN_WITH_RETURN         fixed bin(31) value(75);
 dcl SQLA_OPEN_WITH_RETURN_TO_CLIENT fixed bin(31) value(76);

 /* Values returned in task[n].val when task[n].func is         */
 /* SQLA_SQLCODE_COPY. This is an output parameter of SQLACMPL. */

 dcl SQLA_SQLCODE              fixed bin(31) value(1);
                               /* Copy SQLCODE and/or SQLSTATE        */
 dcl SQLA_SQLCODE_PREP_ERROR   fixed bin(31) value(2);
                               /* Copy PREP errors                    */

 /* Values assigned to token[n].use, an output parameter of SQLACMPL. */
 dcl SQLA_INPUT_HVAR           fixed bin(31) value(0);
                               /* Input host var, no indicator var    */
 dcl SQLA_INPUT_WITH_IND       fixed bin(31) value(1);
                               /* Input host var followed by          */
                               /* indicator var                       */
 dcl SQLA_OUTPUT_HVAR          fixed bin(31) value(2);
                               /* Output host var, no indicator var   */
 dcl SQLA_OUTPUT_WITH_IND      fixed bin(31) value(3);
                               /* Output host var followed by         */
                               /* indicator var                       */
 dcl SQLA_INDICATOR            fixed bin(31) value(4);
                               /* Indicator variable                  */
 dcl SQLA_USER_SQLDA           fixed bin(31) value(5);
                               /* SQLDA structure                     */
 dcl SQLA_INVALID_USE          fixed bin(31) value(6);
                               /* Host variable type does not match   */
                               /* use                                 */
 dcl SQLA_INVALID_ID           fixed bin(31) value(7);
                               /* Host variable token ID is not       */
                               /* valid                               */
 dcl SQLA_LITERAL              fixed bin(31) value(8);
                               /* Literal string                      */
 dcl SQLA_MULTIPLE_STRUCT_FIELD fixed bin(31) value(9);
                               /* Host var was one of several fields  */
                               /* expanded from a structure           */
                               /* reference                           */
 dcl SQLA_ATOMIC_FIELD         fixed bin(31) value(10);
                               /* Host var was either atomic or a     */
                               /* single field from a structure       */
                               /* reference                           */

 /* Values assigned to stmt_type, an output parameter of SQLACMPL. */
 dcl SQLA_TYPE_NULL_CONNECT        fixed bin(31) value(0);
 dcl SQLA_TYPE_CONN_EXCL_NO_PWD    fixed bin(31) value(1);
 dcl SQLA_TYPE_CONN_EXCL_PWD       fixed bin(31) value(2);
 dcl SQLA_TYPE_CONN_EXCL_NO_PWD_SN fixed bin(31) value(91);
 dcl SQLA_TYPE_CONN_EXCL_PWD_SN    fixed bin(31) value(92);
 dcl SQLA_TYPE_CONNECT_RESET       fixed bin(31) value(3);
 dcl SQLA_TYPE_CONN_SHARE_NO_PWD   fixed bin(31) value(4);
 dcl SQLA_TYPE_CONN_SHARE_PWD      fixed bin(31) value(5);
 dcl SQLA_TYPE_CONNECT_USERID      fixed bin(31) value(6);
 dcl SQLA_TYPE_BEGIN               fixed bin(31) value(10);
 dcl SQLA_TYPE_BEGIN_COMPOUND      fixed bin(31) value(12);
 dcl SQLA_TYPE_CALLPROC            fixed bin(31) value(13);
 dcl SQLA_TYPE_CLOSE               fixed bin(31) value(15);
 dcl SQLA_TYPE_COMMIT              fixed bin(31) value(20);
 dcl SQLA_TYPE_CONNECT_1           fixed bin(31) value(21);
 dcl SQLA_TYPE_CONNECT_2           fixed bin(31) value(22);
 dcl SQLA_TYPE_DISCONNECT_DBNAME   fixed bin(31) value(23);
 dcl SQLA_TYPE_DISCONNECT_CURRENT  fixed bin(31) value(24);
 dcl SQLA_TYPE_DISCONNECT_ALL      fixed bin(31) value(25);
 dcl SQLA_TYPE_RELEASE_DBNAME      fixed bin(31) value(26);
 dcl SQLA_TYPE_RELEASE_CURRENT     fixed bin(31) value(27);
 dcl SQLA_TYPE_RELEASE_ALL         fixed bin(31) value(28);
 dcl SQLA_TYPE_SET_CONNECTION      fixed bin(31) value(29);
 dcl SQLA_TYPE_DECLARE_SELECT      fixed bin(31) value(30);
 dcl SQLA_TYPE_DECLARE_SNAME       fixed bin(31) value(40);
 dcl SQLA_TYPE_ALLOCATE_CURSOR     fixed bin(31) value(45);
 dcl SQLA_TYPE_DESCRIBE            fixed bin(31) value(50);
 dcl SQLA_TYPE_DESCRIBE_CURSOR     fixed bin(31) value(55);
 dcl SQLA_TYPE_END                 fixed bin(31) value(60);
 dcl SQLA_TYPE_END_COMPOUND        fixed bin(31) value(65);
 dcl SQLA_TYPE_EXECUTE             fixed bin(31) value(70);
 dcl SQLA_TYPE_EXECUTE_IMM         fixed bin(31) value(80);
 dcl SQLA_TYPE_FETCH               fixed bin(31) value(90);
 dcl SQLA_TYPE_FREE_LOB_LOCATOR    fixed bin(31) value(95);
 dcl SQLA_TYPE_INCLUDE_SQLCA       fixed bin(31) value(100);
 dcl SQLA_TYPE_INCLUDE_SQLDA       fixed bin(31) value(110);
 dcl SQLA_TYPE_INCLUDE_TEXTFILE    fixed bin(31) value(115);
 dcl SQLA_TYPE_OPEN                fixed bin(31) value(120);
 dcl SQLA_TYPE_PREPARE             fixed bin(31) value(130);
 dcl SQLA_TYPE_ROLLBACK            fixed bin(31) value(140);
 dcl SQLA_TYPE_SELECT              fixed bin(31) value(150);
 dcl SQLA_TYPE_SELECT_INTO         fixed bin(31) value(160);
 dcl SQLA_TYPE_SET_CURRENT_PKGSET  fixed bin(31) value(163);
 dcl SQLA_TYPE_WHEN_NOT_FOUND      fixed bin(31) value(170);
 dcl SQLA_TYPE_WHEN_SQLERROR       fixed bin(31) value(180);
 dcl SQLA_TYPE_WHEN_SQLWARNING     fixed bin(31) value(190);
 dcl SQLA_TYPE_OTHER               fixed bin(31) value(200);

 /* Values used for term_option, an input parameter of SQLAFINI. */
 dcl SQLA_SAVE                 fixed bin(31) value(1);
                               /* Save the access plan and/or bind    */
                               /* file                                */
 dcl SQLA_DISCARD              fixed bin(31) value(0);
                               /* Discard the access plan and/or      */
                               /* bind file                           */

 /* Miscellaneous Constants */

 dcl SQL_MAX_FILE_NAME_LENGTH  fixed bin(31) value(128);
                               /* size of SQLAINIT file name buffer   */

 dcl SQL_CMPL_BUFSIZ           fixed bin(31) value(256);
                               /* size of SQLACMPL output buffers     */
 dcl SQL_PID_LENGTH_V610       fixed bin(31) value(40);
                               /* length of precompiler pid for V6.1  */
                               /* or earlier                          */
 dcl SQL_PID_LENGTH            fixed bin(31) value(162);
                               /* length of precompiler pid           */
 dcl SQL_MIN_PID_LENGTH        fixed bin(31) value(34);
                               /* minimum length of precompiler pid   */
 dcl SQLA_FLAG_MAXMSGS         fixed bin(31) value(10);
                               /* Message array length same as SQLH   */
                               /* MAXMSGS                             */
 dcl SQLA_FLAG_VERSION         fixed bin(31) value(1);
                               /* Current SQL Flagger version         */

 /* Return codes from Precompiler Services and Runtime Services */
 /* functions.                                                  */
 dcl SQLA_SQLCA_BAD            fixed bin(31) value(-1);
                               /* sqlca pointer/length invalid        */
 dcl SQLA_CHECK_SQLCA          fixed bin(31) value(0);
                               /* check sqlca completion status       */

 /* Values returned in sqlca.sqlcode by Precompiler */
 /* or Runtime Services                             */
 dcl SQLA_RC_OK                    fixed bin(31) value(SQL_RC_OK);
 dcl SQLA_RC_OPTION_IGNORED        fixed bin(31) value(20);
 dcl SQLA_RC_CHAR_BAD              fixed bin(31) value(SQL_RC_E007);
 dcl SQLA_RC_STRING_NOT_TERMINATED fixed bin(31) value(SQL_RC_E010);
 dcl SQLA_RC_EMPTY_DEL_IDENT       fixed bin(31) value(SQL_RC_E013);
 dcl SQLA_RC_BFILE_OPEN_ERROR      fixed bin(31) value(-31);
 dcl SQLA_RC_BFILE_DISK_ERROR      fixed bin(31) value(-32);
 dcl SQLA_RC_SECTION_LIMIT         fixed bin(31) value(-51);
 dcl SQLA_RC_MEMORY_BAD            fixed bin(31) value(-83);
 dcl SQLA_RC_SNAME_DUP             fixed bin(31) value(-85);
 dcl SQLA_RC_NO_STRUCT             fixed bin(31) value(-87);
 dcl SQLA_RC_AMBIG_HOSTVAR         fixed bin(31) value(-88);
 dcl SQLA_RC_STMT_LIMIT            fixed bin(31) value(SQL_RC_E101);
 dcl SQLA_RC_NUMBER_BAD            fixed bin(31) value(SQL_RC_E103);
 dcl SQLA_RC_STMT_SYNTAX_BAD       fixed bin(31) value(SQL_RC_E104);
 dcl SQLA_RC_GSTRING_BAD           fixed bin(31) value(SQL_RC_E105);
                                   /* DBCS only               */
 dcl SQLA_RC_IDENTIFIER_LIMIT      fixed bin(31) value(SQL_RC_E107);
 dcl SQLA_RC_QUALIFIER_BAD         fixed bin(31) value(SQL_RC_E108);
 dcl SQLA_RC_DDSBAD                fixed bin(31) value(SQL_RC_E142);
 dcl SQLA_RC_DDSIGN                fixed bin(31) value(SQL_RC_W143);
 dcl SQLA_RC_DDSWRN                fixed bin(31) value(SQL_RC_W143);
 dcl SQLA_RC_STMT_IGNORED          fixed bin(31) value(SQL_RC_W143);
 dcl SQLA_RC_KEYWORD_BAD           fixed bin(31) value(SQL_RC_E199);
 dcl SQLA_RC_HVAR_NOT_DEC          fixed bin(31) value(-306);
 dcl SQLA_RC_HVAR_DUP_NAME         fixed bin(31) value(-307);
 dcl SQLA_RC_HVAR_LIMIT            fixed bin(31) value(-308);
 dcl SQLA_RC_STMT_HVAR_LIMIT       fixed bin(31) value(-310);
 dcl SQLA_RC_HVAR_USE_BAD          fixed bin(31) value(-324);
 dcl SQLA_RC_CURSOR_DUP            fixed bin(31) value(-505);
 dcl SQLA_RC_STMT_MODIFY_ALL       fixed bin(31) value(513);
 dcl SQLA_RC_INVALID_TRIGGER_STMT  fixed bin(31) value(SQL_RC_E797);
 dcl SQLA_RC_SQLDA_SQLD_ERR        fixed bin(31) value(SQL_RC_E804);
 dcl SQLA_RC_SQLVAR_TYPE_ERR       fixed bin(31) value(SQL_RC_E804);
 dcl SQLA_RC_DISK_FULL             fixed bin(31) value(SQL_RC_E968);
 dcl SQLA_RC_NODE_FAILURE          fixed bin(31) value(SQL_RC_E1229);
 dcl SQLA_RC_CMPD_NESTED           fixed bin(31) value(-4010);
 dcl SQLA_RC_CMPD_INVALID_STMT     fixed bin(31) value(-4011);
 dcl SQLA_RC_CMPD_INVALID_COMMIT   fixed bin(31) value(-4012);
 dcl SQLA_RC_CMPD_INVALID_END      fixed bin(31) value(-4013);
 dcl SQLA_RC_INVALID_CMPD_SYNTAX   fixed bin(31) value(-4014);
 dcl SQLA_RC_FATAL_ERROR           fixed bin(31) value(-4901);
 dcl SQLA_RC_PARM_CHARS_BAD        fixed bin(31) value(-4902);
 dcl SQLA_RC_PARM_LENGTH_BAD       fixed bin(31)
                                   value(SQLA_RC_OPTION_LEN_BAD);
 dcl SQLA_RC_PARM_POINTER_BAD      fixed bin(31)
                                   value(SQLA_RC_OPTION_PTR_BAD);
 dcl SQLA_RC_PARM_RANGE_BAD        fixed bin(31)
                                   value(SQLA_RC_OPTION_SIZE_BAD);
 dcl SQLA_RC_HVAR_SQLTYPE_BAD      fixed bin(31) value(-4911);
 dcl SQLA_RC_HVAR_SQLLEN_BAD       fixed bin(31) value(-4912);
 dcl SQLA_RC_HVAR_TOKEN_ID_DUP     fixed bin(31) value(-4913);
 dcl SQLA_RC_HVAR_TOKEN_ID_BAD     fixed bin(31) value(-4914);
 dcl SQLA_RC_INIT_DUP              fixed bin(31) value(-4915);
 dcl SQLA_RC_INIT_REQUIRED         fixed bin(31) value(-4916);
 dcl SQLA_RC_OPTION_BAD            fixed bin(31)
                                   value(SQLA_RC_OPTION_DATA_BAD);
 dcl SQLA_RC_TERM_OPTION_BAD       fixed bin(31) value(-4918);
 dcl SQLA_RC_TASK_ARRAY_LIMIT      fixed bin(31) value(-4919);
 dcl SQLA_RC_TOKEN_ARRAY_LIMIT     fixed bin(31) value(-4920);
 dcl SQLA_RC_OPTION_GEN_INVALID    fixed bin(31)
                                   value(SQLA_RC_OPTION_INVALID);
 dcl SQLA_RC_STMT_CLAUSE_BAD       fixed bin(31) value(-4940);
                                   /* Prep version of -109    */
 dcl SQLA_RC_STMT_BLANK            fixed bin(31) value(-4941);
                                   /* Prep version of -198    */
 dcl SQLA_RC_SELECT_HVAR_TYPE_BAD  fixed bin(31) value(-4942);
                                   /* Prep version of -303    */
 dcl SQLA_RC_SELECT_LIST_BAD       fixed bin(31) value(4943);
                                   /* Prep version of -313    */
 dcl SQLA_RC_COLUMN_NOT_NULLABLE   fixed bin(31) value(-4944);
                                   /* Prep version of -407    */
 dcl SQLA_RC_STMT_MARKER_BAD       fixed bin(31) value(-4945);
                                   /* Prep version of -418    */
 dcl SQLA_RC_CURSOR_NOT_DECLARED   fixed bin(31) value(-4946);
                                   /* Prep version of -504    */
 dcl SQLA_RC_NO_USERDA_IN_CMPD     fixed bin(31) value(-4950);
 dcl SQLA_RC_SQLDA_ID_BAD          fixed bin(31) value(-4951);
 dcl SQLA_RC_SQLVAR_INDEX_BAD      fixed bin(31) value(-4952);
 dcl SQLA_RC_CALL_TYPE_BAD         fixed bin(31) value(-4953);
 dcl SQLA_RC_SECTION_BAD           fixed bin(31) value(-4954);

 /* Temporary value used in sqlca.sqlcode after an SQLAALOC function. */
 /* Runtime code can check sqlca.sqlcode to determine whether or not  */
 /* the SQLASETV function needs to be called to initialize the sqlda  */
 /* sqlvar elements.                                                  */
 dcl SQLA_RC_SQLVARS_SET           fixed bin(31) value(4959);
                                   /* sqlvars already initialized     */

 /* Errors that cause Precompiler Services to enter the fatal error   */
 /* state. After encountering one of these types of errors,           */
 /* Precompiler Services requires an SQLAFINI and SQLAINIT call       */
 /* before it will continue.                                          */

 dcl SQLA_RC_INV_INSERT            fixed bin(31) value(SQL_RC_E803);
 dcl SQLA_RC_INV_SQLDA_ADR         fixed bin(31) value(SQL_RC_E822);
 dcl SQLA_RC_SYS_ERROR             fixed bin(31) value(SQL_RC_E902);
 dcl SQLA_RC_DEADLOCK_ERR          fixed bin(31) value(SQL_RC_E911);
 dcl SQLA_RC_FAT_SYS_ERR           fixed bin(31) value(SQL_RC_E912);
 dcl SQLA_RC_TOO_MANY_LKS          fixed bin(31) value(SQL_RC_E930);
 dcl SQLA_RC_STORAGE_ERR           fixed bin(31) value(SQL_RC_E954);
 dcl SQLA_RC_DB_HEAP_ERR           fixed bin(31) value(SQL_RC_E956);
 dcl SQLA_RC_TOOMANY_OFLS          fixed bin(31) value(SQL_RC_E958);
 dcl SQLA_RC_TOOMANY_FILES         fixed bin(31) value(SQL_RC_E960);
 dcl SQLA_RC_LOG_FULL              fixed bin(31) value(SQL_RC_E964);
 dcl SQLA_RC_FILE_SYS_FULL         fixed bin(31) value(SQL_RC_E968);
 dcl SQLA_RC_READ_ONLY_FIL         fixed bin(31) value(SQL_RC_E970);

 dcl SQLA_RC_INCORRECT_DSK         fixed bin(31) value(-972);
 dcl SQLA_RC_DB_DRV_LOCKED         fixed bin(31) value(-974);
 dcl SQLA_RC_DRV_DOOR_OPEN         fixed bin(31) value(-976);
 dcl SQLA_RC_DISK_WRT_PRO          fixed bin(31) value(-978);
 dcl SQLA_RC_FILESYSTEM_ACCESS     fixed bin(31) value(-10019);

 dcl SQLA_RC_DISK_ERROR            fixed bin(31) value(SQL_RC_E980);
 dcl SQLA_RC_DISK_ERR              fixed bin(31) value(SQL_RC_E982);
 dcl SQLA_RC_COMM_RB_ERR           fixed bin(31) value(SQL_RC_E984);
 dcl SQLA_RC_CAT_FILE_ERR          fixed bin(31) value(SQL_RC_E985);
 dcl SQLA_RC_TAB_FILE_ERR          fixed bin(31) value(SQL_RC_E986);
 dcl SQLA_RC_INDEX_ERR             fixed bin(31) value(SQL_RC_E990);
 dcl SQLA_RC_REL_NUM_BAD           fixed bin(31) value(SQL_RC_E992);
 dcl SQLA_RC_AGENT_GONE            fixed bin(31)
                                   value(SQLE_RC_AGENT_GONE);
 dcl SQLA_RC_CTRL_BREAK            fixed bin(31) value(-4994);
                                   /* Prep version of -952      */
 dcl SQLA_RC_CODEPAGE_BAD          fixed bin(31) value(-4995);
                                   /* Country info not found    */
 dcl SQLA_RC_SQLUSER_BAD           fixed bin(31) value(-4997);
                                   /* Prep version of -1046     */
 dcl SQLA_RC_DB_DISCONNECTED       fixed bin(31) value(-4998);
                                   /* Prep version of -1049     */
 dcl SQLA_RC_INTERNAL_ERR          fixed bin(31) value(-4999);
                                   /* Precompiler Services err  */

 /*********************************************************************/
 /* NOTE: sqlaopts has been obsoleted in favor of sqlaoptions.        */
 /* sqlaopts will be unavailable in future releases                   */
 /*********************************************************************/

 /*********************************************************************/
 /* Target API constants for sqlaopts()                               */
 /*********************************************************************/
 dcl SQLAO_PREP_SVCS_API      fixed bin(31) value(0);
                              /* Precompiler Services API (sqlainit)  */

 dcl sqlaopts                            /* Parse an option string    */
                                         /* and produce an option     */
                                         /* array                     */
     entry (char(*) var byaddr,          /* option string             */
            pointer,                     /* option array (sqlopt)     */
            pointer,                     /* database name (sqlainit   */
                                         /* only)                     */
            pointer,                     /* userid (sqlainit only)    */
            pointer,                     /* password (sqlainit only)  */
            pointer,                     /* message file name         */
            pointer,                     /* package name (sqlainit    */
                                         /* only)                     */
            pointer,                     /* bind file name (sqlainit  */
                                         /* only)                     */
            fixed bin(31),               /* target API                */
            pointer,                     /* memory handle             */
            pointer)                     /* SQLCA                     */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlaopts');

 /*********************************************************************/
 /* NOTE: sqlaopts_free has been obsoleted in favor of                */
 /*       sqlaoptions_free.                                           */
 /* sqlaopts_free will be unavailable in future releases.             */
 /*********************************************************************/

 dcl sqlaopts_free                       /* Frees any memory          */
                                         /* allocated by sqlaopts     */
     entry (pointer,                     /* memory handle returned    */
                                         /* by sqlaopts               */
            pointer)                     /* SQLCA                     */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlaopts_free');

 dcl sqlaoptions                          /* Parse an option string   */
                                          /* and produce an option    */
                                          /* array                    */
     entry (char(*) var byaddr,           /* option string            */
            pointer,                      /* option array (sqlopt)    */
            fixed bin(16) unsigned byaddr,/* database name length     */
                                          /* (sqlainit only)          */
            pointer byaddr,               /* database name (sqlainit  */
                                          /* only)                    */
            fixed bin(16) unsigned byaddr,/* userid length (sqlainit  */
                                          /* only)                    */
            pointer byaddr,               /* userid (sqlainit only)   */
            fixed bin(16) unsigned byaddr,/* password length          */
                                          /* (sqlainit only)          */
            pointer byaddr,               /* password (sqlainit only) */
            fixed bin(16) unsigned byaddr,/* message file name length */
            pointer byaddr,               /* message file name        */
            fixed bin(16) unsigned byaddr,/* package name length      */
            pointer byaddr,               /* package name             */
            fixed bin(16) unsigned byaddr,/* bind file name length    */
            pointer byaddr,               /* bind file name           */
            fixed bin(31),                /* target API               */
            pointer byaddr,               /* memory handle            */
            pointer)                      /* SQLCA                    */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlaoptions');

 dcl sqlaoptions_free                    /* Frees any memory          */
                                         /* allocated by sqlaoptions  */
     entry (pointer,                     /* memory handle returned    */
                                         /* by sqlaoptions            */
            pointer)                     /* SQLCA                     */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlaoptions_free');

 /*********************************************************************/
 /* Precompiler Services Structures                                   */
 /*********************************************************************/

 /* Precompiler Option Array.  Used with SQLAINIT. */

 define structure
   1 sqla_options_header,
     2 allocated  fixed bin(32) unsigned,
     2 used       fixed bin(32) unsigned;


 define structure
   1 sqla_option,
     2 type       fixed bin(32) unsigned,
     2 val        fixed bin(32) unsigned;


 define structure
   1 sqla_options,
     2 header     type sqla_options_header,
     2 option (1) type sqla_option;


 /* Program ID.  Used by Precompiler Services and Runtime Services */
 define structure
   1 sqla_program_id_V610,
     2 length      fixed bin(16) unsigned,
     2 rp_rel_num  fixed bin(16) unsigned,
     2 db_rel_num  fixed bin(16) unsigned,
     2 bf_rel_num  fixed bin(16) unsigned,
     2 sqluser     char(8),
     2 planname    char(8),
     2 contoken    char(8),
     2 buffer      char(8);

 define structure
   1 sqla_program_id_v70,
     2 length      fixed bin(16) unsigned,
     2 rp_rel_num  fixed bin(16) unsigned,
     2 db_rel_num  fixed bin(16) unsigned,
     2 bf_rel_num  fixed bin(16) unsigned,
     2 sqluser_len fixed bin(16) unsigned,
     2 sqluser     char(128),
     2 planname    char(8),
     2 contoken    char(8),
     2 buffer      char(8);

 define structure
   1 sqla_program_id,
     2 length      fixed bin(16) unsigned,
     2 rp_rel_num  fixed bin(16) unsigned,
     2 db_rel_num  fixed bin(16) unsigned,
     2 bf_rel_num  fixed bin(16) unsigned,
     2 planname    char(8),
     2 contoken    char(8),
     2 buffer      char(8),
     2 sqluser_len fixed bin(16) unsigned,
     2 sqluser     char(128);

 /* Indexes into the buffer field, showing the information it provides*/
 dcl SQLA_PGMID_STD              fixed bin(31) value(0);
 dcl SQLA_PGMID_CONNECT          fixed bin(31) value(1);
 dcl SQLA_PGMID_SQLRULES         fixed bin(31) value(2);
 dcl SQLA_PGMID_DISCONNECT       fixed bin(31) value(3);
 dcl SQLA_PGMID_SYNCPOINT        fixed bin(31) value(4);
 dcl SQLA_PGMID_DEFERRED_PREPARE fixed bin(31) value(5);
 dcl SQLA_INT_TO_ASCII_DIFF      fixed bin(31) value(48);

 /* Number of DUOW connection options */
 dcl SQLA_PGMID_CONNOPTS         fixed bin(31) value(4);

 /* Precompiler Task Array.  Used with SQLACMPL. */

 define structure
   1 sqla_tasks_header,
     2 allocated  fixed bin(32) unsigned,
     2 used       fixed bin(32) unsigned;

 define structure
   1 sqla_task,
     2 func       fixed bin(32) unsigned,
     2 val        fixed bin(32) unsigned;

 define structure
   1 sqla_tasks,
     2 header     type sqla_tasks_header,
     2 task (1)   type sqla_task;


 /* Token return structure.  Used to return length and offset of */
 /* a token within an SQL statement.  May be overlaid on top of  */
 /* the val member of the task array or on top of the id member  */
 /* of the token id array.                                       */
 define structure
   1 sqla_return_token,
     2 offset     fixed bin(16) unsigned,
     2 length     fixed bin(16) unsigned;


 /* Precompiler Token ID Array.  Used with SQLACMPL. */

 define structure
   1 sqla_tokens_header,
     2 allocated  fixed bin(32) unsigned,
     2 used       fixed bin(32) unsigned;

 define structure
   1 sqla_token,
     2 id         fixed bin(32) unsigned,
     2 use        fixed bin(32) unsigned;

 define structure
   1 sqla_tokens,
     2 header     type sqla_tokens_header,
     2 token (1)  type sqla_token;


 /* Flagger information area. Used with SQLACMPL and SQLGCMPL. */
 define structure
   1 sqla_flagmsgs,
     2 count      fixed bin(15),
     2 padding    fixed bin(15),
     2 sqlca (SQLA_FLAG_MAXMSGS) type sqlca;

 define structure
   1 sqla_flaginfo,
     2 version    fixed bin(15),
     2 padding    fixed bin(15),
     2 msgs       type sqla_flagmsgs;

 /* Precompiler Services Prototypes */

 /* NOTE: sqlaahvr has been obsoleted in favor of sqlaalhv. */
 /* sqlaahvr will be unavailable in future releases.        */
 dcl sqlaahvr                             /* Add a host variable      */
                                          /* declaration (obsolete)   */
     entry (fixed bin(16) unsigned byaddr,/* host variable name length*/
            char(*) varz byaddr,          /* host variable name       */
            fixed bin(16) unsigned byaddr,/* host var SQL data type   */
            fixed bin(16) unsigned byaddr,/* host variable length     */
            fixed bin(32) unsigned byaddr,/* host variable token id   */
            fixed bin(16) unsigned byaddr,/* host variable location   */
            pointer,                      /* reserved                 */
            pointer)                      /* SQLCA                    */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlaahvr');

 dcl sqlaalhv                             /* Add a host variable      */
                                          /* declaration              */
     entry (fixed bin(16) unsigned byaddr,/* host variable name length*/
            char(*) varz byaddr,          /* host variable name       */
            fixed bin(16) unsigned byaddr,/* host var SQL data type   */
            fixed bin(32) unsigned byaddr,/* host variable length     */
            fixed bin(32) unsigned byaddr,/* host variable token id   */
            fixed bin(16) unsigned byaddr,/* host variable location   */
            pointer,                      /* reserved                 */
            pointer)                      /* SQLCA                    */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlaalhv');

 dcl sqlacmpl                             /* Compile an sql statement */
     entry (fixed bin(16) unsigned byaddr,/* SQL statement text length*/
            char(*) varz byaddr,          /* SQL statement text       */
            fixed bin(16) unsigned byaddr,/* source line number       */
            type sqla_tasks byaddr,       /* task array               */
            type sqla_tokens byaddr,      /* token id array           */
            fixed bin(16) unsigned byaddr,/* section number           */
            fixed bin(16) unsigned byaddr,/* type of SQL statement    */
            char(128) byaddr,             /* 128 byte string buffer 1 */
            char(128) byaddr,             /* 128 byte string buffer 2 */
            char(128) byaddr,             /* 128 byte string buffer 3 */
            type sqla_flaginfo byaddr,    /* SQL Flagger information  */
            pointer)                      /* SQLCA                    */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlacmpl');

 dcl sqlafini                             /* Terminate an access plan */
     entry (fixed bin(16) unsigned byaddr,/* save / discard           */
                                          /* plan / bind file         */
            pointer,                      /* reserved                 */
            pointer)                      /* SQLCA                    */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlafini');

 dcl sqlainit                             /* Initialize an access plan*/
     entry (fixed bin(16) unsigned byaddr,/* program name length      */
            char(*) varz byaddr,          /* program name             */
            fixed bin(16) unsigned byaddr,/* database name length     */
            char(*) varz byaddr,          /* database name            */
            fixed bin(16) unsigned byaddr,/* password length          */
            char(*) varz byaddr,          /* database password        */
            fixed bin(16) unsigned byaddr,/* bind file name length    */
            char(*) varz byaddr,          /* bind file name           */
            type sqla_options byaddr,     /* precompiler option array */
            type sqla_program_id,         /* precompiler program ID   */
            pointer,                      /* reserved                 */
            pointer)                      /* SQLCA                    */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlainit');

 /* Generic Precompiler Services Prototypes */

 /* NOTE: sqlgahvr has been obsoleted in favor of sqlgalhv. */
 /* sqlgahvr will be unavailable in future releases.        */
 dcl sqlgahvr                             /* Add a host variable      */
                                          /* declaration (obsolete)   */
     entry (fixed bin(16) unsigned byaddr,/* host variable name length*/
            char(*) varz byaddr,          /* host variable name       */
            fixed bin(16) unsigned byaddr,/* host var SQL data type   */
            fixed bin(16) unsigned byaddr,/* host variable length     */
            fixed bin(32) unsigned byaddr,/* host variable token id   */
            fixed bin(16) unsigned byaddr,/* host variable location   */
            pointer,                      /* reserved                 */
            pointer)                      /* SQLCA                    */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgahvr');

 dcl sqlgalhv                             /* Add a host variable      */
                                          /* declaration              */
     entry (fixed bin(16) unsigned byaddr,/* host variable name length*/
            char(*) varz byaddr,          /* host variable name       */
            fixed bin(16) unsigned byaddr,/* host var SQL data type   */
            fixed bin(32) unsigned byaddr,/* host variable length     */
            fixed bin(32) unsigned byaddr,/* host variable token id   */
            fixed bin(16) unsigned byaddr,/* host variable location   */
            pointer,                      /* reserved                 */
            pointer)                      /* SQLCA                    */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgalhv');

 dcl sqlgcmpl                             /* Compile an sql statement */
     entry (fixed bin(16) unsigned byaddr,/* SQL statement text length*/
            char(*) varz byaddr,          /* SQL statement text       */
            fixed bin(16) unsigned byaddr,/* source line number       */
            type sqla_tasks byaddr,       /* task array               */
            type sqla_tokens byaddr,      /* token id array           */
            fixed bin(16) unsigned byaddr,/* section number           */
            fixed bin(16) unsigned byaddr,/* type of SQL statement    */
            char(128) byaddr,             /* 128 byte string buffer 1 */
            char(128) byaddr,             /* 128 byte string buffer 2 */
            char(128) byaddr,             /* 128 byte string buffer 3 */
            type sqla_flaginfo byaddr,    /* SQL Flagger information  */
            pointer)                      /* SQLCA                    */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgcmpl');

 dcl sqlgfini                             /* Terminate an access plan */
     entry (fixed bin(16) unsigned byaddr,/* save / discard           */
                                          /* plan / bind file         */
            pointer,                      /* reserved                 */
            pointer)                      /* SQLCA                    */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgfini');

 dcl sqlginit                             /* Initialize an access plan*/
     entry (fixed bin(16) unsigned byaddr,/* program name length      */
            char(*) varz byaddr,          /* program name             */
            fixed bin(16) unsigned byaddr,/* database name length     */
            char(*) varz byaddr,          /* database name            */
            fixed bin(16) unsigned byaddr,/* password length          */
            char(*) varz byaddr,          /* database password        */
            fixed bin(16) unsigned byaddr,/* bind file name length    */
            char(*) varz byaddr,          /* bind file name           */
            type sqla_options byaddr,     /* precompiler option array */
            type sqla_program_id,         /* precompiler program ID   */
            pointer,                      /* reserved                 */
            pointer)                      /* SQLCA                    */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlginit');

 /* Generic Runtime Services Prototypes */

 dcl sqlgaloc
     entry (fixed bin(16) unsigned, /* sqlda identification number    */
            fixed bin(16) unsigned, /* number of sqlvar elements      */
                                    /* needed                         */
            fixed bin(16) unsigned, /* statement identification       */
                                    /* number                         */
            pointer)                /* reserved                       */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgaloc');

 dcl sqlgcall
     entry (fixed bin(16) unsigned, /* function call type             */
            fixed bin(16) unsigned, /* access plan section or         */
                                    /* statement type                 */
            fixed bin(16) unsigned, /* input SQLDA ID                 */
            fixed bin(16) unsigned, /* output SQLDA ID                */
            pointer)                /* reserved                       */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgcall');

 dcl sqlgcmpd
     entry (fixed bin(16) unsigned, /* function call type             */
            fixed bin(16) unsigned, /* access plan section            */
            fixed bin(16) unsigned, /* input SQLDA ID                 */
            fixed bin(16) unsigned, /* output SQLDA ID                */
            pointer)                /* reserved                       */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgcmpd');

 dcl sqlgdloc
     entry (fixed bin(16) unsigned, /* SQLDA ID                       */
            pointer)                /* reserved                       */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgdloc');

 /* NOTE: sqlgsets has been obsoleted in favor of sqlgstls. */
 /* sqlgsets will be unavailable in future releases.        */
 dcl sqlgsets
     entry (fixed bin(16) unsigned, /* SQL statement text length      */
            char(*) var byaddr,     /* SQL statement text             */
            pointer)                /* reserved                       */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgsets');

 dcl sqlgstls
     entry (fixed bin(32) unsigned, /* SQL statement text length      */
            char(*) var byaddr,     /* SQL statement text             */
            pointer)                /* reserved                       */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgstls');

 /* NOTE: sqlgsetv has been obsoleted in favor of sqlgstlv. */
 /* sqlgsetv will be unavailable in future releases.        */
 dcl sqlgsetv
     entry (fixed bin(16) unsigned, /* SQLDA ID                       */
            fixed bin(16) unsigned, /* sqlvar element                 */
            fixed bin(16) unsigned, /* SQL data type                  */
            fixed bin(16) unsigned, /* declared length                */
            pointer,                /* address of host var            */
            fixed bin (15) byaddr,  /* address of indicator var       */
            pointer)                /* reserved                       */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgsetv');

 dcl sqlgstlv
     entry (fixed bin(16) unsigned, /* SQLDA ID                       */
            fixed bin(16) unsigned, /* sqlvar element                 */
            fixed bin(16) unsigned, /* SQL data type                  */
            fixed bin(32) unsigned, /* declared length                */
            pointer,                /* address of host var            */
            fixed bin (15) byaddr,  /* address of indicator var       */
            pointer)                /* reserved                       */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgstlv');

 dcl sqlgstlva
     entry (fixed bin(16) unsigned, /* SQLDA ID                       */
            fixed bin(16) unsigned, /* sqlvar element                 */
            fixed bin(16) unsigned, /* SQL data type                  */
            fixed bin(32) unsigned, /* declared length                */
            pointer,                /* address of host var            */
            type sqluint32,         /* declared struct type length    */
            pointer,                /* address of struct type name    */
            fixed bin (15) byaddr,  /* address of indicator var       */
            pointer)                /* reserved                       */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgstlva');

 dcl sqlgstop
     entry (pointer)                /* reserved                       */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgstop');

 dcl sqlgstrt
     entry (char(40) byaddr,        /* runtime program ID             */
            type sqla_runtime_info byaddr, /* runtime information     */
            pointer)                /* SQLCA                          */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgstrt');

 dcl sqlgusda
     entry (fixed bin(16) unsigned, /* SQLDA ID                       */
            type sqlda byaddr,      /* SQLDA                          */
            pointer)                /* reserved                       */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgusda');

 /*********************************************************************/
 /* NOTE: sqlgopts has been obsoleted in favor of sqlgoptions.        */
 /* sqlgopts will be unavailable in future releases.                  */
 /*********************************************************************/

 dcl sqlgopts                            /* Parse an option string and*/
                                         /* produce an option array   */
     entry (char(*) var byaddr,          /* option string             */
            pointer,                     /* option array (sqlopt)     */
            pointer,                     /* database name (sqlginit   */
                                         /* only)                     */
            pointer,                     /* userid (sqlginit only)    */
            pointer,                     /* password (sqlginit only)  */
            pointer,                     /* message file name         */
            pointer,                     /* package name (sqlginit    */
                                         /* only)                     */
            pointer,                     /* bind file name (sqlginit  */
                                         /* only)                     */
            fixed bin(31),               /* target API                */
            pointer,                     /* memory handle             */
            pointer)                     /* SQLCA                     */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgopts');

 /*********************************************************************/
 /* NOTE: sqlgopts_free has been obsoleted in favor of                */
 /*       sqlgoptions_free.                                           */
 /*  sqlgopts will be unavailable in future releases.                 */
 /*********************************************************************/

 dcl sqlgopts_free                       /* Frees any memory          */
                                         /* allocated by sqlgopts     */
     entry (pointer,                     /* memory handle returned    */
                                         /* by sqlgopts               */
            pointer)                     /* SQLCA                     */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgopts_free');

 dcl sqlgoptions                         /* Parse an option string and*/
                                         /* produce an option array   */
     entry (char(*) var byaddr,          /* option string             */
            pointer,                     /* option array (sqlopt)     */
            fixed bin (15) byaddr,       /* database name length      */
                                         /* (sqlginit only)           */
            pointer,                     /* database name             */
                                         /* (sqlginit only)           */
            fixed bin (15) byaddr,       /* userid length             */
                                         /* (sqlginit only)           */
            pointer,                     /* userid (sqlginit only)    */
            fixed bin (15) byaddr,       /* password length           */
                                         /* (sqlginit only)           */
            pointer,                     /* password (sqlginit only)  */
            fixed bin (15) byaddr,       /* message file name length  */
            pointer,                     /* message file name         */
            fixed bin (15) byaddr,       /* package name length       */
            pointer,                     /* package name (sqlginit    */
                                         /* only)                     */
            fixed bin (15) byaddr,       /* bind file name length     */
            pointer,                     /* bind file name (sqlginit  */
                                         /* only)                     */
            fixed bin(31),               /* target API                */
            pointer,                     /* memory handle             */
            pointer)                     /* SQLCA                     */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgoptions');

 dcl sqlgoptions_free                    /* Frees any memory allocated*/
                                         /* by sqlgoptions            */
     entry (pointer,                     /* memory handle returned    */
                                         /* by sqlgoptions            */
            pointer)                     /* SQLCA                     */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlgoptions_free');

 %end; /* SQL_H_SQLAPREP */
