 /********************************************************************/
 /*                                                                  */
 /*  PL/I Include file: SQLCODES.CPY                                 */
 /*                                                                  */
 /*  This file is installed in the \IBMPLI\INCLUDE\SDKWIN\ directory.*/
 /*                                                                  */
 /*                                                                  */
 /*  NAME - SQLCODES.CPY                                             */
 /*                                                                  */
 /*  DESCRIPTION                                                     */
 /*                                                                  */
 /*    This include file is translated into a PL/I include file,     */
 /*    from the C header files supplied with the                     */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT    product.            */
 /*    This include file is intended for use with the                */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT   product.             */
 /*                                                                  */
 /*                                                                  */
 /*    (C) Copyright IBM Corp. 1994, 1996. All Rights Reserved.      */
 /*    US Government Users Restricted Rights-- Use, duplication or   */
 /*    disclosure restricted by GSA ADP Schedule Contract with       */
 /*    IBM Corp.                                                     */
 /*  Licensed Materials - Property of IBM                            */
 /*                                                                  */
 /*  Function = Include File defining:                               */
 /*               Labels for SQLCODES                                */
 /*                                                                  */
 /*  Operating System = Windows                                      */
 /*                                                                  */
 /*                                                                  */
 /*  DISCLAIMER OF WARRANTIES                                        */
 /*    The following enclosed code is sample code created by IBM   */
 /*    Corporation. This sample code is not part of any standard     */
 /*    IBM product and is provided to you solely for the purpose of  */
 /*    assisting you in the development of your applications.  The   */
 /*    code is provided "AS IS", without warranty of any kind.       */
 /*    IBM shall not be liable for any damages arising out of your   */
 /*    use of the sample code, even if IBM has been advised of the   */
 /*    possibility of such damages.                                  */
 /*                                                                  */
 /********************************************************************/
 %dcl SQL_H_SQLCODES char ext;
 %if SQL_H_SQLCODES = '' %then %do;
 %SQL_H_SQLCODES = 'Y';


 %dcl SQL_H_SQLSYSTM char ext;
 %if SQL_H_SQLSYSTM = '' %then %do;
 /* System dependent defines  */
 %include sqlsystm;
 %end;

 /* SQL Return Codes in SQLCODE */

 %dcl #SQL_RC_OK char ext;
 %if #SQL_RC_OK = '' %then %do;
 %#SQL_RC_OK = 'Y';
 dcl SQL_RC_OK fixed bin (31) value(0);
 %end;

 /* ------------ warnings ------------ */
                              /* correlation without qualification   */
 dcl SQL_RC_W012 fixed bin(31) value(12);
                              /* unsupported bind/prep options       */
 dcl SQL_RC_W020 fixed bin(31) value(20);
                              /* eof                                 */
 dcl SQL_RC_W100 fixed bin(31) value(100);
                              /* duplicate column conistraint        */
 dcl SQL_RC_W139 fixed bin(31) value(139);
                              /* invalid syntax ignored              */
 dcl SQL_RC_W143 fixed bin(31) value(143);
                              /* explain mode incompatible           */
 dcl SQL_RC_W217 fixed bin(31) value(217);
                              /* not enough sqlvars, none filled in  */
 dcl SQL_RC_W236 fixed bin(31) value(236);
                              /* distinct type: not enough sqlvars,  */
                              /* some filled in                      */
 dcl SQL_RC_W237 fixed bin(31) value(237);
                              /* LOB type: not enough sqlvars, none  */
                              /* filled in                           */
 dcl SQL_RC_W238 fixed bin(31) value(238);
                              /* distinct type: not enough sqlvars,  */
                              /* none filled in                      */
 dcl SQL_RC_W239 fixed bin(31) value(239);
                              /* new view replaced old               */
 dcl SQL_RC_W280 fixed bin(31) value(280);
                              /* possible infinite loop              */
 dcl SQL_RC_W347 fixed bin(31) value(347);
                              /* alias target is not defined         */
 dcl SQL_RC_W403 fixed bin(31) value(403);
                              /* clause value has been replaced      */
 dcl SQL_RC_W434 fixed bin(31) value(434);
                              /* Sub-optimal query                   */
 dcl SQL_RC_W437 fixed bin(31) value(437);
                              /* Function has truncated value        */
 dcl SQL_RC_W445 fixed bin(31) value(445);
                              /* Create UDF contains redundant keyw  */
 dcl SQL_RC_W447 fixed bin(31) value(447);
                              /* UDF returns a warning sqlstate      */
 dcl SQL_RC_W462 fixed bin(31) value(462);
                              /* DDL:could truncate value at         */
                              /* runtime                             */
 dcl SQL_RC_W464 fixed bin(31) value(464);
                              /* Procedure returned too many query   */
                              /* result sets                         */
 dcl SQL_RC_W466 fixed bin(31) value(466);
                              /* one or more results sets for        */
                              /* stored procedure                    */
 dcl SQL_RC_W467 fixed bin(31) value(467);
                              /* Another result set exists for a     */
                              /* stored procedure                    */
 dcl SQL_RC_W474 fixed bin(31) value(474);
                              /* DDL:could truncate value at         */
                              /* runtime                             */
 dcl SQL_RC_W477 fixed bin(31) value(477);
                              /* duplicate referential constraint    */
 dcl SQL_RC_W541 fixed bin(31) value(541);
                              /* Isolation level escalated           */
 dcl SQL_RC_W570 fixed bin(31) value(570);
                              /* some privileges were not granted    */
 dcl SQL_RC_W595 fixed bin(31) value(595);
                              /* existing index used                 */
 dcl SQL_RC_W598 fixed bin(31) value(598);
                              /* compare func not created for lstr   */
 dcl SQL_RC_W599 fixed bin(31) value(599);
                              /* index already exists                */
 dcl SQL_RC_W605 fixed bin(31) value(605);
                              /* unknown SQL warning another         */
                              /* product                             */
 dcl SQL_RC_W965 fixed bin(31) value(965);
                              /* XA informational message            */
 dcl SQL_RC_W997 fixed bin(31) value(997);
                              /* XA no data to return from recover   */
 dcl SQL_RC_W1138 fixed bin(31) value(1138);
                              /* already existing index was          */
                              /* migrated                            */
 dcl SQL_RC_W1140 fixed bin(31) value(1140);
                              /* estimate cost exceeds resource      */
                              /* limit warning threshold             */
 dcl SQL_RC_W1165 fixed bin(31) value(1165);
                              /* value not within host variable      */
                              /* data type range                     */
 dcl SQL_RC_W1166 fixed bin(31) value(1166);
                              /* Division by zero                    */
 dcl SQL_RC_W1167 fixed bin(31) value(1167);
                              /* Arithmetic overflow or arithmetic   */
                              /* exception                           */
 dcl SQL_RC_W1179 fixed bin(31) value(1179);
                              /* object may require invoker to have  */
                              /* privileges on data source object    */
 dcl SQL_RC_W1251 fixed bin(31) value(1251);
                              /* Trailing blanks are truncated       */

 dcl SQL_RC_W1440 fixed bin(31) value(1440);
                              /* WITH GRANT OPTION ignored           */
 dcl SQL_RC_ERR_DB_TERM fixed bin(31) value(1475);
                              /* system error on DB termination      */
 dcl SQL_RC_W1479 fixed bin(31) value(1479);
                              /* Invalid cursor position             */
 dcl SQL_RC_W1530 fixed bin(31) value(1530);
                              /* value of DEGREE ignored             */
 dcl SQL_RC_W1580 fixed bin(31) value(1580);
                              /* Trailing blanks are truncated       */
 dcl SQL_RC_W1594 fixed bin(31) value(1594);
                              /* data remains unverified             */
 dcl SQLM_RC_NOT_SET fixed bin(31) value(1615);
                              /* Event monitor state not changed     */

 dcl SQL_RC_W1625 fixed bin(31) value(1625);
                              /* Monitor: No conversion from source  */
                              /* cp to target cp                     */
 dcl SQL_RC_W1626 fixed bin(31) value(1626);
                              /* Monitor: code page conversion       */
                              /* overflow                            */
 dcl SQL_RC_W1627 fixed bin(31) value(1627);
                              /* Monitor: V5 snapshot returned on    */
                              /* V6 request                          */
 dcl SQL_RC_W1758 fixed bin(31) value(1758);
                              /* containers not designated for       */
                              /* specific nodes are not used         */
 dcl SQL_RC_W1759 fixed bin(31) value(1759);
                              /* Redistribute required to change     */
                              /* data partitioning                   */
 dcl SQL_RC_W1821 fixed bin(31) value(1821);
                              /* LOB value retrieved may have been   */
                              /* changed                             */
 dcl SQL_RC_W1824 fixed bin(31) value(1824);
                              /* base tables of UNION ALL may be     */
                              /* same table                          */
 dcl SQL_RC_W2314 fixed bin(31) value(2314);
                              /* Statistics are in an inconsistent   */
                              /* state                               */
 dcl SQL_RC_W3274 fixed bin(31) value(3274);
                              /* The database was not catalogued in  */
                              /* LDAP                                */
 dcl SQL_RC_W3275 fixed bin(31) value(3275);
                              /* The database was not uncatalogued   */
                              /* in LDAP                             */
 dcl SQL_RC_W8009 fixed bin(31) value(8009);
                              /* concurrent user limit exceeded -    */
                              /* DB2 Workgroup                       */
 dcl SQL_RC_W8010 fixed bin(31) value(8010);
                              /* concurrent user limit exceeded -    */
                              /* DB2 Connect                         */
 dcl SQL_RC_W8012 fixed bin(31) value(8012);
                              /* concurrent user limit exceeded -    */
                              /* DB2 Enterprise                      */
 dcl SQL_RC_W8013 fixed bin(31) value(8013);
                              /* concurrent connection limit         */
                              /* exceeded - DB2 Connect              */
 dcl SQL_RC_W20059 fixed bin(31) value(20059);
                              /* summary table cannot be used to     */
                              /* optimize query                      */
 dcl SQL_RC_W20109 fixed bin(31) value(20109);
                              /* Error in debugger support           */
 dcl SQL_RC_W20206fixed bin(31) value(20206);
                              /* procedure returned too many         */
                              /* results                             */

 /* ------------ errors ------------ */
                              /* illegal character                   */
 dcl SQL_RC_E007 fixed bin(31) value(-7);
                              /* string constant not terminated      */
 dcl SQL_RC_E010 fixed bin(31) value(-10);
                              /* cursor or statement name = ""       */
 dcl SQL_RC_E013 fixed bin(31) value(-13);
                              /* INTO clause required                */
 dcl SQL_RC_E029 fixed bin(31) value(-29);
                              /* reserved                            */
 dcl SQL_RC_E051 fixed bin(31) value(-51);
                              /* bad SQL statement                   */
 dcl SQL_RC_E084 fixed bin(31) value(-84);

                              /* statement too long                  */
 dcl SQL_RC_E101 fixed bin(31) value(-101);
                              /* string constant too long            */
 dcl SQL_RC_E102 fixed bin(31) value(-102);
                              /* invalid numeric literal             */
 dcl SQL_RC_E103 fixed bin(31) value(-103);
                              /* invalid character/token             */
 dcl SQL_RC_E104 fixed bin(31) value(-104);
                              /* invalid string constant             */
 dcl SQL_RC_E105 fixed bin(31) value(-105);
                              /* name too long                       */
 dcl SQL_RC_E106 fixed bin(31) value(-106);
                              /* incomplete statement                */
 dcl SQL_RC_E107 fixed bin(31) value(-107);
                              /* name has too many qualifiers        */
 dcl SQL_RC_E108 fixed bin(31) value(-108);
                              /* clause not permitted                */
 dcl SQL_RC_E109 fixed bin(31) value(-109);
                              /* invalid hex constant                */
 dcl SQL_RC_E110 fixed bin(31) value(-110);
                              /* no column name                      */
 dcl SQL_RC_E111 fixed bin(31) value(-111);
                              /* operand is SQL function             */
 dcl SQL_RC_E112 fixed bin(31) value(-112);
                              /* wrong nbr of insert values          */
 dcl SQL_RC_E117 fixed bin(31) value(-117);
                              /* object table in from clause         */
 dcl SQL_RC_E118 fixed bin(31) value(-118);
                              /* column not in group by              */
 dcl SQL_RC_E119 fixed bin(31) value(-119);
                              /* clause includes SQL fn              */
 dcl SQL_RC_E120 fixed bin(31) value(-120);
                              /* dup column name                     */
 dcl SQL_RC_E121 fixed bin(31) value(-121);
                              /* no group by                         */
 dcl SQL_RC_E122 fixed bin(31) value(-122);
                              /* parameter must be constant          */
 dcl SQL_RC_NOTCONST fixed bin(31) value(-123);
                              /* no result column                    */
 dcl SQL_RC_E125 fixed bin(31) value(-125);
                              /* dup distinct                        */
 dcl SQL_RC_E127 fixed bin(31) value(-127);
                              /* too many table names                */
 dcl SQL_RC_E129 fixed bin(31) value(-129);
                              /* invalid escape character            */
 dcl SQL_RC_INVESC fixed bin(31) value(-130);
                              /* incompatible data for like          */
 dcl SQL_RC_E131 fixed bin(31) value(-131);
                              /* like predicate invalid              */
 dcl SQL_RC_E132 fixed bin(31) value(-132);
                              /* improper use of long string         */
 dcl SQL_RC_E134 fixed bin(31) value(-134);
                              /* length of concat too long           */
 dcl SQL_RC_E135 fixed bin(31) value(-135);
                              /* input must be a host variable or    */
                              /* NULL                                */
 dcl SQL_RC_E137 fixed bin(31) value(-137);
                              /* substr arg out of range             */
 dcl SQL_RC_E138 fixed bin(31) value(-138);
                              /* syntax not supported                */
 dcl SQL_RC_E142 fixed bin(31) value(-142);
                              /* unsupported ANSI syntax             */
 dcl SQL_RC_E146 fixed bin(31) value(-146);
                              /* view not updatable                  */
 dcl SQL_RC_E150 fixed bin(31) value(-150);
                              /* column not updatable                */
 dcl SQL_RC_E151 fixed bin(31) value(-151);
                              /* no column list                      */
 dcl SQL_RC_E153 fixed bin(31) value(-153);
                              /* trigger trans tbl not modifiable    */
 dcl SQL_RC_E155 fixed bin(31) value(-155);
                              /* command not allowed on view         */
 dcl SQL_RC_E156 fixed bin(31) value(-156);
                              /* view name in foreign key            */
 dcl SQL_RC_E157 fixed bin(31) value(-157);
                              /* nbr of columns does not match       */
 dcl SQL_RC_E158 fixed bin(31) value(-158);
                              /* drop view on table                  */
 dcl SQL_RC_E159 fixed bin(31) value(-159);
                              /* with check not allowed on view      */
 dcl SQL_RC_E160 fixed bin(31) value(-160);
                              /* with check violation                */
 dcl SQL_RC_E161 fixed bin(31) value(-161);
                              /* nbr of arguments invalid            */
 dcl SQL_RC_E170 fixed bin(31) value(-170);
                              /* argument invalid                    */
 dcl SQL_RC_E171 fixed bin(31) value(-171);
                              /* function name invalid               */
 dcl SQL_RC_E172 fixed bin(31) value(-172);
                              /* translate scalar argument invalid   */
 dcl SQL_RC_E176 fixed bin(31) value(-176);
                              /* datetime syntax invalid             */
 dcl SQL_RC_E180 fixed bin(31) value(-180);
                              /* datetime value invalid              */
 dcl SQL_RC_E181 fixed bin(31) value(-181);
                              /* datetime arithmetic invalid         */
 dcl SQL_RC_E182 fixed bin(31) value(-182);
                              /* datetime arithmetic out of range    */
 dcl SQL_RC_E183 fixed bin(31) value(-183);
                              /* datetime register is invalid        */
 dcl SQL_RC_DTMEREG fixed bin(31) value(-187);
                              /* truncated DBCS character found      */
 dcl SQL_RC_E190 fixed bin(31) value(-190);
                              /* data type or length of column       */
                              /* incompatible                        */
 dcl SQL_RC_DBCSTRUNC fixed bin(31) value(-191);
                              /* NOT NULL needs DEFAULT              */
 dcl SQL_RC_E193 fixed bin(31) value(-193);
                              /* no qualified columns in ORDER BY    */
 dcl SQL_RC_E197 fixed bin(31) value(-197);
                              /* no statement text                   */
 dcl SQL_RC_E198 fixed bin(31) value(-198);
                              /* illegal use of reserved word        */
 dcl SQL_RC_E199 fixed bin(31) value(-199);
                              /* illegal use of reserved word        */

 dcl SQL_RC_E203 fixed bin(31) value(-203);
                              /* ambiguous column reference          */
 dcl SQL_RC_E204 fixed bin(31) value(-204);
                              /* undefined name                      */
 dcl SQL_RC_E205 fixed bin(31) value(-205);
                              /* not a column                        */
 dcl SQL_RC_E206 fixed bin(31) value(-206);
                              /* not a column of referenced tables   */
 dcl SQL_RC_E207 fixed bin(31) value(-207);
                              /* cannot orderby column name w/union  */
 dcl SQL_RC_E208 fixed bin(31) value(-208);
                              /* column not part of result table     */
 dcl SQL_RC_E212 fixed bin(31) value(-212);
                              /* duplicate table designator          */
 dcl SQL_RC_E214 fixed bin(31) value(-214);
                              /* bad expression in group/by or       */
                              /* order by                            */
 dcl SQL_RC_E216 fixed bin(31) value(-216);
                              /* number of elements does not match   */
 dcl SQL_RC_E219 fixed bin(31) value(-219);
                              /* required explain table not exist    */
 dcl SQL_RC_E220 fixed bin(31) value(-220);
                              /* explain table has improper def      */
 dcl SQL_RC_E242 fixed bin(31) value(-242);
 dcl SQL_RC_E257 fixed bin(31) value(-257);
                              /* duplicate object in list            */
 dcl SQL_RC_E258 fixed bin(31) value(-258);
                              /* raw device containers not allowed   */
                              /* cannot add container to pool        */
 dcl SQL_RC_E259 fixed bin(31) value(-259);
                              /* container map too big               */
 dcl SQL_RC_E260 fixed bin(31) value(-260);
                              /* partition key has long field        */
 dcl SQL_RC_E261 fixed bin(31) value(-261);
                              /* node in use, cannot drop            */
 dcl SQL_RC_E262 fixed bin(31) value(-262);
                              /* multinode table without part key    */
 dcl SQL_RC_E263 fixed bin(31) value(-263);
                              /* invalid node range                  */
 dcl SQL_RC_E264 fixed bin(31) value(-264);
                              /* multinode tbl, cannot drop part     */
 dcl SQL_RC_E265 fixed bin(31) value(-265);
                              /* duplicate node name/number          */
 dcl SQL_RC_E266 fixed bin(31) value(-266);
                              /* node not defined                    */
 dcl SQL_RC_E268 fixed bin(31) value(-268);
                              /* operatn not done because rebalance  */
 dcl SQL_RC_E269 fixed bin(31) value(-269);
                              /* too many nodegroups                 */
 dcl SQL_RC_E270 fixed bin(31) value(-270);
                              /* function not supported              */
 dcl SQL_RC_E271 fixed bin(31) value(-271);
                              /* Index file missing or invalid       */
 dcl SQL_RC_E276 fixed bin(31) value(-276);
                              /* database in restore pending state   */
 dcl SQL_RC_E279 fixed bin(31) value(-279);
                              /* connection terminated during        */
                              /* COMMIT                              */
 dcl SQL_RC_E281 fixed bin(31) value(-281);
                              /* cannot add containers to            */
                              /* tablespace                          */
 dcl SQL_RC_E282 fixed bin(31) value(-282);
                              /* cannot drop tblspace, tbl conflict  */
 dcl SQL_RC_E283 fixed bin(31) value(-283);
                              /* cannot drop only temp tablespace    */
 dcl SQL_RC_E284 fixed bin(31) value(-284);
                              /* invalid tablespace type for clause  */
 dcl SQL_RC_E285 fixed bin(31) value(-285);
                              /* all table parts must be in tblspce  */
                              /* need default tblspce for new        */
 dcl SQL_RC_E286 fixed bin(31) value(-286);
                              /* tables                              */
 dcl SQL_RC_E287 fixed bin(31) value(-287);
                              /* SYSCATSPACE not for user objects    */
 dcl SQL_RC_E288 fixed bin(31) value(-288);
                              /* long tablespace cannot use system   */
 dcl SQL_RC_E289 fixed bin(31) value(-289);
                              /* cannot allocate new pages in        */
                              /* tablespace                          */
 dcl SQL_RC_E290 fixed bin(31) value(-290);
                              /* access to tablespace not allowed    */
 dcl SQL_RC_E291 fixed bin(31) value(-291);
                              /* invalid state transition            */
 dcl SQL_RC_E292 fixed bin(31) value(-292);
                              /* cannot create internal db file      */
 dcl SQL_RC_E293 fixed bin(31) value(-293);
                              /* error accessing container           */
 dcl SQL_RC_E294 fixed bin(31) value(-294);
                              /* container already in use            */
 dcl SQL_RC_E295 fixed bin(31) value(-295);
                              /* container names too long            */
 dcl SQL_RC_E296 fixed bin(31) value(-296);
                              /* tablespace limit exceeded           */
 dcl SQL_RC_E297 fixed bin(31) value(-297);
                              /* container pathname too long         */
 dcl SQL_RC_E298 fixed bin(31) value(-298);
                              /* bad container pathname              */
 dcl SQL_RC_E299 fixed bin(31) value(-299);
                              /* container already added             */
 dcl SQL_RC_E301 fixed bin(31) value(-301);
                              /* host variable has invalid type      */
 dcl SQL_RC_E302 fixed bin(31) value(-302);
                              /* host variable value too large       */
 dcl SQL_RC_E303 fixed bin(31) value(-303);
                              /* data types not comparable           */
 dcl SQL_RC_E304 fixed bin(31) value(-304);
                              /* value not in range of host var      */
 dcl SQL_RC_E305 fixed bin(31) value(-305);
                              /* host var cannot be null             */
 dcl SQL_RC_E308 fixed bin(31) value(-308);
                              /* host var limit reached              */
 dcl SQL_RC_E309 fixed bin(31) value(-309);
                              /* host var should not be null         */
 dcl SQL_RC_E311 fixed bin(31) value(-311);
                              /* length of host var is negative      */
 dcl SQL_RC_E312 fixed bin(31) value(-312);
                              /* unusable host variable              */
 dcl SQL_RC_E313 fixed bin(31) value(-313);
                              /* wrong nbr of host variables         */
 dcl SQL_RC_E332 fixed bin(31) value(-332);
                              /* no conversn source-cp to target-cp  */
 dcl SQL_RC_E334 fixed bin(31) value(-334);
                              /* converion overflow                  */
 dcl SQL_RC_E340 fixed bin(31) value(-340);
                              /* duplicate common table expression   */
 dcl SQL_RC_E341 fixed bin(31) value(-341);
                              /* cyclic ref between comm tbl exp     */
 dcl SQL_RC_E342 fixed bin(31) value(-342);
                              /* comm tbl exp use UNION ALL          */
 dcl SQL_RC_E343 fixed bin(31) value(-343);
                              /* col names required                  */
 dcl SQL_RC_E344 fixed bin(31) value(-344);
                              /* columns must match exactly          */
 dcl SQL_RC_E345 fixed bin(31) value(-345);
                              /* cannot use GROUP BY or HAVING here  */
 dcl SQL_RC_E346 fixed bin(31) value(-346);
                              /* invalid reference to comm tbl exp   */
 dcl SQL_RC_E350 fixed bin(31) value(-350);
                              /* LOB col cannot be idx, key, constr  */
 dcl SQL_RC_E351 fixed bin(31) value(-351);
                              /* LOB col cannot be selected by DRDA  */
 dcl SQL_RC_E352 fixed bin(31) value(-352);
                              /* LOB col cannot be inserted by DRDA  */
 dcl SQL_RC_E355 fixed bin(31) value(-355);
                              /* LOB col cannot be logged            */
 dcl SQL_RC_E357 fixed bin(31) value(-357);
                              /* DataLink Error                      */
 dcl SQL_RC_E358 fixed bin(31) value(-358);
                              /* DataLink Error                      */
 dcl SQL_RC_E368 fixed bin(31) value(-368);
                              /* DataLink Error                      */
 dcl SQL_RC_W369 fixed bin(31) value(369);
                              /* DataLink Warning                    */
 dcl SQL_RC_E370 fixed bin(31) value(-370);
                              /* parameter must be named in CREATE   */
                              /* FUNCTION statement                  */
 dcl SQL_RC_E374 fixed bin(31) value(-374);
                              /* clause not specified in CREATE      */
                              /* FUNCTION                            */
 dcl SQL_RC_E388 fixed bin(31) value(-388);
                              /* source and target are built-in      */
                              /* types or same                       */
 dcl SQL_RC_E389 fixed bin(31) value(-389);
                              /* invalid specific function instance  */
                              /* in CREATE CAST                      */
 dcl SQL_RC_E390 fixed bin(31) value(-390);
                              /* function is invalid in the context  */
                              /* it is used                          */
 dcl SQL_RC_E391 fixed bin(31) value(-391);
                              /* Invalid use of a row based          */
                              /* function                            */
 dcl SQL_RC_E392 fixed bin(31) value(-392);
                              /* SQLDA provided for fetch has been   */
                              /* changed                             */
 dcl SQL_RC_E401 fixed bin(31) value(-401);
                              /* operands not comparable             */
 dcl SQL_RC_E402 fixed bin(31) value(-402);
                              /* invalid type for arithmetic op      */
 dcl SQL_RC_E403 fixed bin(31) value(-403);
                              /* alias object undefined              */
 dcl SQL_RC_E404 fixed bin(31) value(-404);
                              /* update/insert string too long       */
 dcl SQL_RC_E405 fixed bin(31) value(-405);
                              /* numeric literal out of range        */
 dcl SQL_RC_E406 fixed bin(31) value(-406);
                              /* derived value out of range          */
 dcl SQL_RC_E407 fixed bin(31) value(-407);
                              /* column cannot be null               */
 dcl SQL_RC_E408 fixed bin(31) value(-408);
                              /* invalid data type for column        */
 dcl SQL_RC_E409 fixed bin(31) value(-409);
                              /* invalid operand for count           */
 dcl SQL_RC_E410 fixed bin(31) value(-410);
                              /* float literal too long              */
 dcl SQL_RC_E412 fixed bin(31) value(-412);
                              /* multiple columns in subquery        */
 dcl SQL_RC_E413 fixed bin(31) value(-413);
                              /* overflow during data conversion     */
 dcl SQL_RC_E415 fixed bin(31) value(-415);
                              /* incompatible data types for union   */
 dcl SQL_RC_E416 fixed bin(31) value(-416);
                              /* long string in union                */
 dcl SQL_RC_E417 fixed bin(31) value(-417);
                              /* invalid use of parameter markers    */
 dcl SQL_RC_E418 fixed bin(31) value(-418);
                              /* parameter marker in select clause   */
 dcl SQL_RC_E419 fixed bin(31) value(-419);
                              /* division produced negative scale    */
 dcl SQL_RC_E420 fixed bin(31) value(-420);
                              /* invalid character in input string   */
 dcl SQL_RC_E421 fixed bin(31) value(-421);
                              /* diff number of columns for union    */
 dcl SQL_RC_E423 fixed bin(31) value(-423);
                              /* Invalid handle                      */
 dcl SQL_RC_E426 fixed bin(31) value(-426);
                              /* dynamic COMMIT not valid            */
 dcl SQL_RC_E427 fixed bin(31) value(-427);
                              /* dynamic ROLLBACK not valid          */
 dcl SQL_RC_E428 fixed bin(31) value(-428);
                              /* DISCONNECT in unit of work          */
                              /* not allow                           */
 dcl SQL_RC_E429 fixed bin(31) value(-429);
                              /* Handle table full                   */
 dcl SQL_RC_E430 fixed bin(31) value(-430);
                              /* UDF abnormal end                    */
 dcl SQL_RC_E431 fixed bin(31) value(-431);
                              /* UDF interrupted                     */
 dcl SQL_RC_E432 fixed bin(31) value(-432);
                              /* Parameter marker cannot have udf nm */
 dcl SQL_RC_E433 fixed bin(31) value(-433);
                              /* Value is too long                   */
 dcl SQL_RC_E435 fixed bin(31) value(-435);
                              /* Inv SQLSTATE in RAISE_ERROR         */
 dcl SQL_RC_E436 fixed bin(31) value(-436);
                              /* C language char string missing NUL  */
 dcl SQL_RC_E438 fixed bin(31) value(-438);
                              /* App raised error                    */
 dcl SQL_RC_E439 fixed bin(31) value(-439);
                              /* Error in UDF                        */
 dcl SQL_RC_E440 fixed bin(31) value(-440);
                              /* No function with compatible arg     */
 dcl SQL_RC_E441 fixed bin(31) value(-441);
                              /* Invalid use of DISTINCT with        */
                              /* scalar                              */
 dcl SQL_RC_E442 fixed bin(31) value(-442);
                              /* Error refering function in DML      */
 dcl SQL_RC_E443 fixed bin(31) value(-443);
                              /* UDF returns error sqlstate          */
 dcl SQL_RC_E444 fixed bin(31) value(-444);
                              /* Unable to access UDF function       */
 dcl SQL_RC_E448 fixed bin(31) value(-448);
                              /* Exceed max number of parameters     */
 dcl SQL_RC_E449 fixed bin(31) value(-449);
                              /* Invalid EXTERNAL NAME format        */
 dcl SQL_RC_E450 fixed bin(31) value(-450);
                              /* UDF generates too long result       */
                              /* value                               */
 dcl SQL_RC_E451 fixed bin(31) value(-451);
                              /* DDL: invalid type for external UDF  */
 dcl SQL_RC_E452 fixed bin(31) value(-452);
                              /* Hostvar file inaccessible           */
 dcl SQL_RC_E453 fixed bin(31) value(-453);
                              /* Error in RETURNS and CAST FROM      */
 dcl SQL_RC_E454 fixed bin(31) value(-454);
                              /* Duplicate UDF name and signature    */
 dcl SQL_RC_E455 fixed bin(31) value(-455);
                              /* Diff schema for UDF name &          */
                              /* specific                            */
 dcl SQL_RC_E456 fixed bin(31) value(-456);
                              /* Duplicate specific name             */
 dcl SQL_RC_E457 fixed bin(31) value(-457);
                              /* Name reserved for system use        */
 dcl SQL_RC_E458 fixed bin(31) value(-458);
                              /* DDL refers UDF signature not found  */
 dcl SQL_RC_E459 fixed bin(31) value(-459);
                              /* AS CAST use error                   */
 dcl SQL_RC_E461 fixed bin(31) value(-461);
                              /* invalid CAST                        */
 dcl SQL_RC_E463 fixed bin(31) value(-463);
                              /* UDF returns an invalid sqlstate     */
 dcl SQL_RC_E465 fixed bin(31) value(-465);
                              /* Unable to start fenced UDF          */
 dcl SQL_RC_E470 fixed bin(31) value(-470);
                              /* Could not pass NULL argument to     */
                              /* procedure                           */
 dcl SQL_RC_E473 fixed bin(31) value(-473);
                              /* reserved object name                */
 dcl SQL_RC_E475 fixed bin(31) value(-475);
                              /* Result type of source is different  */
 dcl SQL_RC_E476 fixed bin(31) value(-476);
                              /* Reference to function is not        */
                              /* unique                              */
 dcl SQL_RC_E478 fixed bin(31) value(-478);
                              /* other obj depends on this obj       */
 dcl SQL_RC_E481  fixed bin(31) value(-481);
                              /* GROUP BY: element nested in         */
                              /* element                             */
 dcl SQL_RC_E483 fixed bin(31) value(-483);
                              /* Parm num not match with source      */
 dcl SQL_RC_E486 fixed bin(31) value(-486);
                              /* Boolean type is system used only    */
 dcl SQL_RC_E487 fixed bin(31) value(-487);
                              /* Attempt to excute an SQL statement  */
 dcl SQL_RC_E489 fixed bin(31) value(-489);
                              /* Inv BOOLEAN in select list result   */
 dcl SQL_RC_E491 fixed bin(31) value(-491);
                              /* DDL: missing reqired clause         */
 dcl SQL_RC_E492 fixed bin(31) value(-492);
                              /* DDL: miss match with source type    */
 dcl SQL_RC_E493 fixed bin(31) value(-493);
                              /* UDF returned bad date/time value    */
 dcl SQL_RC_E495 fixed bin(31) value(-495);
                              /* estimated cost exceeds resource     */
                              /* limit error threshold               */
 dcl SQL_RC_E499 fixed bin(31) value(-499);
                              /* cursor already assigned to a        */
                              /* result set                          */

 dcl SQL_RC_E501 fixed bin(31) value(-501);
                              /* cursor not open (fetch/close)       */
 dcl SQL_RC_E502 fixed bin(31) value(-502);
                              /* cursor already open                 */
 dcl SQL_RC_E503 fixed bin(31) value(-503);
                              /* column not in update clause         */
 dcl SQL_RC_E504 fixed bin(31) value(-504);
                              /* cursor name not defined             */
 dcl SQL_RC_E507 fixed bin(31) value(-507);
                              /* cursor not open (update/delete)     */
 dcl SQL_RC_E508 fixed bin(31) value(-508);
                              /* cursor not on a row                 */
 dcl SQL_RC_E509 fixed bin(31) value(-509);
                              /* table not same as for cursor        */
 dcl SQL_RC_E510 fixed bin(31) value(-510);
                              /* table cannot be modified            */
 dcl SQL_RC_E511 fixed bin(31) value(-511);
                              /* for update not allowed              */
 dcl SQL_RC_E514 fixed bin(31) value(-514);
                              /* cursor not prepared                 */
 dcl SQL_RC_E516 fixed bin(31) value(-516);
                              /* describe not a prepared statement   */
 dcl SQL_RC_E517 fixed bin(31) value(-517);
                              /* prepared statment not a select      */
 dcl SQL_RC_E518 fixed bin(31) value(-518);
                              /* execute not a prepared statement    */
 dcl SQL_RC_E519 fixed bin(31) value(-519);
                              /* statement has an open cursor        */
 dcl SQL_RC_E525 fixed bin(31) value(-525);
                              /* statement cannot be executed        */
 dcl SQL_RC_E526 fixed bin(31) value(-526);
                              /* function does not apply to global   */
                              /* temp tables                         */
 dcl SQL_RC_E528 fixed bin(31) value(-528);
                              /* duplicate primary/unique key        */
 dcl SQL_RC_E530 fixed bin(31) value(-530);
                              /* invalid foreign key value           */
 dcl SQL_RC_E531 fixed bin(31) value(-531);
                              /* cannot update primary key           */
 dcl SQL_RC_E532 fixed bin(31) value(-532);
                              /* delete is restricted                */
 dcl SQL_RC_E533 fixed bin(31) value(-533);
                              /* multi-row insert not allowed        */
 dcl SQL_RC_E534 fixed bin(31) value(-534);
                              /* multi-row update of pk              */
 dcl SQL_RC_E535 fixed bin(31) value(-535);
                              /* multi-row delete not allowed        */
 dcl SQL_RC_E536 fixed bin(31) value(-536);
                              /* descendent in subquery              */
 dcl SQL_RC_E537 fixed bin(31) value(-537);
                              /* dup column in key def               */
 dcl SQL_RC_E538 fixed bin(31) value(-538);
                              /* foreign key does not match pk       */
 dcl SQL_RC_E539 fixed bin(31) value(-539);
                              /* table does not have primary key     */
 dcl SQL_RC_E540 fixed bin(31) value(-540);
                              /* table does not have primary index   */
 dcl SQL_RC_E541 fixed bin(31) value(-541);
                              /* duplicate referential constraint    */
 dcl SQL_RC_E542 fixed bin(31) value(-542);
                              /* pk column cannot allow nulls        */
 dcl SQL_RC_E543 fixed bin(31) value(-543);
                              /* restricted row delete               */
 dcl SQL_RC_E544 fixed bin(31) value(-544);
                              /* check contraint violated            */
 dcl SQL_RC_E545 fixed bin(31) value(-545);
                              /* check contraint not satisfied       */
 dcl SQL_RC_E546 fixed bin(31) value(-546);
                              /* check contraint invalid             */
 dcl SQL_RC_E548 fixed bin(31) value(-548);
                              /* check contraint invalid             */
 dcl SQL_RC_E549  fixed bin(31) value(-549);
                              /* restricted stmt used with           */
                              /* DYNAMICRULES BIND pkg               */
 dcl SQL_RC_E551 fixed bin(31) value(-551);
                              /* authorization error w/obj insert    */
 dcl SQL_RC_E552 fixed bin(31) value(-552);
                              /* auth error w/o obj ins              */
 dcl SQL_RC_E553 fixed bin(31) value(-553);
                              /* SYSIBM qualifier                    */
 dcl SQL_RC_E554 fixed bin(31) value(-554);
                              /* cannot grant privilege to self      */
 dcl SQL_RC_E555 fixed bin(31) value(-555);
                              /* cannot revoke privilege from self   */
 dcl SQL_RC_E556 fixed bin(31) value(-556);
                              /* revoke stmt denied--priv not held   */
 dcl SQL_RC_E557 fixed bin(31) value(-557);
                              /* invalid combination of privileges   */
 dcl SQL_RC_E558 fixed bin(31) value(-558);
                              /* revoke stmt denied--has CONTROL     */
 dcl SQL_RC_E562 fixed bin(31) value(-562);
                              /* privilege not allowed for public    */
 dcl SQL_RC_E567 fixed bin(31) value(-567);
                              /* invalid authorization id            */
 dcl SQL_RC_E569 fixed bin(31) value(-569);
                              /* user/group ambiguity                */
 dcl SQL_RC_E572 fixed bin(31) value(-572);
                              /* Inoperative package                 */
 dcl SQL_RC_E573 fixed bin(31) value(-573);
                              /* contraint col not primary key       */
 dcl SQL_RC_E574 fixed bin(31) value(-574);
                              /* DEFAULT invalid for column          */
 dcl SQL_RC_E575 fixed bin(31) value(-575);
                              /* view is inoperative                 */
 dcl SQL_RC_E576 fixed bin(31) value(-576);
                              /* Repetitive alias chain              */
 dcl SQL_RC_E577 fixed bin(31) value(-577);
                              /* function or procedure not defined   */
                              /* as MODIFIES SQL DATA                */
 dcl SQL_RC_E579 fixed bin(31) value(-579);
                              /* function or procedure not defined   */
                              /* as READS SQL DATA                   */
 dcl SQL_RC_E580 fixed bin(31) value(-580);
                              /* Result of CASE expr cannot be NULL  */
 dcl SQL_RC_E581 fixed bin(31) value(-581);
                              /* Data types of CASE expr incompat    */
 dcl SQL_RC_E582 fixed bin(31) value(-582);
                              /* Inv predicate in CASE expr          */
 dcl SQL_RC_E583 fixed bin(31) value(-583);
                              /* Variant or ext action function      */
 dcl SQL_RC_E584 fixed bin(31) value(-584);
                              /* Inv use of NULL or DEFAULT          */
 dcl SQL_RC_E585 fixed bin(31) value(-585);
                              /* Duplicate schema name               */
 dcl SQL_RC_E586 fixed bin(31) value(-586);
                              /* Too many schema names               */
 dcl SQL_RC_E600 fixed bin(31) value(-600);
                              /* udf - dup func signature            */
 dcl SQL_RC_E601 fixed bin(31) value(-601);
                              /* duplicate table/view name           */
 dcl SQL_RC_E602 fixed bin(31) value(-602);
                              /* too many columns in index           */
 dcl SQL_RC_E603 fixed bin(31) value(-603);
                              /* cannot create unique index          */
 dcl SQL_RC_E604 fixed bin(31) value(-604);
                              /* invalid length, precision, scale    */
 dcl SQL_RC_E606 fixed bin(31) value(-606 );
                              /* authid does not own column or       */
                              /* table                               */
 dcl SQL_RC_E607 fixed bin(31) value(-607);
                              /* op not allowed on system tables     */
 dcl SQL_RC_E612 fixed bin(31) value(-612);
                              /* duplicate column name               */
 dcl SQL_RC_E613 fixed bin(31) value(-613);
                              /* primary key too long                */
 dcl SQL_RC_E614 fixed bin(31) value(-614);
                              /* index key too long                  */
 dcl SQL_RC_E620 fixed bin(31) value(-620);
                              /* userid does not have appropriate    */
                              /* dbspaces                            */
 dcl SQL_RC_E623 fixed bin(31) value(-623);
                              /* clustering index already exists     */
                              /* for table                           */
 dcl SQL_RC_E624 fixed bin(31) value(-624);
                              /* table already has primary key       */
 dcl SQL_RC_E628 fixed bin(31) value(-628);
                              /* DDL: multiple/conflict keywords     */
 dcl SQL_RC_E629 fixed bin(31) value(-629);
                              /* foreign key is not nullable         */
 dcl SQL_RC_E631 fixed bin(31) value(-631);
                              /* foreign key is too long             */
 dcl SQL_RC_E632 fixed bin(31) value(-632);
                              /* delete rule restriction             */
 dcl SQL_RC_E633 fixed bin(31) value(-633);
                              /* delete rule is restricted           */
 dcl SQL_RC_E634 fixed bin(31) value(-634);
                              /* delete rule cannot be CASCADE       */
 dcl SQL_RC_E637 fixed bin(31) value(-637);
                              /* dup pk or drop pk clause            */
 dcl SQL_RC_E638 fixed bin(31) value(-638);
                              /* no column definitions               */
 dcl SQL_RC_E644 fixed bin(31) value(-644);
                              /* invalid keyword value               */
 dcl SQL_RC_E647 fixed bin(31) value(-647);
                              /* bufferpool not active               */
 dcl SQL_RC_E648 fixed bin(31) value(-648);
                              /* invalid referential constraint      */
 dcl SQL_RC_E658 fixed bin(31) value(-658);
                              /* object cannot be explicitely        */
                              /* dropped                             */
 dcl SQL_RC_E659 fixed bin(31) value(-659);
                              /* architectural size limit of object  */
 dcl SQL_RC_E667 fixed bin(31) value(-667);
                              /* ref constraint does not hold        */
 dcl SQL_RC_E668 fixed bin(31) value(-668);
                              /* table in CHECK PENDING state        */
 dcl SQL_RC_E669 fixed bin(31) value(-669);
                              /* cannot drop primary key             */
 dcl SQL_RC_E670 fixed bin(31) value(-670);
                              /* row length too large                */
 dcl SQL_RC_E673 fixed bin(31) value(-673);
                              /* primary key not unique              */
 dcl SQL_RC_E680 fixed bin(31) value(-680);
                              /* too many columns for table          */
 dcl SQL_RC_E683 fixed bin(31) value(-683);
                              /* incompatible column constraint      */
 dcl SQL_RC_E696 fixed bin(31) value(-696);
                              /* invalid trigger definition          */
 dcl SQL_RC_E697 fixed bin(31) value(-697);
                              /* invalid correlation name use        */

 dcl SQL_RC_E707 fixed bin(31) value(-707);
                              /* object uses reserved name           */
 dcl SQL_RC_INV_REPL fixed bin(31) value(-713);
                              /* invalid replace value for sp reg    */
 dcl SQL_RC_E723 fixed bin(31) value(-723);
                              /* trigger error                       */
 dcl SQL_RC_E724 fixed bin(31) value(-724);
                              /* max level of cascading              */
 dcl SQL_RC_E727 fixed bin(31) value(-727);
                              /* Invalid implicit PREP or REBIND     */
 dcl SQL_RC_E750 fixed bin(31) value(-750);
                              /* Table cannot be renamed             */
 dcl SQL_RC_E751 fixed bin(31) value(-751);
                              /* Invalid triggered statement         */
 dcl SQL_RC_E752 fixed bin(31) value(-752);
                              /* Inoperative package                 */
 dcl SQL_RC_E797  fixed bin(31) value(-797);
                              /* Invalid triggered statement         */

 dcl SQL_RC_E801 fixed bin(31) value(-801);
                              /* divide by zero                      */
 dcl SQL_RC_E802 fixed bin(31) value(-802);
                              /* arith overflow or divide by zero    */
 dcl SQL_RC_E803 fixed bin(31) value(-803);
                              /* distinct violation                  */
 dcl SQL_RC_E804 fixed bin(31) value(-804);
                              /* bad input parameters                */
 dcl SQL_RC_E805 fixed bin(31) value(-805);
                              /* program not bound                   */
 dcl SQL_RC_E808 fixed bin(31) value(-808);
                              /* inconsistent connect semantics      */
 dcl SQL_RC_E811 fixed bin(31) value(-811);
                              /* more than one row/value             */
 dcl SQL_RC_E818 fixed bin(31) value(-818);
                              /* time stamp conflict                 */
 dcl SQL_RC_E822 fixed bin(31) value(-822);
                              /* invalid address in sqlda            */
 dcl SQL_RC_E840 fixed bin(31) value(-840);
                              /* too many items in list              */
 dcl SQL_RC_E842 fixed bin(31) value(-842);
                              /* connection already exists           */
 dcl SQL_RC_E843 fixed bin(31) value(-843);
                              /* connection does not exist           */
 dcl SQL_RC_E847 fixed bin(31) value(-847);
                              /* can't change connection settings    */
 dcl SQL_RC_E859 fixed bin(31) value(-859);
                              /* TM not for 2 phase commit apps      */
 dcl SQL_RC_E865 fixed bin(31) value(-865);
                              /* inv TM_DATABASE value               */
 dcl SQL_RC_E866 fixed bin(31) value(-866);
                              /* connect redirect failed             */
 dcl SQL_RC_E868 fixed bin(31) value(-868);
                              /* connection already exists           */

 dcl SQL_RC_E901 fixed bin(31) value(-901);
                              /* non-fatal system error              */
 dcl SQL_RC_E902 fixed bin(31) value(-902);
                              /* fatal error                         */
 dcl SQL_RC_E903 fixed bin(31) value(-903);
                              /* commit failed, rollback             */
 dcl SQL_RC_E904 fixed bin(31) value(-904);
                              /* lock timeout                        */
 dcl SQL_RC_E905 fixed bin(31) value(-905);
                              /* resource limit exceeded             */
 dcl SQL_RC_E906 fixed bin(31) value(-906);
                              /* function disabled                   */
 dcl SQL_RC_E908 fixed bin(31) value(-908);
                              /* BIND operation not allowed          */
 dcl SQL_RC_E909 fixed bin(31) value(-909);
                              /* object deleted                      */
 dcl SQL_RC_E910 fixed bin(31) value(-910);
                              /* drop pending                        */
 dcl SQL_RC_E911 fixed bin(31) value(-911);
                              /* deadlock                            */
 dcl SQL_RC_E912 fixed bin(31) value(-912);
                              /* too many lock requests              */
 dcl SQL_RC_E913 fixed bin(31) value(-913);
                              /* dist env rollback                   */
 dcl SQL_RC_E917 fixed bin(31) value(-917);
                              /* remote rebind from DRDA failed      */
 dcl SQL_RC_E918 fixed bin(31) value(-918);
                              /* ROLLBACK required                   */
 dcl SQL_RC_E920 fixed bin(31) value(-920);
                              /* reject DB connection to SA REQ      */
 dcl SQL_RC_E925 fixed bin(31) value(-925);
                              /* COMMIT not allowed                  */
 dcl SQL_RC_E926 fixed bin(31) value(-926);
                              /* ROLLBACK not allowed                */
 dcl SQL_RC_E930 fixed bin(31) value(-930);
                              /* insufficient storage                */
 dcl SQL_RC_INODE fixed bin(31) value(-931);
                              /* all inodes used, system limit       */
 dcl SQL_RC_E950 fixed bin(31) value(-950);
                              /* cursors active on dropped object    */
 dcl SQL_RC_E951 fixed bin(31) value(-951);
                              /* table in use - alter disallowed     */
 dcl SQL_RC_E952 fixed bin(31) value(-952);
                              /* user cancel                         */
 dcl SQL_RC_E953 fixed bin(31) value(-953);
                              /* agent heap too small                */
 dcl SQL_RC_E954 fixed bin(31) value(-954);
                              /* application heap too small          */
 dcl SQL_RC_E955 fixed bin(31) value(-955);
                              /* sort heap error                     */
 dcl SQL_RC_E956 fixed bin(31) value(-956);
                              /* database heap too small             */
 dcl SQL_RC_E957 fixed bin(31) value(-957);
                              /* requestor comm heap too small       */
 dcl SQL_RC_E958 fixed bin(31) value(-958);
                              /* max number of files open            */
 dcl SQL_RC_E959 fixed bin(31) value(-959);
                              /* server comm heap too small          */
 dcl SQL_RC_E960 fixed bin(31) value(-960);
                              /* max nbr of files in database        */
 dcl SQL_RC_E961 fixed bin(31) value(-961);
                              /* rqstr remote svcs heap too small    */
 dcl SQL_RC_E962 fixed bin(31) value(-962);
                              /* svr remote svcs heap too small      */
 dcl SQL_RC_E964 fixed bin(31) value(-964);
                              /* log file full                       */
 dcl SQL_RC_E966 fixed bin(31) value(-966);
                              /* error opening sqlcode mapping file  */
 dcl SQL_RC_E967 fixed bin(31) value(-967);
                              /* format error in sqlcode map file    */
 dcl SQL_RC_E968 fixed bin(31) value(-968);
                              /* disk full                           */
 dcl SQL_RC_E969 fixed bin(31) value(-969);
                              /* unknown sql error another product   */
 dcl SQL_RC_E970 fixed bin(31) value(-970);
                              /* read-only file                      */
 dcl SQL_RC_E972_DB2AIX fixed bin(31) value(-10019);
                              /* incorrect diskette                  */
 dcl SQL_RC_E972_DB2OS2 fixed bin(31) value(-972);
                              /* incorrect diskette                  */
 dcl SQL_RC_E972 fixed bin(31) value(SQL_RC_E972_DB2OS2);
                              /* incorrect diskette                  */
 dcl SQL_RC_E973 fixed bin(31) value(-973);
                              /* out of memory error                 */
 dcl SQL_RC_W973 fixed bin(31) value(973);
                              /* out of memory warning               */
 dcl SQL_RC_E974_DB2AIX fixed bin(31) value(-10019);
                              /* drive locked                        */
 dcl SQL_RC_E974_DB2OS2 fixed bin(31) value(-974);
                              /* drive locked                        */
 dcl SQL_RC_E974 fixed bin(31) value(SQL_RC_E974_DB2OS2);
                              /* drive locked                        */
 dcl SQL_RC_QBACK fixed bin(31) value(-975);
                              /* quiesce backup                      */
 dcl SQL_RC_E976_DB2AIX fixed bin(31) value(-10019);
                              /* diskette door open                  */
 dcl SQL_RC_E976_DB2OS2 fixed bin(31) value(-976);
                              /* diskette door open                  */
 dcl SQL_RC_E976 fixed bin(31) value(SQL_RC_E976_DB2OS2);
                             /* diskette door open                   */
 dcl SQL_RC_E977 fixed bin(31) value(-977);
                              /* unknown commit state                */
 dcl SQL_RC_E978_DB2AIX fixed bin(31) value(-10019);
                              /* diskette write-protected            */
 dcl SQL_RC_E978_DB2OS2 fixed bin(31) value(-978);
                              /* diskette write-protected            */
 dcl SQL_RC_E978 fixed bin(31) value(SQL_RC_E978_DB2OS2);
                              /* diskette write-protected            */

 dcl SQL_RC_E979 fixed bin(31) value(-979);
                              /* commit failed with SYNCPOINT NONE   */
 dcl SQL_RC_E980 fixed bin(31) value(-980);
                              /* disk error                          */
 dcl SQL_RC_E982 fixed bin(31) value(-982);
                              /* disk error on temp file             */
 dcl SQL_RC_E984 fixed bin(31) value(-984);
                              /* unsuccessful commit or rollback     */
 dcl SQL_RC_E985 fixed bin(31) value(-985);
                              /* file error - catalog file bad       */
 dcl SQL_RC_E986 fixed bin(31) value(-986);
                              /* file error - file renamed           */
 dcl SQL_RC_E987 fixed bin(31) value(-987);
                              /* application shared memory cannot    */
                              /* be allocated                        */
 dcl SQL_RC_E988 fixed bin(31) value(-988);
                              /* app ctl heap out of memory          */
 dcl SQL_RC_E990 fixed bin(31) value(-990);
                              /* index structure limit error         */
 dcl SQL_RC_E992 fixed bin(31) value(-992);
                              /* release number incompatible         */
 dcl SQL_RC_E994 fixed bin(31) value(-994);
                              /* reserved                            */
 dcl SQL_RC_E996 fixed bin(31) value(-996);
                              /* error freeing pages in DMS          */
                              /* tablespace                          */
 dcl SQL_RC_E998 fixed bin(31) value(-998);
                              /* General XA error                    */

 dcl SQL_RC_E1007 fixed bin(31) value(-1007);
                              /* error finding pages in DMS          */
                              /* tablespace                          */
 dcl SQL_RC_E1008 fixed bin(31) value(-1008);
                              /* invalid tablespace id               */
 dcl SQL_RC_E1139 fixed bin(31) value(-1139);
                              /* table space maximum size exceeded   */
 dcl SQL_RC_E1163 fixed bin(31) value(-1163);
                              /* table cannot be enabled for data    */
                              /* capture                             */
 dcl SQL_RC_E1180 fixed bin(31) value(-1180);
                              /* UDF caused an OLE error             */
 dcl SQL_RC_E1181 fixed bin(31) value(-1181);
                              /* UDF raised an exception             */
 dcl SQL_RC_E1182 fixed bin(31) value(-1182);
                              /* UDF cannot initialize source        */
                              /* object of OLE DB                    */
 dcl SQL_RC_E1183 fixed bin(31) value(-1183);
                              /* UDF received OLE DB error           */
 dcl SQL_RC_E1184 fixed bin(31) value(-1184);
                              /* EXPLAIN table(s) created with       */
                              /* earlier EXPLAIN.DDL                 */

 dcl SQL_RC_E1216 fixed bin(31) value(-1216);
                              /* invalid use of graphic data         */
 dcl SQL_RC_E1217 fixed bin(31) value(-1217);
                              /* REAL data type not supported        */
 dcl SQL_RC_E1218 fixed bin(31) value(-1218);
                              /* no bufferpool pages available       */
 dcl SQL_RC_E1219 fixed bin(31) value(-1219);
                              /* out of private memory               */
 dcl SQL_RC_E1226 fixed bin(31) value(-1226);
                              /* max number of agents started        */
 dcl SQL_RC_E1227 fixed bin(31) value(-1227);
                              /* Updatale cat values inv             */
 dcl SQL_RC_E1229 fixed bin(31) value(-1229);
                              /* System error rollback               */
 dcl SQL_RC_E1233 fixed bin(31) value(-1233);
                              /* Graphic data that is not UCS-2 is   */
                              /* not supported                       */
 dcl SQL_RC_W1244 fixed bin(31) value(1244);
                              /* Disconn at next commit              */
 dcl SQL_RC_E1245 fixed bin(31) value(-1245);
                              /* Max client connects                 */
 dcl SQL_RC_E1247 fixed bin(31) value(-1247);
                              /* XA TM uses syncpoint 2              */
 dcl SQL_RC_E1248 fixed bin(31) value(-1248);
                              /* db not defined with TM              */
 dcl SQL_RC_E1290 fixed bin(31) value(-1290);
                              /* DB2CLIENTCOMM env var inv           */
 dcl SQL_RC_E1291 fixed bin(31) value(-1291);
                              /* direcory services error             */
 dcl SQL_RC_E1293 fixed bin(31) value(-1293);
                              /* global dir error                    */
 dcl SQL_RC_E1294 fixed bin(31) value(-1294);
                              /* global dir path invalid             */
 dcl SQL_RC_E1295 fixed bin(31) value(-1295);
                              /* global dir router invalid           */

 dcl SQL_RC_E1339 fixed bin(31) value(-1339);
                              /* Not Atomic Compound SQL error(s)    */

 dcl SQL_RC_E1419 fixed bin(31) value(-1419);
                              /* package not executable              */
 dcl SQL_RC_E1420 fixed bin(31) value(-1420);
                              /* too many concat operators           */
 dcl SQL_RC_E1421 fixed bin(31) value(-1421);
                              /* MBCS conversion error               */
 dcl SQL_RC_E1422 fixed bin(31) value(-1422);
                              /* Container wrong size                */
 dcl SQL_RC_E1423 fixed bin(31) value(-1423);
                              /* no blobs for dwn lvl cl             */
 dcl SQL_RC_E1424 fixed bin(31) value(-1424);
                              /* too many transition tbles           */

 dcl SQL_RC_E1462 fixed bin(31) value(-1462);
                              /* only valid for sync mgr connection  */

 dcl SQL_RC_E1581 fixed bin(31) value(-1581);
                              /* table cannot be in append mode      */
                              /* with clustering index               */
 dcl SQL_RC_E1582 fixed bin(31) value(-1582);
                              /* pagesize of table space doesn't     */
                              /* match bufferpool                    */
 dcl SQL_RC_E1583 fixed bin(31) value(-1583);
                              /* pagesize not supported              */
 dcl SQL_RC_E1584 fixed bin(31) value(-1584);
                              /* temporary table space cannot be     */
                              /* found                               */
 dcl SQL_RC_E1585 fixed bin(31) value(-1585);
                              /* No temp table space with            */
                              /* sufficient page size                */
 dcl SQL_RC_E1590 fixed bin(31) value(-1590);
                              /* LONG not allowed on devices         */
 dcl SQL_RC_E1591 fixed bin(31) value(-1591);
                              /* ON option of SET INTEGRITY invalid  */
 dcl SQL_RC_E1592 fixed bin(31) value(-1592);
                              /* INCREMENTAL option invalid          */
 dcl SQL_RC_E1593 fixed bin(31) value(-1593);
                              /* REMAIN PENDING option invalid       */
 dcl SQL_RC_E1595 fixed bin(31) value(-1595);
                              /* table integrity cannot be checked   */
 dcl SQL_RC_E1596 fixed bin(31) value(-1596);
                              /* WITH EMPTY TABLE option not         */
                              /* allowed because of dependent        */
                              /* REFRESH IMMEDIATE table             */

 dcl SQL_RC_E1749 fixed bin(31) value(-1749);
                              /* The table is not created with NOT   */
                              /* LOGGED INITIALLY                    */

 dcl SQL_RC_E1750 fixed bin(31) value(-1750);
                              /* foreign keys not allowed for        */
                              /* tables created not logged           */
                              /* initially                           */
 dcl SQL_RC_E1751 fixed bin(31) value(-1751);
                              /* nodegroups must have at least one   */
                              /* node                                */
 dcl SQL_RC_E1752 fixed bin(31) value(-1752);
                              /* tablespace not created in the       */
                              /* correct nodegroup                   */
 dcl SQL_RC_E1753 fixed bin(31) value(-1753);
                              /* a node does not have the complete   */
                              /* temporary tablespaces               */
 dcl SQL_RC_E1754 fixed bin(31) value(-1754);
                              /* all tablespace in CREATE TABLE      */
                              /* must be in the same nodegroup       */
 dcl SQL_RC_E1756 fixed bin(31) value(-1756);
                              /* more than one clause specifies      */
                              /* containers without ON NODES clause  */
 dcl SQL_RC_E1757 fixed bin(31) value(-1757);
                              /* missing USING clause without ON     */
                              /* NODES clause                        */
 dcl SQL_RC_E1760 fixed bin(31) value(-1760);
                              /* missing clause for create stored    */
                              /* procedure                           */
 dcl SQL_RC_E1761 fixed bin(31) value(-1761);
                              /* nodegroup not defined for buffer    */
                              /* pool                                */
 dcl SQL_RC_E1762 fixed bin(31) value(-1762);
                              /* not enough disk space for connect   */

 dcl SQL_RC_E1803 fixed bin(31) value(-1803);
                              /* operation cannot be executed in No  */
                              /* Package Lock mode                   */
 dcl SQL_RC_E1820 fixed bin(31) value(-1820);
                              /* Action on LOB value failed          */
 dcl SQL_RC_E1822 fixed bin(31) value(-1822);
                              /* Unexpected error from data source   */
 dcl SQL_RC_E1823 fixed bin(31) value(-1823);
                              /* No data type mapping exists for     */
                              /* server                              */
 dcl SQL_RC_E1825 fixed bin(31) value(-1825);
                              /* Statement cannot be handled by      */
                              /* Datajoiner                          */
 dcl SQL_RC_E1826 fixed bin(31) value(-1826);
                              /* Invalid value for system catalog    */
                              /* column                              */
 dcl SQL_RC_E1827 fixed bin(31) value(-1827);
                              /* user mapping undefined              */
 dcl SQL_RC_E1828 fixed bin(31) value(-1828);
                              /* server option undefined             */

 dcl SQL_RC_NO_TCPIP fixed bin(31) value(-1468);
                              /* TCPIP not running                   */
 dcl SQL_RC_NODE_INVALID fixed bin(31) value(-1469);
                              /* invalid node                        */
 dcl SQL_RC_DB2NODE_INVALID fixed bin(31) value(-1470);
                              /* DB2NODE env var invalid             */
 dcl SQL_RC_LOG_MISMATCH fixed bin(31) value(-1471);
                              /* nodes out of sync                   */
 dcl SQL_RC_TIMEDIFF_CA fixed bin(31) value(-1472);
                              /* connect fail, system clocks out of  */
                              /* sync                                */
 dcl SQL_RC_TIMEDIFF_CO fixed bin(31) value(-1473);
                              /* commit fail, system clocks out of   */
                              /* sync                                */
 dcl SQL_RC_TIMEDIFF_W fixed bin(31) value(-1474);
                              /* transaction OK, system clocks out   */
                              /* of sync                             */
 dcl SQL_RC_E1476 fixed bin(31) value(-1476);
                              /* rollback on table error             */
 dcl SQL_RC_E1477 fixed bin(31) value(-1477);
                              /* table not accessible                */

 dcl SQL_RC_E1830 fixed bin(31) value(-1830);
                              /* RETURNS clause must be specified    */
                              /* before EXPRESSION AS                */
 dcl SQL_RC_E1831 fixed bin(31) value(-1831);
                              /* Cannot update table stats for       */
                              /* subtable                            */
 dcl SQL_RC_E1832 fixed bin(31) value(-1832);
                              /* data filter function cannot be      */
                              /* LANGUAGE SQL                        */
 dcl SQL_RC_E1881 fixed bin(31) value(-1881);
                              /* option is not valid for this data   */
                              /* source                              */
 dcl SQL_RC_E1882 fixed bin(31) value(-1882);
                              /* option is not valid for this data   */
                              /* source                              */
 dcl SQL_RC_E1883 fixed bin(31) value(-1883);
                              /* Missing option for this data        */
                              /* source                              */
 dcl SQL_RC_E1884 fixed bin(31) value(-1884);
                              /* Option specified more than once     */
 dcl SQL_RC_E1885 fixed bin(31) value(-1885);
                              /* option is already defined           */
 dcl SQL_RC_E1886 fixed bin(31) value(-1886);
                              /* option has not been added           */
 dcl SQL_RC_E3201 fixed bin(31) value(-3201);
                              /* Cannot import replace parent        */

 dcl SQL_RC_E3260 fixed bin(31) value(-3260);
                              /* Unexpected LDAP error               */
 dcl SQL_RC_E3261 fixed bin(31) value(-3261);
                              /* Missing required parameters         */
 dcl SQL_RC_E3262 fixed bin(31) value(-3262);
                              /* The TCP/IP service name is not      */
                              /* valid                               */
 dcl SQL_RC_E3263 fixed bin(31) value(-3263);
                              /* The protocol type is not supported  */
 dcl SQL_RC_E3264 fixed bin(31) value(-3264);
                              /* The DB2 server has not been         */
                              /* registered in LDAP                  */
 dcl SQL_RC_E3265 fixed bin(31) value(-3265);
                              /* LDAP authentication error           */
 dcl SQL_RC_E3267 fixed bin(31) value(-3267);
                              /* Insufficient LDAP authority         */
 dcl SQL_RC_E3268 fixed bin(31) value(-3268);
                              /* LDAP schema is not compatible       */
 dcl SQL_RC_E3269 fixed bin(31) value(-3269);
                              /* The LDAP server is not available    */
 dcl SQL_RC_E3270 fixed bin(31) value(-3270);
                              /* LDAP user's DN is invalid           */
 dcl SQL_RC_E3271 fixed bin(31) value(-3271);
                              /* LDAP user's DN or password is not   */
                              /* configured                          */
 dcl SQL_RC_E3272 fixed bin(31) value(-3272);
                              /* The LDAP node was not found         */
 dcl SQL_RC_E3273 fixed bin(31) value(-3273);
                              /* The LDAP database was not found     */
 dcl SQL_RC_E3276 fixed bin(31) value(-3276);
                              /* Unable to obtain the LDAP naming    */
                              /* context                             */
 dcl SQL_RC_E3277 fixed bin(31) value(-3277);
                              /* The database already exists         */
 dcl SQL_RC_E3278 fixed bin(31) value(-3278);
                              /* The node already exists             */
 dcl SQL_RC_E3279 fixed bin(31) value(-3279);
                              /* LDAP is disabled                    */
 dcl SQL_RC_E3280 fixed bin(31) value(-3280);
                              /* The node type is not supported      */
 dcl SQL_RC_E3281 fixed bin(31) value(-3281);
                              /* The operating system type is        */
                              /* invalid                             */

 dcl SQL_RC_E3600 fixed bin(31) value(-3600);
                              /* Table not in check pend state       */
 dcl SQL_RC_W3601 fixed bin(31) value(3601);
                              /* Auto Check pending state            */
 dcl SQL_RC_W3602 fixed bin(31) value(3602);
                              /* Constraint violation moved          */
 dcl SQL_RC_E3603 fixed bin(31) value(-3603);
                              /* Constraint Violations               */
 dcl SQL_RC_E3604 fixed bin(31) value(-3604);
                              /* Invalid Exception Table             */
 dcl SQL_RC_E3605 fixed bin(31) value(-3605);
                              /* Exception Table same as Check       */
                              /* Table                               */
 dcl SQL_RC_E3606 fixed bin(31) value(-3606);
                              /* # check & exception tables not      */
                              /* match                               */
 dcl SQL_RC_E3608 fixed bin(31) value(-3608);
                              /* Parent in Check Pending state       */

 dcl SQL_RC_E4300 fixed bin(31) value(-4300);
                              /* Java support not installed          */
 dcl SQL_RC_E4301 fixed bin(31) value(-4301);
                              /* Java startup, comm, shutdown        */
                              /* failed                              */
 dcl SQL_RC_E4302 fixed bin(31) value(-4302);
                              /* Java unclassified exception         */
 dcl SQL_RC_E4303 fixed bin(31) value(-4303);
                              /* Java could not parse class!method   */
 dcl SQL_RC_E4304 fixed bin(31) value(-4304);
                              /* Java could not instantiate class    */
 dcl SQL_RC_E4305 fixed bin(31) value(-4305);
                              /* Java internal error code            */
 dcl SQL_RC_E4306 fixed bin(31) value(-4306);
                              /* Java cannot call method             */
 dcl SQL_RC_E4307 fixed bin(31) value(-4307);
                              /* Java method call problems           */

 dcl SQL_RC_E5051 fixed bin(31) value(-5051);
                              /* Invalid qualifier specified in      */
                              /* CREATE SCHEMA                       */

 dcl SQL_RC_E6040 fixed bin(31) value(-6040);
                              /* Insufficient FCM buffers            */
 dcl SQL_RC_E6041 fixed bin(31) value(-6041);
                              /* Insufficient FCM connection         */
                              /* entries                             */
 dcl SQL_RC_E6042 fixed bin(31) value(-6042);
                              /* Insufficient FCM message anchors    */
 dcl SQL_RC_E6043 fixed bin(31) value(-6043);
                              /* Insufficient FCM request blocks     */
 dcl SQL_RC_E6071 fixed bin(31) value(-6071);
                              /* New node requires stop and start    */

 dcl SQL_RC_E8014 fixed bin(31) value(-8014);
                              /* not licensed for TCP/IP             */
                              /* connections.                        */
 dcl SQL_RC_E8015 fixed bin(31) value(-8015);
                              /* not licensed for multiple database  */
                              /* updates per transaction             */

 dcl SQL_RC_E8100 fixed bin(31) value(-8100);
                              /* Page number too high                */
 dcl SQL_RC_E8101 fixed bin(31) value(-8101);
                              /* Segment in error                    */


 dcl SQL_RC_E20005 fixed bin(31) value(-20005);
                              /* internal object limit exceeded      */
 dcl SQL_RC_E20010 fixed bin(31) value(-20010);
                              /* mutation methd not allowed          */
 dcl SQL_RC_E20011 fixed bin(31) value(-20011);
                              /* transform for data type already     */
                              /* exists                              */
 dcl SQL_RC_E20012 fixed bin(31) value(-20012);
                              /* no transforms were dropped          */
 dcl SQL_RC_E20013 fixed bin(31) value(-20013);
                              /* Invalid object for supertype        */
 dcl SQL_RC_E20014 fixed bin(31) value(-20014);
                              /* function cannot be used as          */
                              /* transform function                  */
 dcl SQL_RC_E20015 fixed bin(31) value(-20015);
                              /* transform for type not defined      */
 dcl SQL_RC_E20016 fixed bin(31) value(-20016);
                              /* column length value too small       */
 dcl SQL_RC_E20017 fixed bin(31) value(-20017);
                              /* Hierarchy too deep                  */
 dcl SQL_RC_E20018 fixed bin(31) value(-20018);
                              /* row function must return at most    */
                              /* one row                             */
 dcl SQL_RC_E20019 fixed bin(31) value(-20019);
                              /* result type cannot be assigned to   */
                              /* RETURN type                         */
 dcl SQL_RC_E20020 fixed bin(31) value(-20020);
                              /* Invalid operation for typed table   */
 dcl SQL_RC_E20021 fixed bin(31) value(-20021);
                              /* Cannot change inherited column      */
 dcl SQL_RC_E20022 fixed bin(31) value(-20022);
                              /* SCOPE already defined               */
 dcl SQL_RC_E20023 fixed bin(31) value(-20023);
                              /* SCOPE not allowed for parameter     */
 dcl SQL_RC_E20024 fixed bin(31) value(-20024);
                              /* SCOPE not valid for reference       */
 dcl SQL_RC_E20025 fixed bin(31) value(-20025);
                              /* Incorrect SCOPE for RETURNS         */
 dcl SQL_RC_E20026 fixed bin(31) value(-20026);
                              /* Type is not a structured type       */
 dcl SQL_RC_E20027 fixed bin(31) value(-20027);
                              /* Subtable already exists of type     */
 dcl SQL_RC_E20028 fixed bin(31) value(-20028);
                              /* Subtable schema incorrect           */
 dcl SQL_RC_E20029 fixed bin(31) value(-20029);
                              /* Invalid operation for subtable      */
 dcl SQL_RC_E20030 fixed bin(31) value(-20030);
                              /* Attrs cannot be altered when in     */
                              /* use                                 */
 dcl SQL_RC_E20031 fixed bin(31) value(-20031);
                              /* Invalid object for subtable         */
 dcl SQL_RC_E20032 fixed bin(31) value(-20032);
                              /* Invalid index columns for subtable  */
 dcl SQL_RC_E20033 fixed bin(31) value(-20033);
                              /* Unscoped reference                  */
 dcl SQL_RC_E20034 fixed bin(31) value(-20034);
                              /* Invalid TYPE predicate              */
 dcl SQL_RC_E20035 fixed bin(31) value(-20035);
                              /* Invalid path expression             */
 dcl SQL_RC_E20036 fixed bin(31) value(-20036);
                              /* Path includes OID column            */
 dcl SQL_RC_E20037 fixed bin(31) value(-20037);
                              /* REF IS column must be defined       */
 dcl SQL_RC_E20038 fixed bin(31) value(-20038);
                              /* ASC or DESC cannot be specified     */
 dcl SQL_RC_E20039 fixed bin(31) value(-20039);
                              /* definition of index does not match  */
                              /* extension                           */
 dcl SQL_RC_E20040 fixed bin(31) value(-20040);
                              /* number or type of result            */
                              /* inconsistent                        */
 dcl SQL_RC_E20041 fixed bin(31) value(-20041);
                              /* number or type of parameters does   */
                              /* not match                           */
 dcl SQL_RC_E20042 fixed bin(31) value(-20042);
                              /* maximum allowable parameters        */
                              /* exceeded                            */
 dcl SQL_RC_E20043 fixed bin(31) value(-20043);
                              /* argument for function is invalid    */
 dcl SQL_RC_E20044 fixed bin(31) value(-20044);
                              /* function not supported in CREATE    */
                              /* INDEX EXTENSION                     */
 dcl SQL_RC_E20045 fixed bin(31) value(-20045);
                              /* datatype of instance parameter      */
                              /* invalid                             */
 dcl SQL_RC_E20047 fixed bin(31) value(-20047);
                              /* search method not found             */
 dcl SQL_RC_E20048 fixed bin(31) value(-20048);
                              /* search method argument mismatch     */
 dcl SQL_RC_E20049 fixed bin(31) value(-20049);
                              /* operand type mismatch               */
 dcl SQL_RC_E20050 fixed bin(31) value(-20050);
                              /* search target or search argument    */
                              /* mismatch                            */
 dcl SQL_RC_E20051 fixed bin(31) value(-20051);
                              /* argument cannot be both search      */
                              /* target and search argument          */
 dcl SQL_RC_E20052 fixed bin(31) value(-20052);
                              /* Cannot update OID column            */
 dcl SQL_RC_E20053 fixed bin(31) value(-20053);
                              /* Fullselect in typed view is not     */
                              /* valid                               */
 dcl SQL_RC_E20054 fixed bin(31) value(-20054);
                              /* Invalid state for operation         */
 dcl SQL_RC_E20055 fixed bin(31) value(-20055);
                              /* Result column data type not         */
                              /* compatible                          */
 dcl SQL_RC_E20056 fixed bin(31) value(-20056);
                              /* Processing error on file server     */
 dcl SQL_RC_E20057 fixed bin(31) value(-20057);
                              /* column cannot be defined as read    */
                              /* only                                */
 dcl SQL_RC_E20058 fixed bin(31) value(-20058);
                              /* fullselect for summary table is     */
                              /* invalid                             */
 dcl SQL_RC_E20075 fixed bin(31) value(-20075);
                              /* index not created, column length    */
                              /* too long                            */
 dcl SQL_RC_E20076 fixed bin(31) value(-20076);
                              /* instance not enabled for operation  */
 dcl SQL_RC_E20077 fixed bin(31) value(-20077);
                              /* Cannot construct object with        */
                              /* Datalink or Reference type          */
                              /* attributes                          */
 dcl SQL_RC_E20078 fixed bin(31) value(-20078);
                              /* operation cannot be applied to      */
                              /* object                              */
 dcl SQL_RC_E20108 fixed bin(31) value(-20108);
                              /* result set contains unsupported     */
                              /* data type                           */
 dcl SQL_RC_E20200 fixed bin(31) value(-20200);
                              /* URL not found                       */
 dcl SQL_RC_E20201 fixed bin(31) value(-20201);
                              /* jar name invalid                    */
 dcl SQL_RC_E20202 fixed bin(31) value(-20202);
                              /* class is in use                     */
 dcl SQL_RC_E20203 fixed bin(31) value(-20203);
                              /* Java method has invalid signature   */
 dcl SQL_RC_E20204 fixed bin(31) value(-20204);
                              /* function unable to map to single    */
                              /* method                              */
 dcl SQL_RC_E20205 fixed bin(31) value(-20205);
                              /* null value not allowed in argument  */
 dcl SQL_RC_E20207 fixed bin(31) value(-20207);
                              /* unsupported deployment descriptor   */

 dcl SQL_RC_E30000 fixed bin(31) value(-30000);
                              /* Distribution protocol error, no     */
                              /* disconnect                          */
 dcl SQL_RC_E30002 fixed bin(31) value(-30002);
                              /* statement cannot be executed due    */
                              /* to prior condition                  */
 dcl SQL_RC_E30020 fixed bin(31) value(-30020);
                              /* Distribution protocol error,        */
                              /* disconnect                          */
 dcl SQL_RC_E30021 fixed bin(31) value(-30021);
                              /* Distribution compatibility error    */
 dcl SQL_RC_E30040 fixed bin(31) value(-30040);
                              /* Distribution memory allocation err  */
 dcl SQL_RC_E30041 fixed bin(31) value(-30041);
                              /* Distribution memory allocation      */
                              /* err, disconnect                     */
 dcl SQL_RC_E30050 fixed bin(31) value(-30050);
                              /* Invalid command while bind in prog  */
 dcl SQL_RC_E30051 fixed bin(31) value(-30051);
                              /* Bind not active                     */
 dcl SQL_RC_E30053 fixed bin(31) value(-30053);
                              /* Bind Owner authorization failure    */
 dcl SQL_RC_E30060 fixed bin(31) value(-30060);
                              /* RDB authorization failure           */
 dcl SQL_RC_E30061 fixed bin(31) value(-30061);
                              /* RDB not found                       */
 dcl SQL_RC_E30070 fixed bin(31) value(-30070);
                              /* Distribution command error          */
 dcl SQL_RC_E30071 fixed bin(31) value(-30071);
                              /* Distribution object error           */
 dcl SQL_RC_E30072 fixed bin(31) value(-30072);
                              /* Distribution parameter error        */
 dcl SQL_RC_E30073 fixed bin(31) value(-30073);
                              /* Distribution parameter value error  */
 dcl SQL_RC_E30074 fixed bin(31) value(-30074);
                              /* Distribution reply error            */
 dcl SQL_RC_E30080 fixed bin(31) value(-30080);
                              /* Communication error                 */
 dcl SQL_RC_E30081 fixed bin(31) value(-30081);
                              /* Communication error                 */
 dcl SQL_RC_E30082 fixed bin(31) value(-30082);
                              /* Security error                      */
 dcl SQL_RC_E30083 fixed bin(31) value(-30083);
                              /* Attempt to change password failed   */
 dcl SQL_RC_E30090 fixed bin(31) value(-30090);
                              /* Remote operation invalid            */
 dcl SQL_RC_W30101 fixed bin(31) value(30101);
                              /* Rebind options ignored              */
 dcl SQL_RC_W30102 fixed bin(31) value(30102);
                              /* Connection disabled                 */

 /* Database Monitor SQLCODES */

 dcl SQLM_RC_BAD_PATH      fixed bin(31) value(-1612);
                              /* bad path specified for event        */
                              /* monitor                             */
 dcl SQLM_RC_BAD_OPTION    fixed bin(31) value(-1613);
                              /* bad OPTION specified for event      */
                              /* monitor                             */
 dcl SQLM_RC_IO_ERROR      fixed bin(31) value(-1614);
                              /* I/O error on activating event       */
                              /* monitor                             */
 dcl SQLM_RC_NOT_ACTIVATED fixed bin(31) value(-1616);
                              /* Event monitor not activated         */
 dcl SQLM_RC_EVMON_FULL    fixed bin(31) value(-1617);
                              /* Event monitor data files are full   */
 dcl SQLM_RC_PATH_IN_USE   fixed bin(31) value(-1618);
                              /* Event monitor path is in use        */
 dcl SQLM_RC_CANNOT_DROP   fixed bin(31) value(-1619);
                              /* Cannot drop active event monitor    */
 dcl SQLM_RC_MUST_COMMIT   fixed bin(31) value(-1621);
                              /* Must commit to use event monitor    */
 dcl SQLM_RC_BAD_STATE     fixed bin(31) value(-1622);
                              /* Invalid state                       */

 %end; /* SQL_H_SQLCODES */
